<?php
class FaqCategoriesController extends AppController {

	var $name = 'FaqCategories';
        var $uses 		= array('FaqCategory','Faq');
	var $helpers 	= array('Html','Form','Javascript','Ajax','Time');
	var $paginate	= array('limit'=> '10', 'page' => '1', 'order'=>array('FaqCategory.id'=>'desc'));
	var $components = array ('RequestHandler','Common');
        var $layout='admin';
        function admin_index() {

            $this->layout   =   "admin";
            $condition=array();
            $separator=array();
            $urlSeparator=array();
            $msgString  =   "";
            if(!empty($this->data)){  
                   	if(isset($this->data['FaqCategory']['search']) && $this->data['FaqCategory']['search']!=''){
				$categoryName=trim($this->data['FaqCategory']['search']);
			}


			if(isset($this->data['FaqCategory']['action'])){
				$idList=$this->data['FaqCategory']['idList']; 
				if($idList){
					if($this->data['FaqCategory']['action']=="activate"){
						$cnd=array("FaqCategory.id IN ($idList) ");
						$this->FaqCategory->updateAll(array('FaqCategory.status' =>"'1'"),$cnd);
					}elseif($this->data['FaqCategory']['action']=="deactivate"){
						$cnd=array("FaqCategory.id IN ($idList) ");
						$this->FaqCategory->updateAll(array('FaqCategory.status' =>"'0'"),$cnd);
					}elseif($this->data['FaqCategory']['action']=="delete"){
						$cnd=array("FaqCategory.id IN ($idList) ");
						$this->FaqCategory->deleteAll($cnd);
					}
				}
			}
		}
                elseif(!empty($this->params)){
			if(isset($this->params['named']['search']) && $this->params['named']['search']!=''){
				$categoryName=trim($this->params['named']['search']);
			}

                }
                        if(isset($categoryName) && $categoryName!=''){
                                $separator[]='search:'.$categoryName;
                                $condition[] =" (FaqCategory.category_name like '%".$categoryName."%' ) ";
                        }


            	$separator=implode("/",$separator);

		if(!empty($this->passedArgs)){
			if(isset($this->passedArgs["page"])){
				$urlSeparator[]='page:'.$this->passedArgs["page"];
			}
			if(isset($this->passedArgs["sort"])){
				$urlSeparator[]='sort:'.$this->passedArgs["sort"];
			}
			if(isset($this->passedArgs["direction"])){
				$urlSeparator[]='direction:'.$this->passedArgs["direction"];
			}
		}

		$urlSeparator=implode("/",$urlSeparator);
		$this->set('separator',$separator);
		$this->set('urlSeparator',$urlSeparator);
		$this->set('faq_categories', $this->paginate('FaqCategory',$condition));
		if($this->RequestHandler->isAjax()) {
			$this->layout='';
			$this->viewPath = 'elements'.DS.'admin/faq_categories/';
			$this->render('index');
		}
	}

        function admin_addFaqCategory() {
                $this->layout   =   "admin";
                $msgString  =   "";
                $forumCat = $this->FaqCategory->find('list',array("fields"=>array("FaqCategory.id"),"conditions"=>"FaqCategory.status='1'"));
                $this->set('forumCat',$forumCat);
                if($this->data){
                       
                            if(empty($this->data["FaqCategory"]["category_name"])){
                                    $msgString .="- Faq Category is required field.<br>";
                            }
                          

                           $value = $this->data['FaqCategory']['category_name'];
                           $catName_conditions["FaqCategory.category_name"]=$this->data["FaqCategory"]["category_name"];
                          
                            if(!$this->FaqCategory->isRecordUnique($catName_conditions))
                                         {
                                                $msgString .="- Faq Category already exists.<br>";
                                         }
                                       
                            if(isset($msgString) && $msgString!=''){
                                    $this->Session->write('message',$msgString);
                            }else{

                                $newurl=$this->Common->convertTitle($this->data["FaqCategory"]["category_name"]);
                                $conditions["FaqCategory.category_name"]=$newurl;
                                if($this->FaqCategory->isRecordUnique($conditions))
                                {
                                    $this->data["FaqCategory"]["title_id"] = $newurl;
                                }else{
                                    $this->data["FaqCategory"]["title_id"] = $newurl;
                                }
                                            $this->data['FaqCategory']['status'] = '1';
                                            if($this->FaqCategory->save($this->data)){
                                                //Print_r($this->data);
                                                
                                                    $categoryId=$this->data->category_id;
//exit;
                                                    $this->Session->write('message','Faqs category saved successfully.');
                                                    $this->redirect('/admin/faq_categories/index');
                                            }
                            }

            }
            // }
	}

        function admin_editFaqcategory($id=null) {
                              
                      $this->layout   =   "admin";
                      $msgString    ="";
                      $forumCat = $this->FaqCategory->find('list',array("fields"=>array("FaqCategory.id"),"conditions"=>"FaqCategory.status='1'"));
                      $this->set('forumCat',$forumCat);
                      if($this->data){ 
                         if($this->data["FaqCategory"]["category_name"]==""){
				$msgString .="- Faq Category is required field.<br>";
			}
			
			if(isset($msgString) && $msgString!=''){
				$this->Session->write('message',$msgString);

			}else{
                                $newurl=$this->Common->convertTitle($this->data["FaqCategory"]["category_name"]);
                                $conditions["FaqCategory.category_name"]=$newurl;
                                if($this->FaqCategory->isRecordUnique($conditions))
                                {
                                    $this->data["FaqCategory"]["title_id"] = $newurl;
                                }else{
                                    $this->data["FaqCategory"]["title_id"] = $newurl;
                                }
                                        $this->data['FaqCategory']['status'] = 1;
                                        if($this->FaqCategory->save($this->data)){
						$categoryId=$this->FaqCategory->id;
						$this->Session->write('message','Faqs category saved successfully.');
						$this->redirect('/admin/faq_categories/index');
					}
			}


                      }
                     elseif($id>0){
                            $this->FaqCategory->id = $id;
                            $this->data =  $this->FaqCategory->read();
                            $customerId=$this->data["FaqCategory"]["id"];
                            $this->set("faq",$customerId);
                     }
        
        }

        function admin_deleteFaqCategory($id=NULL){
		if($id>0){
			$this->FaqCategory->delete($id);
			$this->viewPath = 'elements'.DS.'admin';
			$this->render('blank_delete');
		}
             
	}//end of admin_deleteForum

	/*_____________________________________________________________________________
	Function : admin_deactivateForum
	Deactivate a merchant from admin side
	Tables : forum_categories
	�������������������������������������������������������������������������������*/
	function admin_deactivateFaqCategory($id=NULL){
		if($id>0){
			$cnd=array("FaqCategory.id = $id");
			$this->FaqCategory->updateAll(array('FaqCategory.status' =>"'0'"),$cnd);
			$this->set('action','/admin/faq_categories/activateFaqCategory/'.$id);
			$this->set('id',$id);
			$this->set('status',0);
			$this->viewPath = 'elements'.DS.'admin';
			$this->render('update_status');
		}
            

	}//end of admin_deactivateForum

	/*_____________________________________________________________________________
	Function : admin_activateForum
	Activate a merchant from admin side
	Tables : forum_categories
	�������������������������������������������������������������������������������*/
	function admin_activateFaqCategory($id=NULL){
		if($id>0){
			$cnd=array("FaqCategory.id = $id");
			$this->FaqCategory->updateAll(array('FaqCategory.status' =>"'1'"),$cnd);
			$this->set('action','/admin/faq_categories/deactivateFaqCategory/'.$id);
			$this->set('id',$id);
			$this->set('status',1);
			$this->viewPath = 'elements'.DS.'admin';
			$this->render('update_status');
		}
             
	}//end of admin_activateForum
        


//----------------------------------------------------------- END ADMIN FUNCTIONS ---------------------------------------------------//

//----------------------------------------------------------- START CLIENTFUNCTIONS ---------------------------------------------------//
}
