<?php

class ReguserOrdersController extends AppController {

	var $name = 'ReguserOrders';
	var $uses 		= array("User","State","Reference","ReguserOrder","SubscriptionPlan","Configuration");
	var $helpers 	= array('Html','Form','Javascript','Ajax','Time');
	var $paginate	= array('limit'=> '50', 'page' => '1', 'order'=>array('ReguserOrder.id'=>'desc'));
	var $components = array ('RequestHandler',"Logincheck","Common");
	var $layout='admin';

	function beforeFilter(){
                $loggedAdminId = $this->Session->read("adminid");
		if(isset($this->params['admin']) && $this->params['admin'] && !$loggedAdminId){
			$this->redirect("/admin/admins/login");
		}
	}



	/*_____________________________________________________________________________
	Function : index
	Show admin_index page
	Tables : ReguserOrder
	???????????????????????????????????????????????????????????????????????????????*/
	function admin_index($created=null,$toDate=null){
		$this->layout="admin";
		$this->set("expand_menu_links","reguser_orders");
		$condition=array();
		$separator=array();
		$urlSeparator=array();

		if(!empty($this->data)){

			if(isset($this->data['ReguserOrder']['id']) && $this->data['ReguserOrder']['id']!=''){
				$customerName=trim($this->data['ReguserOrder']['id']);
			}


			if(isset($this->data['ReguserOrder']['action'])){
				$idList=$this->data['ReguserOrder']['idList'];
				if($idList){
					if($this->data['ReguserOrder']['action']=="activate"){
						$cnd=array("ReguserOrder.id IN ($idList) ");
						$this->ReguserOrder->updateAll(array('ReguserOrder.status' =>"'1'"),$cnd);
					}elseif($this->data['ReguserOrder']['action']=="deactivate"){
						$cnd=array("ReguserOrder.id IN ($idList) ");
						$this->ReguserOrder->updateAll(array('ReguserOrder.status' =>"'0'"),$cnd);
					}elseif($this->data['ReguserOrder']['action']=="delete"){
						$cnd=array("ReguserOrder.id IN ($idList) ");
						$this->ReguserOrder->deleteAll($cnd);
					}
				}
			}
		}elseif(!empty($this->params)){
			if(isset($this->params['named']['id']) && $this->params['named']['id']!=''){
				$userName=trim($this->params['named']['id']);
			}

		}

		if(isset($userName) && $userName!=''){
			$separator[]='id:'.$userName;
			$condition[] =" (ReguserOrder.id like '%'.$userName.'%') ";
		}

                 if(isset($created) && $created!='' && $created!='null'){
                    $created    =   $created ;
                   }
                    if(isset($toDate) && $toDate!='' && $toDate!='null'){
                    $toDate    =   $toDate ;
                   }
                    elseif(!empty($this->params)){
                                if(isset($this->params['named']['created']) && $this->params['named']['created']!='' && isset($this->params['named']['todate']) && $this->params['named']['todate']!=''){
                                        $created=trim($this->params['named']['created']);
                                        $toDate=trim($this->params['named']['todate']);
                                }
                }
                if(isset($created) && $created!='' && $created!='null'){
			$separator[]='created:'.$created;
                        $separator[]='todate:'.$toDate;
			$condition[]="ReguserOrder.created between '".$created."' and '".$toDate."'";
		}


		$separator=implode("/",$separator);

		if(!empty($this->passedArgs)){
			if(isset($this->passedArgs["page"])){
				$urlSeparator[]='page:'.$this->passedArgs["page"];
			}
			if(isset($this->passedArgs["sort"])){
				$urlSeparator[]='sort:'.$this->passedArgs["sort"];
			}
			if(isset($this->passedArgs["direction"])){
				$urlSeparator[]='direction:'.$this->passedArgs["direction"];
			}
		}

		$urlSeparator=implode("/",$urlSeparator);

		$this->set('separator',$separator);
		$this->set('urlSeparator',$urlSeparator);

                $condition[]="ReguserOrder.payment_status = 'Confirm'";
                $this->set('subscribers', $this->paginate('ReguserOrder',$condition));
                
		if($this->RequestHandler->isAjax()) {
			$this->layout='';
			$this->viewPath = 'elements'.DS.'admin/reguser_orders/';
			$this->render('index');
		}
	}// end of function index

              

        function admin_deletesubscribers($id=NULL){
        if($id>0){
        $this->ReguserOrder->delete($id);
        $this->viewPath = 'elements'.DS.'admin';
        $this->Session->write('message','Subscriber details deleted successfully.');
        $this->render('blank_delete');
        $this->redirect('/admin/reguser_orders/index');
        }
        }//end of admin_deleteUser

        function admin_deactivateSubscriber($id=NULL){
        if($id>0){
        $this->ReguserOrder->recursive = -1;
        $cnd=array("ReguserOrder.id = $id");
        $this->ReguserOrder->updateAll(array('ReguserOrder.status' =>"'0'"),$cnd);
        $this->Session->write('message','Subscriber Deactivated successfully.');
        $this->set('action','/admin/reguser_orders/activateSubscriber/'.$id);
        $this->set('id',$id);
        $this->set('status',0);
        $this->viewPath = 'elements'.DS.'admin';
        $this->render('update_status');
        $this->redirect('/admin/reguser_orders/index');
        }

        }

        function admin_activateSubscriber($id=NULL){
		if($id>0){
                    $this->ReguserOrder->recursive = -1;
			$cnd=array("ReguserOrder.id = $id");
			$this->ReguserOrder->updateAll(array('ReguserOrder.status' =>"'1'"),$cnd);
                        $this->Session->write('message','Subscriber Activated successfully.');
			$this->set('action','/admin/reguser_orders/deactivateSubscriber/'.$id);
			$this->set('id',$id);
			$this->set('status',1);
			$this->viewPath = 'elements'.DS.'admin';
			$this->render('update_status');
			$this->redirect('/admin/reguser_orders/index');
		}
	}//end of admin_activateCustomer        



              function admin_monthlyInvoice($planid=null,$userid=null){

                $this->layout="admin";

                    $query_monthinvoice = "SELECT user_id, plan_id, purchased_plan_id, SUM(total_weight), SUM(overage_amount), SUM(shipping_charge) FROM generate_invoices WHERE plan_id = '".$planid."' AND user_id = '".$userid."' GROUP BY purchased_plan_id,user_id";
                    $result_monthinvoice = mysql_query($query_monthinvoice) or die(mysql_error());
                    $row_monthinvoice = mysql_fetch_assoc($result_monthinvoice);

                    $this->set('row_monthinvoice',$row_monthinvoice);

             }  //end function admin_monthlyInvoice()



             function admin_viewPlan($id=NULL){
                    $this->layout="admin";
                    $this->ReguserOrder->id = $id;
                    $planDetails = $this->ReguserOrder->read();
                    //echo '<pre>';print_r($planDetails);exit;
                    $this->set("planDetails",$planDetails);
                } //end function admin_viewOrder()


/* admin functions end here....................******************************************************************************* */





                /*client function starts hers
                 * by deepshikha
                 */
                
        function orders($planid = null){		
			$this->layout="client";
            //$this->layout="client_inner";
            $this->userLoginCheck();

            $this->set('planid',$planid);

            $plandetail = $this->SubscriptionPlan->find("first",array("conditions"=>"SubscriptionPlan.id = '".$planid."'"));
            $this->set('plandetail',$plandetail);

            $buyerInfo= $this->User->find("first",array("conditions"=>"User.id='".$_SESSION['user_id']."'"));
            $this->set('buyerInfo',$buyerInfo);

            $this->data['ReguserOrder']['user_id'] = $_SESSION['user_id'];
            $this->data['ReguserOrder']['plan_id'] = $planid;
            $this->data['ReguserOrder']['plan_charge'] = $plandetail['SubscriptionPlan']['plan_charge'];
            $this->data['ReguserOrder']['minimum_usage_per_bag'] = $plandetail['SubscriptionPlan']['minimum_usage_per_bag'];
            $this->data['ReguserOrder']['total_usage'] = $plandetail['SubscriptionPlan']['total_usage'];
            $this->data['ReguserOrder']['used_usage'] = '0';
            $this->data['ReguserOrder']['payment_status'] = 'Pending';
            $this->data['ReguserOrder']['status'] = '0';

            $this->ReguserOrder->save($this->data);
            $orderid=$this->ReguserOrder->id;
            $this->set('orderid',$orderid);

        }


       function purchaseplan(){
            
            $this->layout="client_inner";
            $this->userLoginCheck();

            $userInfo= $this->User->find("first",array("conditions"=>"User.id='".$this->Session->read("user_id")."'"));
            $this->set('userInfo',$userInfo);

            $plandetail = $this->ReguserOrder->find("first",array("conditions"=>array("ReguserOrder.id = '".$_POST['orderid']."'"),null));
                        
                if($_POST['action']=='1'){
                if($_POST['aggree_terms']=="1"){
                if($_POST){
                    
                      $msgString="";                        

                               if(empty($_POST['billing_address'])){
                                   $msgString.="Please Enter Street Address.<br /> ";
                               }
                               if(empty($_POST['city'])){
                                   $msgString.="Please Enter City. <br />";
                               }
                               if(empty($_POST['state'])){
                                   $msgString.="Please Enter State. <br />";
                               }
                               if(empty($_POST['zipcode'])){
                                   $msgString.="Please Enter Zipcode. <br />";
                               }
                               if(empty($_POST['firstname'])){
                                   $msgString.="Please Enter First Name. <br />";
                               }
                               if(empty($_POST['lastname'])){
                                   $msgString.="Please Enter Last Name. <br />";
                               }
                               if(empty($_POST['CVN'])){
                                   $msgString.="Please Enter CVN. <br />";
                               }elseif(preg_match("/^[0-9]{3,}$/", $_POST['CVN']) === 0){
                                   $msgString .= "CVN Should be Numeric and 3 or 4 digit.<br>";
                                }

                                $padDateMonth = str_pad($_POST['ExpMon'], 2, '0', STR_PAD_LEFT);
                                if(empty($_POST['ExpYear']) || $_POST['ExpMon']=='13'){
                                    $msgString .= "Card Expiration Month or Year Required.<br>";
                                }elseif((date('Y-m') > $_POST['ExpYear']."-".$padDateMonth) ? true : false){
                                    $msgString .= "Choose Valid Expiration Date.<br>";
                                }
                                    $buyerId    =   $this->Session->read("user_id");
                                    $sessionId  =   $this->Session->read("browser_session_id");


                                   $cardNumber  =  $_POST['CardNumber'];
                                   $cardType  =  $_POST['CardType'];
                                   $cvn    =    $_POST['CVN'];
                                   $returnMsg  =   $this->ReguserOrder->validateCC($cardNumber,$cardType);
                                   $expMonth   =   $_POST['ExpMon'];
                                   $expYear     =$_POST['ExpYear'];
                                   if(isset($returnMsg) && $returnMsg!=""){
                                     $msgString.=  $returnMsg;
                                   }
                                   
                                      if(isset($msgString) && $msgString!=""){
                                          $this->Session->write("message",$msgString);
                                          $this->redirect('/reguser_orders/orders/'.$_POST['planid']);
                                      }else{

                                            $configDetails  =   $this->Configuration->find("first",array("conditions"=>"Configuration.id='1'","fields"=>array("payment_mode","api_username","api_password","email","api_signature")));
                                              
                                            if($configDetails['Configuration']['payment_mode']=="sandbox"){
                                                $environment    =   "sandbox";
                                            } else{
                                                $environment    =   "";
                                            }
                                    //echo $environment ; exit;
                                                    //$paymentAmount = urlencode($plandetail['SubscriptionPlan']['plan_charge']);
                                                    $paymentType = urlencode('Sale');                // 'Authorization' or 'Sale'
                                                    $firstName = urlencode($_POST['firstname']);
                                                    $lastName = urlencode($_POST['lastname']);
                                                    $creditCardType = urlencode($cardType);
                                                    $creditCardNumber = urlencode($cardNumber);
                                                    $expDateMonth =$expMonth;
                                                    // Month must be padded with leading zero
                                                    $padDateMonth = urlencode(str_pad($expDateMonth, 2, '0', STR_PAD_LEFT));

                                                    $expDateYear = $expYear;
                                                    $cvv2Number = urlencode($_POST['CVN']);
                                                    $address1 = urlencode($_POST['billing_address']);
                                                    $address2 = "";
                                                    $city = urlencode($_POST['city']);
                                                    $state = urlencode($_POST['state']);
                                                    $zip = urlencode($_POST['zipcode']);
                                                    $country = urlencode('US');                // US or other valid country code
                                                    $amount = urlencode($plandetail['ReguserOrder']['plan_charge']);
                                                    $currencyID = urlencode('USD');                            // or other currency ('GBP', 'EUR', 'JPY', 'CAD', 'AUD')													

                                                    // Add request-specific fields to the request string.
                                                   $nvpStrDoDirect =   "&PAYMENTACTION=$paymentType&AMT=$amount&CREDITCARDTYPE=$creditCardType&ACCT=$creditCardNumber"."&EXPDATE=$padDateMonth$expDateYear&CVV2=$cvv2Number&FIRSTNAME=$firstName&LASTNAME=$lastName"."&STREET=$address1&CITY=$city&STATE=$state&ZIP=$zip&COUNTRYCODE=$country&CURRENCYCODE=$currencyID";
																
																

                                                                $httpParsedResponseArDoDirect =$this->ReguserOrder->PPHttpPostDoDirect('DoDirectPayment', $nvpStrDoDirect,$environment);
                                                                 //echo "<pre>";print_r($httpParsedResponseArDoDirect);exit;

                                                                $authorizationID    =   $httpParsedResponseArDoDirect['TRANSACTIONID'];
                                                                  
                                                                if("SUCCESS" == strtoupper($httpParsedResponseArDoDirect["ACK"]) || "SUCCESSWITHWARNING" == strtoupper($httpParsedResponseArDoDirect["ACK"])) {

                                                                    $curdate = date('Y-m-d');
                                                                    $expdate = date("Y-m-d", mktime(0, 0, 0, date("m")+1, date("d")-1, date("Y")));

                                                                    
                                                                            $query_update = "UPDATE reguser_orders SET payment_status='Confirm',status='1',transaction_id='".$authorizationID."',plan_start_date='".$curdate."',plan_expire_date='".$expdate."' WHERE id = '".$_POST['orderid']."'";
                                                                            mysql_query($query_update) or die(mysql_error());


                                                                                /*condition for entering data into cron table
                                                                                 * to get plan renewed every after 30 days.
                                                                                 * charge from user every after 30 days. 
                                                                                 */                                                                            
                                                                                    $plantypeinfo = $this->ReguserOrder->find("first",array("conditions"=>array("ReguserOrder.id = '".$_POST['orderid']."'"),null));
                                                                                    
                                                                                    $newplan_start_date = $plantypeinfo['ReguserOrder']['plan_expire_date'];

                                                                                    $explode_newplanstart_date = explode('-',$newplan_start_date);

                                                                                    $newplan_expire_date = date("Y-m-d",mktime(0,0,0,$explode_newplanstart_date[1],$explode_newplanstart_date[2]+29,$explode_newplanstart_date[0]));

                                                                                    
                                                                                    $query_renewafter_month = "INSERT INTO future_plans (cron_start_date,user_id,plan_id,plan_type,plan_charge,minimum_usage_per_bag,total_usage,used_usage,transaction_id,plan_start_date,plan_expire_date,payment_status,status)
                                                                                                        VALUES ('".$newplan_start_date."','".$plantypeinfo['ReguserOrder']['user_id']."','".$plantypeinfo['ReguserOrder']['plan_id']."','Renew after 30 days','".$plantypeinfo['ReguserOrder']['plan_charge']."','".$plantypeinfo['ReguserOrder']['minimum_usage_per_bag']."','".$plantypeinfo['ReguserOrder']['total_usage']."','0'
                                                                                                            ,'','".$newplan_start_date."','".$newplan_expire_date."','Pending','1')";
                                                                                    $result_renewafter_month = mysql_query($query_renewafter_month) or die(mysql_error());
                                                                                 /*
                                                                                  * end cron table condition
                                                                                  */

                                                                            
                                                                            $this->ReguserOrder->sendPurchasePlanEmail($userInfo["User"]["email_address"], $_POST['planid']);

                                                                            //$this->ReguserOrder->updateAll(array('ReguserOrder.payment_status' =>"'Confirm' AND ReguserOrder.transaction_id = '".$authorizationID."'"),array('conditions'=>'ReguserOrder.id = '.$_POST['orderid']));

                                                                            //$this->Session->write('message','Congratulations on your subscription to your laundry plan. Schedule your first pickup.');
                                                                            $this->redirect('/page/success_plan/new');
                                                                               
                                                                        } else{
                                                                                $this->Session->write("message",urldecode($httpParsedResponseArDoDirect['L_LONGMESSAGE0']));
                                                                                $this->redirect('/reguser_orders/orders/'.$_POST['planid']);
                                                                             //$httpParsedResponseArDoDirect['L_LONGMESSAGE0'];
                                                                             ///$this->redirect("/page/failure/". $httpParsedResponseArDoDirect['L_LONGMESSAGE0']);
                                                                        }


                                    }

                }      //} // end else{
                } else{
                    $this->Session->write("message","Please agree to our terms of service");
                     $this->redirect('/reguser_orders/orders/'.$_POST['planid']);
                }
           }

       }  //end function purchaseplan()
        
        
                    
      function renewplan(){
            $this->layout="client_inner";
            $this->userLoginCheck();

            $userAddress = $this->User->find("first",array("conditions"=>array("User.id = ".$this->Session->read('user_id'))));

            $paymentstatusinfo = $this->ReguserOrder->find("first",array("conditions"=>array("ReguserOrder.user_id = ".$this->Session->read('user_id'),"ReguserOrder.payment_status = 'Confirm'","ReguserOrder.status = '1'"),'order'=>'ReguserOrder.id DESC',"limit"=>"1"));
            
            if(($paymentstatusinfo['ReguserOrder']['current_pickup'] == $paymentstatusinfo['ReguserOrder']['max_pickup']) && ($paymentstatusinfo['ReguserOrder']['total_usage'] == $paymentstatusinfo['ReguserOrder']['used_usage']) && ($paymentstatusinfo['ReguserOrder']['plan_type'] == 'Auto Renew'))

            //if(($paymentstatusinfo['ReguserOrder']['current_pickup'] == $paymentstatusinfo['ReguserOrder']['max_pickup']) && ($paymentstatusinfo['ReguserOrder']['plan_type'] == 'Auto Renew'))
            { 
                    $curdate = date('Y-m-d');
                    $expdate = date("Y-m-d", mktime(0, 0, 0, date("m")+1, date("d")-1, date("Y")));
                    $query_autorenew = "INSERT INTO reguser_orders (user_id,plan_id,plan_charge,current_pickup,max_pickup,no_of_usage_per_bag,total_usage,used_usage,plan_type,transaction_id,plan_start_date,plan_expire_date,payment_status,status)
                                        VALUES ('".$paymentstatusinfo['ReguserOrder']['user_id']."','".$paymentstatusinfo['ReguserOrder']['plan_id']."','".$paymentstatusinfo['ReguserOrder']['plan_charge']."','0','".$paymentstatusinfo['ReguserOrder']['max_pickup']."','".$paymentstatusinfo['ReguserOrder']['no_of_usage_per_bag']."','".$paymentstatusinfo['ReguserOrder']['total_usage']."','0'
                                            ,'-','','".$curdate."','".$expdate."','Pending','0')";
                    $result_autorenew = mysql_query($query_autorenew) or die(mysql_error());

                    $newplanid = mysql_insert_id();
                    
                    $configDetails  =   $this->Configuration->find("first",array("conditions"=>"Configuration.id='1'","fields"=>array("payment_mode","api_username","api_password","email","api_signature")));

                                    if($configDetails['Configuration']['payment_mode']=="sandbox"){
                                        $environment    =   "sandbox";
                                    } else{
                                           $environment    =   "";
                                    }
                                    //echo $environment ; exit;
                                                    //$paymentAmount = urlencode($plandetail['SubscriptionPlan']['plan_charge']);
                                                    $paymentType = urlencode('Sale');                // 'Authorization' or 'Sale'
                                                    $firstName = urlencode($userAddress['User']['first_name']);
                                                    $lastName = urlencode($userAddress['User']['last_name']);
                                                    $creditCardType = urlencode($userAddress['User']['card_type']);
                                                    $creditCardNumber = urlencode($userAddress['User']['card_number']);
                                                    $expDateMonth = $userAddress['User']['expiration_card_month'];
                                                    $expDateYear = $userAddress['User']['expiration_card_year'];
                                                    $cvv2Number = urlencode($userAddress['User']['card_number_cvv']);
                                                    $address1 = urlencode($userAddress['User']['billing_address']);
                                                    $address2 = "";
                                                    $city = urlencode($userAddress['User']['billing_city']);
                                                    $state = urlencode($userAddress['State']['state']);
                                                    $zip = urlencode($userAddress['User']['billing_zip']);
                                                    $country = urlencode('US');                // US or other valid country code
                                                    $amount = urlencode($paymentstatusinfo['ReguserOrder']['plan_charge']);
                                                    $currencyID = urlencode('USD');                            // or other currency ('GBP', 'EUR', 'JPY', 'CAD', 'AUD')

                                                    // Add request-specific fields to the request string.
                                                    $nvpStrDoDirect =    "&PAYMENTACTION=$paymentType&AMT=$amount&CREDITCARDTYPE=$creditCardType&ACCT=$creditCardNumber".
                                                                "&EXPDATE=$expDateMonth$expDateYear&CVV2=$cvv2Number&FIRSTNAME=$firstName&LASTNAME=$lastName".
                                                                "&STREET=$address1&CITY=$city&STATE=$state&ZIP=$zip&COUNTRYCODE=$country&CURRENCYCODE=$currencyID";

                                                                $httpParsedResponseArDoDirect =$this->ReguserOrder->PPHttpPostDoDirect('DoDirectPayment', $nvpStrDoDirect,$environment);

                                                                $authorizationID    =   $httpParsedResponseArDoDirect['TRANSACTIONID'];

                                                                if("SUCCESS" == strtoupper($httpParsedResponseArDoDirect["ACK"]) || "SUCCESSWITHWARNING" == strtoupper($httpParsedResponseArDoDirect["ACK"])) {

                                                                    $curdate = date('Y-m-d');
                                                                    $expdate = date("Y-m-d", mktime(0, 0, 0, date("m")+1, date("d")-1, date("Y")));


                                                                    $query_update = "UPDATE reguser_orders SET payment_status='Confirm',status='1',transaction_id='".$authorizationID."',plan_start_date='".$curdate."',plan_expire_date='".$expdate."',plan_type='".$_POST['plan_type']."' WHERE id = '".$newplanid."'" ;
                                                                    mysql_query($query_update) or die(mysql_error());

                                                                    $to = $userAddress['User']['email_address'];
                                                                    $subject = "Plan renewed";

                                                                    //$message = "Dear '".$userAddress['User']['first_name']."' ".$userAddress['User']['last_name'].'<br /><br />';
                                                                    $message = "Dear ".$userAddress['User']['first_name']." ".$userAddress['User']['last_name'].'<br /><br />';

                                                                    $message = $message."Your current plan of $".$paymentstatusinfo['ReguserOrder']['plan_charge']." has been renewed.<br />";

                                                                    $message = $message."Your plan has been started from today.";

                                                                    $headers  = "MIME-Version: 1.0\r\n";
                                                                    $headers .= "Content-type: text/html; charset=iso-8859-1\r\n";
                                                                    $headers .= "From: '".SITE_TITLE."' <info@'".SITE_TITLE_MAIL."'.com>\r\n";

                                                                    mail($to,$subject,$message,$headers);

                                                                    $this->redirect('/page/success_plan/autorenew');

                                                                 } else{
                                                                                $this->Session->write("message",urldecode($httpParsedResponseArDoDirect['L_LONGMESSAGE0']));

                                                                   }

                            }else{
                                    $this->Session->write("message",'Your plan can be renewed only once.');
                            }


                      } //end function renewplan(){
                

}



?>
