<?php
/*
 * k@pil Rakesh
 */
class ShippingChargesController extends AppController {

	var $name = 'ShippingCharges';
	var $uses 		= array('PriceProduct','SubscriptionPlan','Configuration','ShippingCharge');
	var $helpers 	= array('Html','Form','Javascript','Ajax','Time');
	var $paginate	= array('limit'=> '50', 'page' => '1', 'order'=>array('ShippingCharge.id'=>'desc'));
	var $components = array ('RequestHandler','Logincheck');
	var $layout='admin';

	function beforeFilter(){
                $loggedAdminId = $this->Session->read("adminid");
		if(isset($this->params['admin']) && $this->params['admin'] && !$loggedAdminId){
			$this->redirect("/admin/admins/login");
		}
	}


	function admin_index($created=null,$toDate=null){
		$this->layout="admin";
	//	$this->set("expand_menu_links","testimonial");
		$condition=array();
		$separator=array();
		$urlSeparator=array();


		$urlSeparator=implode("/",$urlSeparator);

		$this->set('separator',$separator);
		$this->set('urlSeparator',$urlSeparator);

                if(isset($this->data['ShippingCharge']['action'])){
				$idList=$this->data['ShippingCharge']['idList'];
				if($idList){
					if($this->data['ShippingCharge']['action']=="activate"){
						$cnd=array("ShippingCharge.id IN ($idList) ");
						$this->ShippingCharge->updateAll(array('ShippingCharge.status' =>"'1'"),$cnd);
					}elseif($this->data['ShippingCharge']['action']=="deactivate"){
						$cnd=array("ShippingCharge.id IN ($idList) ");
						$this->ShippingCharge->updateAll(array('ShippingCharge.status' =>"'0'"),$cnd);
					}elseif($this->data['ShippingCharge']['action']=="delete"){
						$cnd=array("ShippingCharge.id IN ($idList) ");
						$this->ShippingCharge->deleteAll($cnd);
					}
				}
			}


        $this->set('shippingcharges', $this->paginate('ShippingCharge',$condition));
		if($this->RequestHandler->isAjax()) {
			$this->layout='';
			$this->viewPath = 'elements'.DS.'admin/shipping_charges/';
			$this->render('index');
		}
	}// end of function index



              function admin_addShipping($order_id=NULL){ 
                        $this->layout="admin";
                        $msgString='';
                        $conditions=array();

                        $this->set('order_id',$order_id);

                        $shippinginfo = $this->ShippingCharge->find("count", array ("conditions" => array ("ShippingCharge.order_id = '" . $order_id . "'"),null));
                        $this->set('shippinginfo',$shippinginfo);

                        if($this->data){ 
                                if(empty($this->data["ShippingCharge"]["shipping_no"])){
                                        $msgString .="- Please enter shipping number.<br>";
                                }

                                if(empty($this->data["ShippingCharge"]["shipping_charge"])){
                                        $msgString .="- Please enter shipping amount.<br>";
                                }
                                else if(!is_numeric($this->data["ShippingCharge"]["shipping_charge"])){
                                        $msgString .="- Please enter only numeric shipping amount.<br>";
                                }
                                

                                if(isset($msgString) && $msgString!=''){
                                        $this->Session->write('message',$msgString);
                                }

                                else
                                {
                                        $this->data['ShippingCharge']['order_id'] = $order_id;
                                        //echo '<pre>';print_r($this->data);exit;
                                        $this->ShippingCharge->save($this->data);
                                        $this->Session->write('message','Shipping Details saved successfully.');
                                        $this->redirect('/admin/shipping_charges/index');
                                }
                        }
                        
                } //end function admin_edittestimonials($id=NULL)

   

                function admin_editShipping($id=NULL){
                        $this->layout="admin";
                        $msgString='';
                        $conditions=array();

                        if($this->data){
                                if(empty($this->data["ShippingCharge"]["shipping_no"])){
                                        $msgString .="- Please enter shipping number.<br>";
                                }

                                if(empty($this->data["ShippingCharge"]["shipping_charge"])){
                                        $msgString .="- Please enter shipping amount.<br>";
                                }
                                else if(!is_numeric($this->data["ShippingCharge"]["shipping_charge"])){
                                        $msgString .="- Please enter only numeric shipping amount.<br>";
                                }


                                if(isset($msgString) && $msgString!=''){
                                        $this->Session->write('message',$msgString);
                                }

                                else{
                                        
                                        $this->ShippingCharge->save($this->data);
                                        $this->Session->write('message','Shipping Details updated successfully.');
                                        $this->redirect('/admin/shipping_charges/index');
                                }
                      }
                      else{
                            $this->ShippingCharge->id = $id;
                            $this->data = $this->ShippingCharge->read();
                        }
                } //end function admin_edittestimonials($id=NULL)



                function admin_deleteShipping($id=NULL){
                    if($id>0){
                        $this->ShippingCharge->delete($id);
                        $this->viewPath = 'elements'.DS.'admin';
                        $this->Session->write('message','Shipping details deleted successfully.');
                        $this->render('blank_delete');
                        $this->redirect('/admin/shipping_charges/index');
                    }
                }//end of admin_deleteUser


		function price(){
			$this->layout="client_inner";
			$this->set("title_for_layout","PriceProduct") ;
			$this->set("active","pricing");

			$pricedetail = $this->PriceProduct->find("all", array ("conditions" => array ("PriceProduct.status= '1'"),'order' => 'PriceProduct.product_name ASC',"fields" => array ("PriceProduct.id","PriceProduct.product_name","PriceProduct.product_price")));
                        $this->set("pricedetail", $pricedetail);

                        $plandetailsmallbag = $this->SubscriptionPlan->find("all",array("conditions"=>"SubscriptionPlan.status = '1'"));
                        $this->set('plandetailsmallbag',$plandetailsmallbag);

                        $configdetail = $this->Configuration->find("first", array ("conditions" => array ("Configuration.id= '1'"),null));
                        $this->set('configdetail',$configdetail);
		} //end function price()



}// end of Class
?>