<?php

class FuturePlansController extends AppController {

	var $name = 'FuturePlans';
	var $uses 		= array("User","State","Reference","FuturePlan","SubscriptionPlan","Configuration","ReguserOrder");
	var $helpers 	= array('Html','Form','Javascript','Ajax','Time');
	var $paginate	= array('limit'=> '50', 'page' => '1', 'order'=>array('FuturePlan.id'=>'desc'));
	var $components = array ('RequestHandler',"Logincheck","Common");
	var $layout='admin';

	function beforeFilter(){
                $loggedAdminId = $this->Session->read("adminid");
		if(isset($this->params['admin']) && $this->params['admin'] && !$loggedAdminId){
			$this->redirect("/admin/admins/login");
		}
	}


	/*_____________________________________________________________________________
	Function : index
	Show admin_index page
	Tables : ReguserOrder
	???????????????????????????????????????????????????????????????????????????????*/
	function admin_index($userid=null,$created=null,$toDate=null){
            
		$this->layout="admin";
		$this->set("expand_menu_links","future_plans");
		$condition=array();
		$separator=array();
		$urlSeparator=array();

		if(!empty($this->data)){

			if(isset($this->data['FuturePlan']['id']) && $this->data['FuturePlan']['id']!=''){
				$customerName=trim($this->data['FuturePlan']['id']);
			}


			if(isset($this->data['FuturePlan']['action'])){
				$idList=$this->data['FuturePlan']['idList'];
				if($idList){
					if($this->data['FuturePlan']['action']=="activate"){
						$cnd=array("FuturePlan.id IN ($idList) ");
						$this->FuturePlan->updateAll(array('FuturePlan.status' =>"'1'"),$cnd);
					}elseif($this->data['FuturePlan']['action']=="deactivate"){
						$cnd=array("FuturePlan.id IN ($idList) ");
						$this->FuturePlan->updateAll(array('FuturePlan.status' =>"'0'"),$cnd);
					}elseif($this->data['FuturePlan']['action']=="delete"){
						$cnd=array("FuturePlan.id IN ($idList) ");
						$this->FuturePlan->deleteAll($cnd);
					}
				}
			}
		}elseif(!empty($this->params)){
			if(isset($this->params['named']['id']) && $this->params['named']['id']!=''){
				$userName=trim($this->params['named']['id']);
			}

		}

		if(isset($userName) && $userName!=''){
			$separator[]='id:'.$userName;
			$condition[] =" (FuturePlan.id like '%'.$userName.'%') ";
		}

                 if(isset($created) && $created!='' && $created!='null'){
                    $created    =   $created ;
                   }
                    if(isset($toDate) && $toDate!='' && $toDate!='null'){
                    $toDate    =   $toDate ;
                   }
                    elseif(!empty($this->params)){
                                if(isset($this->params['named']['created']) && $this->params['named']['created']!='' && isset($this->params['named']['todate']) && $this->params['named']['todate']!=''){
                                        $created=trim($this->params['named']['created']);
                                        $toDate=trim($this->params['named']['todate']);
                                }
                }
                if(isset($created) && $created!='' && $created!='null'){
			$separator[]='created:'.$created;
                        $separator[]='todate:'.$toDate;
			$condition[]="FuturePlan.created between '".$created."' and '".$toDate."'";
		}


		$separator=implode("/",$separator);

		if(!empty($this->passedArgs)){
			if(isset($this->passedArgs["page"])){
				$urlSeparator[]='page:'.$this->passedArgs["page"];
			}
			if(isset($this->passedArgs["sort"])){
				$urlSeparator[]='sort:'.$this->passedArgs["sort"];
			}
			if(isset($this->passedArgs["direction"])){
				$urlSeparator[]='direction:'.$this->passedArgs["direction"];
			}
		}

		$urlSeparator=implode("/",$urlSeparator);

		$this->set('separator',$separator);
		$this->set('urlSeparator',$urlSeparator);

                //$condition[]="FuturePlan.payment_status = 'Confirm'";
                $condition[]="FuturePlan.user_id = '".$userid."'";
                
                $this->set('futureplans', $this->paginate('FuturePlan',$condition));
                
		if($this->RequestHandler->isAjax()) {
			$this->layout='';
			$this->viewPath = 'elements'.DS.'admin/future_plans/';
			$this->render('index');
		}
	}// end of function index

              

        function admin_deletefutureplans($id=NULL){

            if($id>0){

                $this->FuturePlan->id = $id;
                $planDetails = $this->FuturePlan->read();

                $userInfo = $this->User->find("first",array("conditions"=>"User.id = '".$planDetails['FuturePlan']['user_id']."'"));

                //mail function by deepshikha

                        $headers .= 'Content-type: text/html; charset=iso-8859-1'. "\r\n";
                        $headers.= 'From:'.SITE_TITLE. "\r\n";
                        $to = $userInfo['User']['email_address'];
                        $subject = "Future Plan Paused";

                        $messageToSend = "Dear ".$userInfo['User']['first_name'].", <br>";
                        $messageToSend .= "Your future plan has been deleted on your request. <br>";
                        $messageToSend .= "You can again purchase a new plan on ".SITE_TITLE.".";

                        $headers  = "MIME-Version: 1.0\r\n";
                        $headers .= "Content-type: text/html; charset=iso-8859-1\r\n";
                        $headers .= "From: ".SITE_TITLE." <info@".SITE_TITLE_MAIL.".com>\r\n";

                        //mail($to, $subject, $messageToSend, $headers);

                $this->FuturePlan->delete($id);
                $this->viewPath = 'elements'.DS.'admin';
                $this->Session->write('message','Future plan details deleted successfully.');
                $this->render('blank_delete');


                $this->redirect('/admin/users/index');
            }
        }//end of admin_deleteUser

        
        function admin_pausePlan($id=NULL,$user_id=null){

            if($id>0){

                    $cnd=array("FuturePlan.id = $id");
                    $this->FuturePlan->updateAll(array('FuturePlan.cron_status' =>"'0'"),$cnd);                   
                    $this->Session->write('message','User Plan Paused successfully.');
                    $this->redirect('/admin/future_plans/index/'.$user_id);
            }
        }//end of admin_pausePlan

        function admin_playPlan($id=NULL,$user_id=null){

            if($id>0){

                    $date = date("Y-m-d");// current date

                    $new_date = strtotime(date("Y-m-d", strtotime($date)) . " +1 day");

                    $new_date = date("Y-m-d",$new_date);

                    $cnd=array("FuturePlan.id = $id");
                    $this->FuturePlan->updateAll(array('FuturePlan.cron_status' =>"'1'",'FuturePlan.cron_start_date' =>"'$new_date'"),$cnd);
                    $this->Session->write('message','User Plan activated successfully.');
                    $this->redirect('/admin/future_plans/index/'.$user_id);
            }
        }//end of admin_playPlan

        

        function upgrade_plan($planid = null){
		
		$this->redirect('upgradenewplan'); //Mukund added for test.
		exit;

            $this->layout="client_inner";
            $this->userLoginCheck();

            $this->set('planid',$planid);

            $plandetail = $this->SubscriptionPlan->find("first",array("conditions"=>"SubscriptionPlan.id = '".$planid."'"));
            $this->set('plandetail',$plandetail);

            $currentplaninfo = $this->ReguserOrder->find("first",array("conditions"=>array("ReguserOrder.user_id = ".$this->Session->read('user_id'),"ReguserOrder.payment_status = 'Confirm'","ReguserOrder.status = '1'"),'order'=>'ReguserOrder.id DESC',"limit"=>"1"));

            $this->set('currentplaninfo',$currentplaninfo);

            $buyerInfo= $this->User->find("first",array("conditions"=>"User.id='".$_SESSION['user_id']."'"));
            $this->set('buyerInfo',$buyerInfo);

            $stateInfo= $this->State->find("first",array("conditions"=>"State.id='".$buyerInfo['User']['state']."'"));
            $this->set('stateInfo',$stateInfo);


            $newplan_start_date = $currentplaninfo['ReguserOrder']['plan_expire_date'];
            $explode_newplanstart_date = explode('-',$newplan_start_date);
            $newplan_expire_date = date("Y-m-d",mktime(0,0,0,$explode_newplanstart_date[1],$explode_newplanstart_date[2]+29,$explode_newplanstart_date[0]));


            $this->data['FuturePlan']['cron_start_date'] = $newplan_start_date;
            $this->data['FuturePlan']['user_id'] = $_SESSION['user_id'];
            $this->data['FuturePlan']['plan_id'] = $planid;
            $this->data['FuturePlan']['plan_type'] = 'Upgrade Plan';
            $this->data['FuturePlan']['plan_charge'] = $plandetail['SubscriptionPlan']['plan_charge'];
            $this->data['FuturePlan']['max_pickup'] = $plandetail['SubscriptionPlan']['max_pickup'];
            $this->data['FuturePlan']['no_of_usage_per_bag'] = $plandetail['SubscriptionPlan']['usage_per_bag'];
            $this->data['FuturePlan']['total_usage'] = $plandetail['SubscriptionPlan']['total_usage'];
            $this->data['FuturePlan']['used_usage'] = '0';
            $this->data['FuturePlan']['plan_start_date'] = $newplan_start_date;
            $this->data['FuturePlan']['plan_expire_date'] = $newplan_expire_date;
            $this->data['FuturePlan']['payment_status'] = 'Pending';
            $this->data['FuturePlan']['status'] = '1';


             /*
             * if user upgrade his/her plan
             * then all plans will be removed from future plans
             */
            $query_delete = "DELETE FROM future_plans WHERE user_id = '".$this->Session->read('user_id')."'" ;
            mysql_query($query_delete) or die(mysql_error());

            //now save in future plans
            $this->FuturePlan->save($this->data);
            $orderid=$this->FuturePlan->id;
            $this->set('orderid',$orderid);

        }


       function purchaseplan(){

            $this->layout="client_inner";
            $this->userLoginCheck();

            $plandetail = $this->SubscriptionPlan->find("first",array("conditions"=>"SubscriptionPlan.id = '".$_POST['planid']."'"));
            $this->set('plandetail',$plandetail);
//echo"<pre>"; print_r($_POST); exit;
                if($_POST['action']=='1'){
                if($_POST['aggree_terms']=="1"){
                if($_POST){                    
                      
                       $msgString="";                        

                               if(empty($_POST['billing_address'])){
                                   $msgString.="Please Enter Street Address.<br /> ";
                               }
                               if(empty($_POST['city'])){
                                   $msgString.="Please Enter City. <br />";
                               }
                               if(empty($_POST['state'])){
                                   $msgString.="Please Enter State. <br />";
                               }
                               if(empty($_POST['zipcode'])){
                                   $msgString.="Please Enter Zipcode. <br />";
                               }
                               if(empty($_POST['firstname'])){
                                   $msgString.="Please Enter First Name. <br />";
                               }
                               if(empty($_POST['lastname'])){
                                   $msgString.="Please Enter Last Name. <br />";
                               }
                               if(empty($_POST['CVN'])){
                                   $msgString.="Please Enter CVN. <br />";
                               }elseif(preg_match("/^[0-9]{3,}$/", $_POST['CVN']) === 0){
                                   $msgString .= "CVN Should be Numeric and 3 or 4 digit.<br>";
                                }

                                 $padDateMonth = str_pad($_POST['ExpMon'], 2, '0', STR_PAD_LEFT);
                                if(empty($_POST['ExpYear']) || $_POST['ExpMon']=='13'){
                                    $msgString .= "Card Expiration Month or Year Required.<br>";
                                }elseif((date('Y-m') > $_POST['ExpYear']."-".$padDateMonth) ? true : false){
                                    $msgString .= "Choose Valid Expiration Date.<br>";
                                }

                                    $buyerId    =   $this->Session->read("user_id");
                                    $sessionId  =   $this->Session->read("browser_session_id");


                                   $cardNumber  =  $_POST['CardNumber'];
                                   $cardType  =  $_POST['CardType'];
                                   $cvn    =    $_POST['CVN'];
                                   $returnMsg  =   $this->ReguserOrder->validateCC($cardNumber,$cardType);
                                   $expMonth   =   $_POST['ExpMon'];
                                   $expYear     =$_POST['ExpYear'];
                                   if(isset($returnMsg) && $returnMsg!=""){
                                     $msgString.=  $returnMsg;

                                   }
                                      if(isset($msgString) && $msgString!=""){
                                          $this->Session->write("message",$msgString);
                                          //$this->redirect('/reguser_orders/orders/'.$_POST['planid']);
                                          $this->redirect('/future_plans/upgrade_plan/'.$_POST['planid']);
                                      }
                                      else{

                                                    $configDetails  =   $this->Configuration->find("first",array("conditions"=>"Configuration.id='1'","fields"=>array("payment_mode","api_username","api_password","email","api_signature")));
                                                                  // echo "<pre>"; print_r($configDetails); exit;
                                                    if($configDetails['Configuration']['payment_mode']=="sandbox"){
                                                        $environment    =   "sandbox";
                                                    }
                                                    else{
                                                           $environment    =   "";
                                                    }
                                    //echo $environment ; exit;
                                                    //$paymentAmount = urlencode($plandetail['SubscriptionPlan']['plan_charge']);
                                                    $paymentType = urlencode('Sale');                // 'Authorization' or 'Sale'
                                                    $firstName = urlencode($_POST['firstname']);
                                                    $lastName = urlencode($_POST['lastname']);
                                                    $creditCardType = urlencode($cardType);
                                                    $creditCardNumber = urlencode($cardNumber);
                                                    $expDateMonth =$expMonth;
                                                    // Month must be padded with leading zero
                                                    $padDateMonth = urlencode(str_pad($expDateMonth, 2, '0', STR_PAD_LEFT));

                                                    $expDateYear = $expYear;
                                                    $cvv2Number = urlencode($_POST['CVN']);
                                                    $address1 = urlencode($_POST['billing_address']);
                                                    $address2 = "";
                                                    $city = urlencode($_POST['city']);
                                                    $state = urlencode($_POST['state']);
                                                    $zip = urlencode($_POST['zipcode']);
                                                    $country = urlencode('US');                // US or other valid country code
                                                    $amount = urlencode($plandetail['SubscriptionPlan']['plan_charge']); 
                                                    $currencyID = urlencode('USD');                            // or other currency ('GBP', 'EUR', 'JPY', 'CAD', 'AUD')

                                                    // Add request-specific fields to the request string.
                                                    $nvpStrDoDirect =    "&PAYMENTACTION=$paymentType&AMT=$amount&CREDITCARDTYPE=$creditCardType&ACCT=$creditCardNumber".
                                                                "&EXPDATE=$padDateMonth$expDateYear&CVV2=$cvv2Number&FIRSTNAME=$firstName&LASTNAME=$lastName".
                                                                "&STREET=$address1&CITY=$city&STATE=$state&ZIP=$zip&COUNTRYCODE=$country&CURRENCYCODE=$currencyID";

                                                                $httpParsedResponseArDoDirect =$this->FuturePlan->PPHttpPostDoDirect('DoDirectPayment', $nvpStrDoDirect,$environment);

                                                                 //echo "<pre>";print_r($httpParsedResponseArDoDirect);exit;

                                                                $authorizationID    =   $httpParsedResponseArDoDirect['TRANSACTIONID'];
                                                                  
                                                                if("SUCCESS" == strtoupper($httpParsedResponseArDoDirect["ACK"]) || "SUCCESSWITHWARNING" == strtoupper($httpParsedResponseArDoDirect["ACK"])) {


                                                                            //update future plans payment status
                                                                            $query_update = "UPDATE future_plans SET payment_status='Confirm',status='1',transaction_id='".$authorizationID."' WHERE id = '".$_POST['orderid']."'" ;
                                                                            mysql_query($query_update) or die(mysql_error());

                                                                            $this->redirect('/page/success_plan/upgrade');
                                                                               
                                                                        } else{
                                                                                $this->Session->write("message",urldecode($httpParsedResponseArDoDirect['L_LONGMESSAGE0']));

                                                                                //echo $_SESSION['message'];exit;
                                                                                //$httpParsedResponseArDoDirect['L_LONGMESSAGE0'];
                                                                                ///$this->redirect("/page/failure/". $httpParsedResponseArDoDirect['L_LONGMESSAGE0']);
                                                                        }


                                    }

                }      //} // end else{
                } else{
                    $this->Session->write("message","Please agree to our terms of service");
                     $this->redirect('/future_plans/upgrade_plan/'.$_POST['planid']);
                }
           }

       }  //end function purchaseplan()
        
        
                    
            function admin_monthlyInvoice($planid=null,$userid=null){

                $this->layout="admin";

                    $query_monthinvoice = "SELECT user_id, plan_id, purchased_plan_id, SUM(max_weight), SUM(total_weight), SUM(overage_weight), SUM(overage_amount) FROM generate_invoices WHERE plan_id = '".$planid."' AND user_id = '".$userid."' GROUP BY purchased_plan_id,user_id";
                    $result_monthinvoice = mysql_query($query_monthinvoice) or die(mysql_error());
                    $row_monthinvoice = mysql_fetch_assoc($result_monthinvoice);
                    
                    $this->set('row_monthinvoice',$row_monthinvoice);

             }  //end function admin_monthlyInvoice()


             function admin_viewPlan($id=NULL){
                    $this->layout="admin";
                    
                    $this->ReguserOrder->id = $id;
                    $planDetails = $this->ReguserOrder->read();
                    //echo '<pre>';print_r($planDetails);exit;
                    $this->set("planDetails",$planDetails);
                } //end function admin_viewOrder()

            
            
            function viewplandetail($planid=null){
                $this->layout="client_inner";
                $this->userLoginCheck();
                $userplanDetails = $this->ReguserOrder->find("first",array("conditions"=>array("ReguserOrder.id = ".$planid)));
                $this->set("userplanDetails",$userplanDetails);
            } //end function viewplandetail()


            function upgradenewplan(){
                //$this->layout="client_inner";
				$this->layout="client";
                $this->userLoginCheck();

                $userplanInfo = $this->ReguserOrder->find("first",array("conditions"=>array("ReguserOrder.user_id = ".$this->Session->read('user_id'),"ReguserOrder.plan_expire_date >'".date("Y-m-d")."'"),'order'=>'ReguserOrder.id DESC',"limit"=>"1"));
                $this->set("userplanInfo",$userplanInfo);


                        $msgString='';

			$condition=array();
			$condition[] = "ReguserOrder.user_id = ".$this->Session->read('user_id');
                        $condition[] = "ReguserOrder.status = 1";
			$separator=array();
			$urlSeparator=array();



			$separator=implode("/",$separator);

			if(!empty($this->passedArgs)){
				if(isset($this->passedArgs["page"])){
					$urlSeparator[]='page:'.$this->passedArgs["page"];
				}
				if(isset($this->passedArgs["sort"])){
					$urlSeparator[]='sort:'.$this->passedArgs["sort"];
				}
				if(isset($this->passedArgs["direction"])){
					$urlSeparator[]='direction:'.$this->passedArgs["direction"];
				}
			}

			$urlSeparator=implode("/",$urlSeparator);

			$this->set('separator',$separator);
			$this->set('urlSeparator',$urlSeparator);

					$this->paginate['ReguserOrder'] = array(
						'order' => array('ReguserOrder.id'=>'DESC'),
						'limit' => '10'
					  );
			$this->set('usersallplanInfo', $this->paginate('ReguserOrder',$condition));


            } //end function upgradenewplan()


}



?>
