<?php

/*
 * by
 * Deepshikha Jain
 */
class OrdersController extends AppController {
	var $name = "Orders";
	var $uses = array (
		"User",
		"OrdersPayAsYouGoUser",
		"SubscriptionPlan",
		"ReguserOrder",
		"Order",
		"OrdersSubscribedPlansUser",
		"Configuration",
		"GenerateInvoice",
		"CouponCode",
		"Reference",
		"UserLocation",
		"WeighProduct",
		"OrderItem"
	);
	var $helpers = array (
		'Html',
		'Form',
		'Javascript',
		'Ajax',
		'Time'
	);
	var $paginate = array (
		'limit' => '10',
		'page' => '1',
		'order' => array (
			'Order.id' => 'desc'
		)
	);
	var $components = array (
		'RequestHandler',
		"Logincheck",
		"Common"
	);

	function beforeFilter() {
		$loggedAdminId = $this->Session->read("adminid");
		if (isset ($this->params['admin']) && $this->params['admin'] && !$loggedAdminId) {
			$this->redirect("/admin/admins/login");
		}
	}

	/*admin function starts here
	* by deepshikha
	*
	*/
	function admin_index($created = null, $toDate = null) {
		$this->layout = "admin";
		//	$this->set("expand_menu_links","testimonial");
		$condition = array ();
		$separator = array ();
		$urlSeparator = array ();

		$urlSeparator = implode("/", $urlSeparator);

		$this->set('separator', $separator);
		$this->set('urlSeparator', $urlSeparator);

		if (!empty ($this->data)) {

			if (isset ($this->data['Order']['search_order']) && $this->data['Order']['search_order'] != '') {
				$orderName = trim($this->data['Order']['search_order']);
			}

			if (isset ($this->data['Order']['action'])) {

				$idList = $this->data['Order']['idList'];
				if ($idList) {
					if ($this->data['Order']['action'] == "activate") {
						$cnd = array (
							"Order.id IN ($idList) "
						);
						$this->Order->updateAll(array (
							'Order.status' => "'1'"
						), $cnd);
					}
					elseif ($this->data['Order']['action'] == "deactivate") {
						$cnd = array (
							"Order.id IN ($idList) "
						);
						$this->Order->updateAll(array (
							'Order.status' => "'0'"
						), $cnd);
					}
					elseif ($this->data['Order']['action'] == "delete") {
						$cnd = array (
							"Order.id IN ($idList) "
						);
						$this->Order->deleteAll($cnd);
					}
				}
			}
		}
		elseif (!empty ($this->params)) {
			if (isset ($this->params['named']['search_order']) && $this->params['named']['search_order'] != '') {
				$orderName = trim($this->params['named']['search_order']);
			}
		}

		if (isset ($orderName) && $orderName != '') {
			$separator[] = 'order_type:' . $orderName;
			$condition[] = " (Order.order_type like '%" . $orderName . "%') ";
		}

		$this->set('orders', $this->paginate('Order', $condition));

		if ($this->RequestHandler->isAjax()) {
			$this->layout = '';
			$this->viewPath = 'elements' . DS . 'admin/orders/';
			$this->render('index');
		}
	} //end of function index()

	function admin_deleteorders($id = NULL) {
		if ($id > 0) {
			$this->Order->delete($id);
			$this->viewPath = 'elements' . DS . 'admin';
			$this->Session->write('message', 'Order details deleted successfully.');
			$this->render('blank_delete');
			$this->redirect('/admin/orders/index');
		}
	} //end of admin_deleteUser

	function admin_deactivateOrder($id = NULL) {
		if ($id > 0) {
			$cnd = array (
				"Order.id = $id"
			);
			$this->Order->updateAll(array (
				'Order.status' => "'0'"
			), $cnd);
			$this->set('action', '/admin/orders/activateOrder/' . $id);
			$this->set('id', $id);
			$this->set('status', 0);
			$this->viewPath = 'elements' . DS . 'admin';
			$this->Session->write('message', 'Order details Deactivated successfully.');
			$this->render('update_status');
			$this->redirect('/admin/orders/index');
		}

	}

	function admin_activateOrder($id = NULL) {
		if ($id > 0) {
			$cnd = array ("Order.id = $id");
			$this->Order->updateAll(array ('Order.status' => "'1'"), $cnd);
			$this->set('action', '/admin/orders/deactivateOrder/' . $id);
			$this->set('id', $id);
			$this->set('status', 1);
			$this->viewPath = 'elements' . DS . 'admin';
			$this->Session->write('message', 'Order details Activated successfully.');
			$this->render('update_status');
			$this->redirect('/admin/orders/index');
		}
	} //end of admin_activateCustomer

	function admin_editOrders($id = NULL) {
		$this->layout = "admin";
		$msgString = '';
		$conditions = array ();
		$this->Order->id = $id;
		$orderDetails = $this->Order->read();
		$this->set('oldweight', $orderDetails['OrdersSubscribedPlansUser']['total_weight']);

		global $default_discount;
		global $minimum_usage;
		global $overage_amount;

		if ($this->data) {
			//echo '<pre>';print_r($this->data);exit;
			$paymentstatusinfo = $this->ReguserOrder->find("first", array ("conditions" => array ("ReguserOrder.user_id = " . $this->data['Order']['user_id'],"ReguserOrder.payment_status = 'Confirm'","ReguserOrder.status = '1'"),'order' => 'ReguserOrder.id DESC',"limit" => "1"));

			if (isset ($this->data['Order']['order_amount']) && (!empty ($this->data['Order']['order_amount'])) && (!empty ($orderDetails['Order']['discount_coupon_code']))) {
				$this->data['Order']['discounted_order_amount'] = (($this->data['Order']['order_amount']) * $default_discount) / 100;
			}

			if (isset ($this->data['OrdersPayAsYouGoUser']['total_weight']) && !empty ($this->data['OrdersPayAsYouGoUser']['total_weight'])) {
				$this->data['Order']['order_amount'] = ($this->data['OrdersPayAsYouGoUser']['total_weight']) * $overage_amount;
			}

			/*
			 * Conditions for total weight & overages
			 * and calculates order amount
			 * by deepshikha
			 * on 14th june 2011
			 */
			if (isset ($this->data['OrdersSubscribedPlansUser']['total_weight']) && !empty ($this->data['OrdersSubscribedPlansUser']['total_weight'])) {

				if (($this->data['OrdersSubscribedPlansUser']['total_weight'] >= $minimum_usage) && $this->data['OrdersSubscribedPlansUser']['total_weight'] > ($paymentstatusinfo['ReguserOrder']['total_usage'] - $paymentstatusinfo['ReguserOrder']['used_usage'])) {
					//echo 'condition 1 if total>15 and total>remaining';exit;
					$this->data['Order']['order_amount'] = ($this->data['OrdersSubscribedPlansUser']['total_weight'] - ($paymentstatusinfo['ReguserOrder']['total_usage'] - $paymentstatusinfo['ReguserOrder']['used_usage'])) * $overage_amount;
				} else
					if ($this->data['OrdersSubscribedPlansUser']['total_weight'] > ($paymentstatusinfo['ReguserOrder']['total_usage'] - $paymentstatusinfo['ReguserOrder']['used_usage']) && $this->data['OrdersSubscribedPlansUser']['total_weight'] <= $minimum_usage) {
						//echo 'condition 2 if total>remaining and total<=15';
						$this->data['Order']['order_amount'] = ($minimum_usage - ($paymentstatusinfo['ReguserOrder']['total_usage'] - $paymentstatusinfo['ReguserOrder']['used_usage'])) * $overage_amount;
					} else
						if ($this->data['OrdersSubscribedPlansUser']['total_weight'] == ($paymentstatusinfo['ReguserOrder']['total_usage'] - $paymentstatusinfo['ReguserOrder']['used_usage']) && $this->data['OrdersSubscribedPlansUser']['total_weight'] < $minimum_usage) {
							//echo 'condition 3 total == remaining and total<15';exit;
							$this->data['Order']['order_amount'] = ($minimum_usage - ($this->data['OrdersSubscribedPlansUser']['total_weight'])) * $overage_amount;
						} else
							if ($this->data['OrdersSubscribedPlansUser']['total_weight'] < ($paymentstatusinfo['ReguserOrder']['total_usage'] - $paymentstatusinfo['ReguserOrder']['used_usage']) && $this->data['OrdersSubscribedPlansUser']['total_weight'] < $minimum_usage && ($paymentstatusinfo['ReguserOrder']['total_usage'] - $paymentstatusinfo['ReguserOrder']['used_usage']) < $minimum_usage) {
								//echo 'condition 4 total < remaining and total<15';exit;
								$this->data['Order']['order_amount'] = ($minimum_usage - ($paymentstatusinfo['ReguserOrder']['total_usage'] - $paymentstatusinfo['ReguserOrder']['used_usage'])) * $overage_amount;
							}

			}

			$this->Order->save($this->data);

			if ($this->data['Order']['order_type'] == 'Pay As You Go') {
				$this->OrdersPayAsYouGoUser->query("UPDATE orders_pay_as_you_go_users SET payment_status = '" . $this->data['OrdersPayAsYouGoUser']['payment_status'] . "', total_weight = '" . $this->data['OrdersPayAsYouGoUser']['total_weight'] . "' WHERE order_id = '" . $id . "'");
			} else {

				if ($this->data['OrdersSubscribedPlansUser']['total_weight'] < $minimum_usage && $this->data['OrdersSubscribedPlansUser']['total_weight'] != '0') { //echo 'total weight is right';exit;
					$this->data['OrdersSubscribedPlansUser']['total_weight'] = $minimum_usage;
				}

				$this->OrdersSubscribedPlansUser->query("UPDATE orders_subscribed_plans_users SET total_weight = '" . $this->data['OrdersSubscribedPlansUser']['total_weight'] . "' WHERE order_id = '" . $id . "'");

				$updated_weight = $this->data['OrdersSubscribedPlansUser']['total_weight'] - $this->data['Order']['old_weight'];

				$querypaymentinfo = "UPDATE reguser_orders SET used_usage = '" . $paymentstatusinfo['ReguserOrder']['used_usage'] . "' + '" . $updated_weight . "', payment_status = '" . $this->data['ReguserOrder']['payment_status'] . "' where id='" . $paymentstatusinfo['ReguserOrder']['id'] . "' AND status='1'";
				$resultpaymentinfo = mysql_query($querypaymentinfo) or die(mysql_error());

			}
			$this->Session->write('message', 'Order details updated successfully.');
			$this->redirect('/admin/orders/index');

		} //end if($this->data){

		else {
			$this->Order->id = $id;
			$this->data = $this->Order->read();
		} //end else
	} //end function admin_editOrders($id=NULL)

	function admin_viewOrder($id = NULL) {
		$this->layout = "admin";
		$this->Order->id = $id;
		$orderDetails = $this->Order->read();
                $this->set("orderDetails", $orderDetails);

                $ordereditemInfo = $this->OrderItem->find("all", array ("conditions" => array ("OrderItem.order_id = " . $id)));
                $this->set("ordereditemInfo", $ordereditemInfo);

	} //end function admin_viewOrder()

	function admin_viewOrderPrint($id = NULL) {
		$this->layout = "";
		$this->Order->id = $id;
		$orderDetails = $this->Order->read();
		$this->set("orderDetails", $orderDetails);

                $ordereditemInfo = $this->OrderItem->find("all", array ("conditions" => array ("OrderItem.order_id = " . $id)));
                $this->set("ordereditemInfo", $ordereditemInfo);
	} //end function admin_viewOrder()

	function admin_generateInvoice($id = NULL) {

		$this->layout = "admin";
		$this->Order->id = $id;
		$orderDetails = $this->Order->read();

		$invoiceinfo = $this->GenerateInvoice->find("count", array (
			"conditions" => array (
				"GenerateInvoice.order_id = '" . $id . "'"
			),
			null
		));

		if ($invoiceinfo > 0) {
			$this->Session->write('message', 'Invoice of this order is already generated.');
			$this->redirect('/admin/generate_invoices/index');
		} else {

			$this->data['GenerateInvoice']['user_id'] = $orderDetails['Order']['user_id'];
			$this->data['GenerateInvoice']['order_id'] = $orderDetails['Order']['id'];
			$this->data['GenerateInvoice']['plan_id'] = $orderDetails['ReguserOrder']['id'];
			$this->data['GenerateInvoice']['purchased_plan_id'] = $orderDetails['ReguserOrder']['plan_id'];
			$this->data['GenerateInvoice']['plan_purchased_date'] = $orderDetails['ReguserOrder']['plan_start_date'];
			$this->data['GenerateInvoice']['plan_expired_date'] = $orderDetails['ReguserOrder']['plan_expire_date'];
			$this->data['GenerateInvoice']['max_weight'] = (float) $orderDetails["ReguserOrder"]['total_usage'];
			$this->data['GenerateInvoice']['total_weight'] = (float) $orderDetails["OrdersSubscribedPlansUser"]['total_weight'];

			if ($orderDetails['Order']['order_amount'] != '') {
				$this->data['GenerateInvoice']['overage_amount'] = $orderDetails['Order']['order_amount'];
			} else {
				$this->data['GenerateInvoice']['overage_amount'] = '0';
			}

			$this->GenerateInvoice->save($this->data);

			$this->Session->write('message', 'Invoice of this order is generated successfully.');
			$this->redirect('/admin/generate_invoices/index');
		}
	} //end function admin_generateInvoice()

	/*
	 *CLIENT FUNCTION STARTS HERE BY Deepshikha Jain
	 */

	function pay_as_you_go($id = null) {
		global $default_discount;
		global $overage_amount;
		global $cardno;

		$this->layout = "client_inner";
		$this->set('active', "order");
		$this->userLoginCheck();
		$errorMessage = "";

		$deliveryInfo1 = $this->WeighProduct->find("all", array (
			"conditions" => array (
				"WeighProduct.status= '1'"
			),
			"fields" => array (
				"WeighProduct.id",
				"WeighProduct.product_name",
				"WeighProduct.product_weight"
			)
		));
		$this->set("deliveryInfo1", $deliveryInfo1);

		$configDetails = $this->Configuration->find("first", array (
			"conditions" => "Configuration.id='1'",
			null
		));

		$userAddress = $this->User->find("list", array (
			"conditions" => array (
				"User.id = " . $this->Session->read('user_id')
			),
			"fields" => array (
				"User.id",
				"User.address"
			)
		));
		$this->set("address", $userAddress);

		$userInfo = $this->User->find("first", array (
			"conditions" => "User.id = '" . $this->Session->read('user_id') . "'"
		));
		$this->set("userInfo", $userInfo);

		$pickupInfo = $this->UserLocation->find("list", array (
			"conditions" => array (
				"UserLocation.user_id = '" . $this->Session->read('user_id') . "'",
				"UserLocation.address_type = 'Pickup'"
			),
			"fields" => array (
				"UserLocation.address"
			)
		));
		//echo '<pre>';print_r($pickupInfo);exit;
		$this->set("pickupInfo", $pickupInfo);

		$deliveryInfo = $this->UserLocation->find("list", array (
			"conditions" => array (
				"UserLocation.user_id = '" . $this->Session->read('user_id') . "'",
				"UserLocation.address_type = 'Delivery'"
			),
			"fields" => array (
				"UserLocation.address"
			)
		));
		$this->set("deliveryInfo", $deliveryInfo);

		if ($this->data) {
			//echo '<pre>';print_r($_POST);
			//echo '<pre>';print_r($this->data);exit;
			if (empty ($this->data['Order']['pickup_date'])) {
				$errorMessage .= "- Please Enter Pickup Date.<br>";
			}
			if (empty ($this->data['Order']['delivery_date'])) {
				$errorMessage .= "- Please Enter Delivery Date.<br>";
			}

			if (isset ($errorMessage) && $errorMessage != "") {
				$this->Session->write("message", $errorMessage);
			} else {


                            //this will calculate total weight of items and save into orders
                                if(isset($id) && $id!=''){				
                                    $count_weight = 0;
                                    for ($i = 0; $i <= count($_POST['vipInfo2']); $i++) {
                                            $count_weight = $count_weight + $_POST['vipInfo2'][$i];
                                    }
                                    $count_weight = $count_weight + $this->data['Order']['order_oldweight'];
                                } else{
                                    $count_weight = 0;
                                    for ($i = 0; $i <= count($_POST['vipInfo2']); $i++) {
                                            $count_weight = $count_weight + $_POST['vipInfo2'][$i];
                                    }
                                }

				/*code for giving discount with coupon code will be used when weight calculator part will be done
				 * order amount will be calculated
				 * when weight calculator will be implemented
				 * after order amount, discounted order amount will be calculated.
				 * so this is static for now.
				 */

				//by deepshikha on 29th june $this->data['Order']['order_amount'] = ($count_weight)*$overage_amount;

				$this->data['Order']['order_amount'] = $configDetails['Configuration']['authorize_amount'];

				if (!empty ($this->data['Order']['discount_coupon_code'])) {
					$couponInfo = $this->CouponCode->find("first", array (
						"conditions" => array (
							"CouponCode.coupon_code = '" . $this->data['Order']['discount_coupon_code'] . "'"
						),
						null
					));

					if ($couponInfo['CouponCode']['status'] == '1' && $couponInfo['CouponCode']['coupon_used_status'] == 'Not Used') {
						$this->data['Order']['discounted_order_amount'] = (($this->data['Order']['order_amount']) * $default_discount) / 100;
					} else {
						$this->data['Order']['discounted_order_amount'] = $this->data['Order']['order_amount'];
						$this->Session->write("message", 'This coupon is already used.');
						$this->redirect('/orders/pay_as_you_go/');
					}

				} else
					if (empty ($this->data['Order']['discount_coupon_code']) && !empty ($userInfo['User']['coupon_code'])) {
						$couponInfo = $this->CouponCode->find("first", array (
							"conditions" => array (
								"CouponCode.coupon_code = '" . $userInfo['User']['coupon_code'] . "'"
							),
							null
						));

						if ($couponInfo['CouponCode']['status'] == '0' && $couponInfo['CouponCode']['coupon_used_status'] == 'Used') {
							$this->data['Order']['discounted_order_amount'] = (($this->data['Order']['order_amount']) * $default_discount) / 100;
						} else {
							$this->data['Order']['discounted_order_amount'] = $this->data['Order']['order_amount'];
						}

					} else {
						$this->data['Order']['discounted_order_amount'] = $this->data['Order']['order_amount'];
					}

				$this->data['Order']['order_type'] = 'Pay As You Go';
				$this->data['Order']['user_id'] = $this->Session->read('user_id');
				$this->data['Order']['delivery_date'] = date('Y-m-d', strtotime($this->data['Order']['delivery_date']));
				$this->data['Order']['pickup_date'] = date('Y-m-d', strtotime($this->data['Order']['pickup_date']));
				$this->data['Order']['order_date'] = date('Y-m-d H:i:s');
				$this->data['Order']['status'] = '1';
				$this->data['Order']['id'] = $id;
				$this->Order->save($this->data);

				$this->CouponCode->query("UPDATE coupon_codes SET coupon_used_status = 'Used', status = '0' WHERE coupon_code = '" . $this->data['Order']['discount_coupon_code'] . "'");

				$this->Reference->query("UPDATE references SET purchase_confirmation = '1', date_confirmed_purchase = '" . date('Y-m-d H:i:s') . "' WHERE coupon_code = '" . $this->data['Order']['discount_coupon_code'] . "'");

				$this->User->query("UPDATE users SET coupon_code = '' WHERE id = '" . $this->Session->read('user_id') . "'");

				$form_order_id = $cardno . str_pad($this->Order->id, 5, "0", STR_PAD_LEFT);
				$this->data['Order']['id'] = $this->Order->id;
				$this->data['Order']['order_no'] = $form_order_id;
				$orderNoArray = array ();
				$orderNoArray['Order']['id'] = $this->data['Order']['id'];
				$orderNoArray['Order']['order_no'] = $this->data['Order']['order_no'];

				$this->Order->save($orderNoArray);

				$orderid = $this->Order->id;


                               //code for saving data into order items table
                                for ($i = 0; $i < count($_POST['vipInfo']); $i++) {
                                                $item_weightid = explode("-", $_POST['vipInfo'][$i]);
                                                $this->data['OrderItem']['product_weight_id'] = $item_weightid[0];
						$this->data['OrderItem']['item_weight'] = $item_weightid[1];
                                                $this->data['OrderItem']['item_quantity'] = $_POST['vipInfo1'][$i];
                                                $this->data['OrderItem']['total_weight'] = $_POST['vipInfo2'][$i];
                                                $this->data['OrderItem']['user_id'] = $this->Session->read('user_id');
                                                $this->data['OrderItem']['order_id'] = $orderid;
                                                $this->data['OrderItem']['status'] = '1';
                                                $this->OrderItem->save($this->data);
                                                $this->OrderItem->id = '';
				}
                                //ends here
                                
                            

				if (empty ($id) || $id == 0) {
					$this->data['OrdersPayAsYouGoUser']['order_id'] = $orderid;
					$this->data['OrdersPayAsYouGoUser']['total_weight'] = $count_weight;
					$this->data['OrdersPayAsYouGoUser']['payment_status'] = 'Pending';

					$this->OrdersPayAsYouGoUser->save($this->data);
				}else{
                                        $this->data['OrdersPayAsYouGoUser']['total_weight'] = $count_weight;
                                        $this->OrdersPayAsYouGoUser->query("UPDATE orders_pay_as_you_go_users SET total_weight = '" . $count_weight . "' WHERE order_id = '" . $id . "'");
                                }

				$this->Session->write("message", "Order Confirmation");
				$this->redirect('/orders/payment_preview_payasugo/' . $this->Order->id);
			}
		} else {
			if (isset ($id)) {
				$this->Order->id = $id;
				$this->data = $this->Order->read();
                                $this->set('id',$id);
                                $orderitemdetails = $this->OrderItem->find("all", array ("conditions" => array ("OrderItem.order_id = " . $id),null));
                                $this->set('orderitemdetails',$orderitemdetails);
                                //echo '<pre>';print_r($orderitemdetails);exit;
			}
		}
	}

	function order_schedule_subscribed_plan($id = null) {
		//echo $id;exit;
		$this->layout = "client_inner";
		$this->set('active', "order");
		$this->userLoginCheck();
		$errorMessage = "";

		$userAddress = $this->User->find("list", array (
			"conditions" => array (
				"User.id = " . $this->Session->read('user_id')
			),
			"fields" => array (
				"User.id",
				"User.address"
			)
		));
		$this->set("address", $userAddress);

		$paymentstatusinfo = $this->ReguserOrder->find("first", array (
			"conditions" => array (
				"ReguserOrder.user_id = " . $this->Session->read('user_id'),
				"ReguserOrder.payment_status = 'Confirm'",
				"ReguserOrder.status = '1'"
			),
			'order' => 'ReguserOrder.id DESC',
			"limit" => "1"
		));
		$this->set('paymentstatusinfo', $paymentstatusinfo);

		$pickupInfo = $this->UserLocation->find("list", array (
			"conditions" => array (
				"UserLocation.user_id = '" . $this->Session->read('user_id') . "'",
				"UserLocation.address_type = 'Pickup'"
			),
			"fields" => array (
				"UserLocation.address"
			)
		));
		//echo '<pre>';print_r($pickupInfo);exit;
		$this->set("pickupInfo", $pickupInfo);

		$deliveryInfo = $this->UserLocation->find("list", array (
			"conditions" => array (
				"UserLocation.user_id = '" . $this->Session->read('user_id') . "'",
				"UserLocation.address_type = 'Delivery'"
			),
			"fields" => array (
				"UserLocation.address"
			)
		));
		$this->set("deliveryInfo", $deliveryInfo);

		if ($this->data) {

			if (empty ($this->data['Order']['pickup_date'])) {
				$errorMessage .= "- Please Enter Pickup Date.<br>";
			}
			if (empty ($this->data['Order']['delivery_date'])) {
				$errorMessage .= "- Please Enter Delivery Date.<br>";
			}

			if (isset ($errorMessage) && $errorMessage != "") {
				$this->Session->write("message", $errorMessage);
			} else {

				$this->data['Order']['user_id'] = $this->Session->read('user_id');
				$this->data['Order']['order_type'] = 'Subscription';
				$this->data['Order']['order_date'] = date('Y-m-d H:i:s');
				$this->data['Order']['delivery_date'] = date('Y-m-d', strtotime($this->data['Order']['delivery_date']));
				$this->data['Order']['pickup_date'] = date('Y-m-d', strtotime($this->data['Order']['pickup_date']));
				$this->data['Order']['status'] = '1';

				$this->Session->write("order_sumry", $this->data);
				$this->Session->write("message", "Order Confirmation");
				$this->redirect('/orders/payment_preview/' . $this->Order->id);
			}
		} else {
			$this->Order->id = $id;
			$this->data = $_SESSION['order_sumry'];
		}
	}

	function payment_preview($order_id = null) {
		$this->layout = "client_inner";
		$this->set('active', "");
		$this->userLoginCheck();
		$errorMessage = "";

		$userAddress = $this->User->find("first", array (
			"conditions" => array (
				"User.id = " . $this->Session->read('user_id')
			)
		));
		$this->set("userAddress", $userAddress);

		$userInfo = $this->Session->read('order_sumry');
		$this->set("userInfo", $userInfo);
	}

	function payment_preview_payasugo($order_id = null) {
		$this->layout = "client_inner";
		$this->set('active', "");
		$this->userLoginCheck();
		$errorMessage = "";

		$userAddress = $this->User->find("first", array ("conditions" => array ("User.id = " . $this->Session->read('user_id'))));
                $this->set("userAddress", $userAddress);
		if (isset ($order_id)) {

			$this->Order->id = $order_id;

			$userInfo = $this->Order->read();
                        $this->set("userInfo", $userInfo);
                        
                        $ordereditemInfo = $this->OrderItem->find("all", array ("conditions" => array ("OrderItem.order_id = " . $order_id)));
                        $this->set("ordereditemInfo", $ordereditemInfo);                        
			
		}
	}

	function payment($order_id = null) {
		$this->layout = "client_inner";
		$this->set('active', "");
		$this->userLoginCheck();
		$errorMessage = "";

		$userAddress = $this->User->find("first", array (
			"conditions" => array (
				"User.id = " . $this->Session->read('user_id')
			)
		));

		$this->set("userAddress", $userAddress);


                $ordereditemInfo = $this->OrderItem->find("all", array ("conditions" => array ("OrderItem.order_id = " . $order_id)));
                $this->set("ordereditemInfo", $ordereditemInfo);         

		$configDetails = $this->Configuration->find("first", array (
			"conditions" => "Configuration.id='1'",
			null
		));

		if ($configDetails['Configuration']['payment_mode'] == "sandbox") {
			$environment = "sandbox";
		} else {
			$environment = "";
		}

		if (isset ($order_id)) {
			$userInfo = $this->Order->find("first", array (
				"conditions" => array (
					"Order.user_id = " . $this->Session->read('user_id'),
					"Order.id = " . $order_id
				)
			));
			$this->set("userInfo", $userInfo);

			if (isset ($configDetails['Configuration']['authorize_amount']) && $configDetails['Configuration']['authorize_amount'] != '0.00') {
				$paymentType = urlencode('Sale'); // Authorization or 'Sale'
				$firstName = urlencode($userAddress['User']['first_name']);
				$lastName = urlencode($userAddress['User']['last_name']);
				$creditCardType = urlencode($userAddress['User']['card_type']);
				$creditCardNumber = urlencode($userAddress['User']['card_number']); //$userInfo['PayAsYouGoOrder']['card_number']
				$expDateMonth = $userAddress['User']['expiration_card_month'];
				// Month must be padded with leading zero
				$padDateMonth = urlencode(str_pad($expDateMonth, 2, '0', STR_PAD_LEFT));

				$expDateYear = urlencode($userAddress['User']['expiration_card_year']); //$userInfo['PayAsYouGoOrder']['expiration_card_year']
				$cvv2Number = urlencode($userAddress['User']['card_number_cvv']); //$userInfo['PayAsYouGoOrder']['card_number_cvv']
				$address1 = urlencode($userAddress['User']['billing_address']); //$userInfo['PayAsYouGoOrder']['billing_address']
				$address2 = "";
				$city = urlencode($userAddress['User']['billing_city']); //$userInfo['PayAsYouGoOrder']['billing_city']
				$state = urlencode('test state'); //$userInfo['PayAsYouGoOrder']['expiration_card_month']
				$zip = urlencode($userAddress['User']['billing_zip']); //$userInfo['PayAsYouGoOrder']['billing_zip']
				$country = urlencode('US'); // US or other valid country code
				$amount = urlencode($configDetails['Configuration']['authorize_amount']); //$userInfo['PayAsYouGoOrder']['expiration_card_month']
				$currencyID = urlencode('USD'); // or other currency ('GBP', 'EUR', 'JPY', 'CAD', 'AUD')

				// Add request-specific fields to the request string.
				$nvpStr = "&PAYMENTACTION=$paymentType&AMT=$amount&CREDITCARDTYPE=$creditCardType&ACCT=$creditCardNumber" .
				"&EXPDATE=$padDateMonth$expDateYear&CVV2=$cvv2Number&FIRSTNAME=$firstName&LASTNAME=$lastName" .
				"&STREET=$address1&CITY=$city&STATE=$state&ZIP=$zip&COUNTRYCODE=$country&CURRENCYCODE=$currencyID";

				$httpParsedResponseAr = $this->Common->PPHttpPost('DoDirectPayment', $nvpStr);

				//echo "<pre>";print_r($httpParsedResponseAr);exit;
				$authorizationID = $httpParsedResponseAr['TRANSACTIONID'];

				$amount = urlencode('1');
				$currency = urlencode('USD'); // or other currency ('GBP', 'EUR', 'JPY', 'CAD', 'AUD')
				$completeCodeType = urlencode('Complete'); // or 'NotComplete'
				$invoiceID = urlencode('');
				$note = urlencode('');
				$nvpStrCap = "&AUTHORIZATIONID=$authorizationID&AMT=$amount&COMPLETETYPE=$completeCodeType&CURRENCYCODE=$currency&NOTE=$note";

				// Execute the API operation; see the PPHttpPost function above.
				$httpParsedResponseArCapture = $this->Common->capture('DoCapture', $nvpStrCap, $environment);
			} //end if amount not equal to zero
			/*by deepshikha*/
			$query_update = "UPDATE orders_pay_as_you_go_users SET payment_status='Confirm',status='1',transaction_id='" . $authorizationID . "' WHERE order_id = '" . $order_id . "'";
			mysql_query($query_update) or die(mysql_error());

			$this->Order->sendGenerateOrderEmail($userAddress["User"]["email_address"], $order_id);

			//echo "<pre>";pr($httpParsedResponseArCapture);exit;

			$this->Session->write("message", "Your order has been placed.  You just saved a few hours of work with a few clicks of a mouse!");

		}
	} //end function payment()

	function completeorder() {

		$this->layout = "client_inner";
		$this->set('active', "");
		$this->userLoginCheck();
		$errorMessage = "";

		$paymentstatusinfo = $this->ReguserOrder->find("first", array (
			"conditions" => array (
				"ReguserOrder.user_id = " . $this->Session->read('user_id'),
				"ReguserOrder.payment_status = 'Confirm'",
				"ReguserOrder.status = '1'"
			),
			'order' => 'ReguserOrder.id DESC',
			"limit" => "1"
		));
		$this->set('paymentstatusinfo', $paymentstatusinfo);

		$this->Order->save($_SESSION['order_sumry']);

		$orderid = $this->Order->id;

		$this->Session->delete('order_sumry'); //deletes all data from session
		//to generate a unique order number
		global $cardno;
		$form_order_id = $cardno . str_pad($orderid, 5, "0", STR_PAD_LEFT);
		$this->data['Order']['id'] = $orderid;
		$this->data['Order']['order_no'] = $form_order_id;
		$orderNoArray = array ();
		$orderNoArray['Order']['id'] = $this->data['Order']['id'];
		$orderNoArray['Order']['order_no'] = $this->data['Order']['order_no'];

		$this->Order->save($orderNoArray);

		$this->data['OrdersSubscribedPlansUser']['order_id'] = $orderid;
		$this->data['OrdersSubscribedPlansUser']['plan_id'] = $paymentstatusinfo['ReguserOrder']['id'];
		$this->data['OrdersSubscribedPlansUser']['status'] = '1';
		$this->OrdersSubscribedPlansUser->save($this->data);

		$userAddress = $this->User->find("first", array (
			"conditions" => array (
				"User.id = " . $this->Session->read('user_id')
			)
		));
		$this->set("userAddress", $userAddress);

		$maximum_usage = $paymentstatusinfo['ReguserOrder']['total_usage'];
		$this->set('maximum_usage', $maximum_usage);

		$query_orderinfo = "SELECT order_id, plan_id, SUM(total_weight) FROM orders_subscribed_plans_users WHERE plan_id = '" . $paymentstatusinfo['ReguserOrder']['id'] . "' GROUP BY plan_id";
		$result_orderinfo = mysql_query($query_orderinfo) or die(mysql_error());
		$row_orderinfo = mysql_fetch_assoc($result_orderinfo);

		if (isset ($orderid)) {
			$userInfo = $this->Order->find("first", array (
				"conditions" => array (
					"Order.user_id = " . $this->Session->read('user_id'),
					"Order.id = " . $orderid
				)
			));
			$this->set("userInfo", $userInfo);

			$this->ReguserOrder->query("UPDATE reguser_orders SET used_usage = '" . $paymentstatusinfo['ReguserOrder']['used_usage'] . "' + '" . $row_orderinfo['SUM(total_weight)'] . "', WHERE id = '" . $paymentstatusinfo['ReguserOrder']['id'] . "'");

			$this->Order->sendGenerateOrderEmail($userAddress["User"]["email_address"], $orderid);

			$this->Session->write("message", "Your order has been placed.  You just saved a few hours of work with a few clicks of a mouse!");
		}

	} //end function completeorder()

	

	function vieworderdetail($orderid = null) {
		$this->layout = "client_inner";
		$this->userLoginCheck();
		$userorderDetails = $this->Order->find("first", array (
			"conditions" => array (
				"Order.id = " . $orderid
			)
		));
		$this->set("userorderDetails", $userorderDetails);

		$userAddress = $this->User->find("first", array (
			"conditions" => array (
				"User.id = " . $this->Session->read('user_id')
			),
			"fields" => array (
				"User.id",
				"User.address"
			)
		));
		$this->set("userAddress", $userAddress);


                $ordereditemInfo = $this->OrderItem->find("all", array ("conditions" => array ("OrderItem.order_id = " . $orderid)));
                $this->set("ordereditemInfo", $ordereditemInfo);
	} //end function vieworderdetail()

	/*paging for my orders*/

	function myorder() {
		$this->layout = "client_inner";
		$this->set("title_for_layout", "Find a Friend");

		$msgString = '';

		$condition = array ();
		$condition[] = "Order.user_id = " . $this->Session->read('user_id');
		$separator = array ();
		$urlSeparator = array ();

		$separator = implode("/", $separator);

		if (!empty ($this->passedArgs)) {
			if (isset ($this->passedArgs["page"])) {
				$urlSeparator[] = 'page:' . $this->passedArgs["page"];
			}
			if (isset ($this->passedArgs["sort"])) {
				$urlSeparator[] = 'sort:' . $this->passedArgs["sort"];
			}
			if (isset ($this->passedArgs["direction"])) {
				$urlSeparator[] = 'direction:' . $this->passedArgs["direction"];
			}
		}

		$urlSeparator = implode("/", $urlSeparator);

		$this->set('separator', $separator);
		$this->set('urlSeparator', $urlSeparator);

		$this->paginate['Order'] = array (
			'order' => array (
				'Order.id' => 'DESC'
			),
			'limit' => '10'
		);
		$this->set('userorderInfo', $this->paginate('Order', $condition));

	} //end function searchzip()

	function test() {
		$this->layout = "client_inner";

		$deliveryInfo1 = $this->WeighProduct->find("all", array ("conditions" => array ("WeighProduct.status= '1'"),'order' => 'WeighProduct.product_name ASC',"fields" => array ("WeighProduct.id","WeighProduct.product_name","WeighProduct.product_weight")));
		//echo '<pre>';print_r($deliveryInfo1);exit;
		$this->set("deliveryInfo1", $deliveryInfo1);
		//echo '<pre>';print_r($_POST);exit;
		//if(isset($_POST) && !empty($_POST)){

		//}
	}


        function deleteitems($id = NULL, $order_id = NULL) {
		if ($id > 0) {
                        $this->OrderItem->id = $id;
			$itemInfo = $this->OrderItem->read();
                        $this->OrdersPayAsYouGoUser->query("UPDATE orders_pay_as_you_go_users SET total_weight = '" . $itemInfo['OrdersPayAsYouGoUser']['total_weight'] . "' - '" . $itemInfo['OrderItem']['total_weight'] . "' WHERE order_id = '" . $order_id . "'");
                        //echo '<pre>';print_r($itemInfo);exit;
			$this->OrderItem->delete($id);
			$this->viewPath = 'elements' . DS . 'admin';
			$this->Session->write('message', 'Item deleted successfully.');
			$this->render('blank_delete');
			$this->redirect('/orders/pay_as_you_go/'.$order_id);
		}
	} //end of admin_deleteUser

}
?>
