<?php

/*
 * by
 * Deepshikha Jain
 */
class OrdersController extends AppController {
	var $name = "Orders";
	var $uses = array (
		"User",
		"OrdersPayAsYouGoUser",
		"SubscriptionPlan",
		"ReguserOrder",
		"Order",
		"OrdersSubscribedPlansUser",
		"Configuration",
		"GenerateInvoice",
		"Discountcoupon",
		"Reference",
		"UserLocation",
		"WeighProduct",
		"OrderItem",
                "ShippingCharge"
	);
	var $helpers = array (
		'Html',
		'Form',
		'Javascript',
		'Ajax',
		'Time'
	);
	var $paginate = array (
		'limit' => '50',
		'page' => '1',
		'order' => array (
			'Order.id' => 'desc'
		)
	);
	var $components = array (
		'RequestHandler',
		"Logincheck",
		"Common"
	);

	function beforeFilter() {
		$loggedAdminId = $this->Session->read("adminid");
		if (isset ($this->params['admin']) && $this->params['admin'] && !$loggedAdminId) {
			$this->redirect("/admin/admins/login");
		}
	}

	/*admin function starts here
	* by deepshikha
	*
	*/
	function admin_index($id = null,$created = null, $toDate = null) {

		$this->layout = "admin";
		//	$this->set("expand_menu_links","testimonial");
		$condition = array ();
		$separator = array ();
		$urlSeparator = array ();

		$urlSeparator = implode("/", $urlSeparator);

		$this->set('separator', $separator);
		$this->set('urlSeparator', $urlSeparator);

		if (!empty ($this->data)) {

			if (isset ($this->data['Order']['search_order']) && $this->data['Order']['search_order'] != '') {
				$orderName = trim($this->data['Order']['search_order']);
			}

			if (isset ($this->data['Order']['action'])) {

				$idList = $this->data['Order']['idList'];
				if ($idList) {
					if ($this->data['Order']['action'] == "activate") {
						$cnd = array (
							"Order.id IN ($idList) "
						);
						$this->Order->updateAll(array (
							'Order.status' => "'1'"
						), $cnd);
					}
					elseif ($this->data['Order']['action'] == "deactivate") {
						$cnd = array (
							"Order.id IN ($idList) "
						);
						$this->Order->updateAll(array (
							'Order.status' => "'0'"
						), $cnd);
					}
					elseif ($this->data['Order']['action'] == "delete") {
						$cnd = array (
							"Order.id IN ($idList) "
						);
						$this->Order->deleteAll($cnd);
					}
				}
			}
		}
		elseif (!empty ($this->params)) {
			if (isset ($this->params['named']['search_order']) && $this->params['named']['search_order'] != '') {
				$orderName = trim($this->params['named']['search_order']);
			}
		}

		if (isset ($orderName) && $orderName != '') {
			$separator[] = 'order_type:' . $orderName;
			$condition[] = " (Order.order_type like '%" . $orderName . "%') ";
		}

                $todate = date("Y-m-d");
                if (isset ($id) && $id != '') {
			$separator[] = 'delivery_date:' . $todate;
			$condition[] = " (Order.delivery_date like '%" . $todate . "%') ";
		}

		$this->set('orders', $this->paginate('Order', $condition));

		if ($this->RequestHandler->isAjax()) {
			$this->layout = '';
			$this->viewPath = 'elements' . DS . 'admin/orders/';
			$this->render('index');
		}
	} //end of function index()

	function admin_deleteorders($id = NULL) {
		if ($id > 0) {
			$this->Order->delete($id);
			$this->viewPath = 'elements' . DS . 'admin';
			$this->Session->write('message', 'Order details deleted successfully.');
			$this->render('blank_delete');
			$this->redirect('/admin/orders/index');
		}
	} //end of admin_deleteUser

	function admin_deactivateOrder($id = NULL) {
		if ($id > 0) {
			$cnd = array (
				"Order.id = $id"
			);
			$this->Order->updateAll(array (
				'Order.status' => "'0'"
			), $cnd);
			$this->set('action', '/admin/orders/activateOrder/' . $id);
			$this->set('id', $id);
			$this->set('status', 0);
			$this->viewPath = 'elements' . DS . 'admin';
			$this->Session->write('message', 'Order details Deactivated successfully.');
			$this->render('update_status');
			$this->redirect('/admin/orders/index');
		}

	}

	function admin_activateOrder($id = NULL) {
		if ($id > 0) {
			$cnd = array ("Order.id = $id");
			$this->Order->updateAll(array ('Order.status' => "'1'"), $cnd);
			$this->set('action', '/admin/orders/deactivateOrder/' . $id);
			$this->set('id', $id);
			$this->set('status', 1);
			$this->viewPath = 'elements' . DS . 'admin';
			$this->Session->write('message', 'Order details Activated successfully.');
			$this->render('update_status');
			$this->redirect('/admin/orders/index');
		}
	} //end of admin_activateCustomer

	function admin_editOrders($id = NULL) { //echo '<pre>';print_r($this->data);exit;
		$this->layout = "admin";
		$msgString = '';
		$conditions = array ();
		$this->Order->id = $id;
		$orderDetails = $this->Order->read();
		$this->set('oldweight', $orderDetails['OrdersSubscribedPlansUser']['total_weight']);

                $configDetails = $this->Configuration->find("first", array (
			"conditions" => "Configuration.id='1'",
			null
		));


                $userInfo = $this->User->find("first", array (
			"conditions" => "User.id='".$orderDetails['Order']['user_id']."'",
			null
		));


		global $minimum_usage;
		global $overage_amount;

		if ($this->data) {
			//echo '<pre>';print_r($this->data);exit;
			$paymentstatusinfo = $this->ReguserOrder->find("first", array ("conditions" => array ("ReguserOrder.user_id = " . $this->data['Order']['user_id'],"ReguserOrder.payment_status = 'Confirm'","ReguserOrder.status = '1'"),'order' => 'ReguserOrder.id DESC',"limit" => "1"));

			if (isset ($this->data['Order']['order_amount']) && (!empty ($this->data['Order']['order_amount'])) && (!empty ($orderDetails['Order']['discount_coupon_code']))) {
				$this->data['Order']['discounted_order_amount'] = (($this->data['Order']['order_amount']) * ($configDetails['Configuration']['coupon_discount'])) / 100;
			}

			if (isset ($this->data['OrdersPayAsYouGoUser']['total_weight']) && !empty ($this->data['OrdersPayAsYouGoUser']['total_weight'])) {
				$this->data['Order']['order_amount'] = ($this->data['OrdersPayAsYouGoUser']['total_weight']) * $overage_amount;
			}

			/*
			 * Conditions for total weight & overages
			 * and calculates order amount
			 * by deepshikha
			 * on 14th june 2011
			 */
			if (isset ($this->data['OrdersSubscribedPlansUser']['total_weight']) && !empty ($this->data['OrdersSubscribedPlansUser']['total_weight'])) {

				if (($this->data['OrdersSubscribedPlansUser']['total_weight'] >= $minimum_usage) && $this->data['OrdersSubscribedPlansUser']['total_weight'] > ($paymentstatusinfo['ReguserOrder']['total_usage'] - $paymentstatusinfo['ReguserOrder']['used_usage'])) {
					//echo 'condition 1 if total>15 and total>remaining';exit;
					$this->data['Order']['order_amount'] = ($this->data['OrdersSubscribedPlansUser']['total_weight'] - ($paymentstatusinfo['ReguserOrder']['total_usage'] - $paymentstatusinfo['ReguserOrder']['used_usage'])) * $overage_amount;
				} else
					if ($this->data['OrdersSubscribedPlansUser']['total_weight'] > ($paymentstatusinfo['ReguserOrder']['total_usage'] - $paymentstatusinfo['ReguserOrder']['used_usage']) && $this->data['OrdersSubscribedPlansUser']['total_weight'] <= $minimum_usage) {
						//echo 'condition 2 if total>remaining and total<=15';
						$this->data['Order']['order_amount'] = ($minimum_usage - ($paymentstatusinfo['ReguserOrder']['total_usage'] - $paymentstatusinfo['ReguserOrder']['used_usage'])) * $overage_amount;
					} else
						if ($this->data['OrdersSubscribedPlansUser']['total_weight'] == ($paymentstatusinfo['ReguserOrder']['total_usage'] - $paymentstatusinfo['ReguserOrder']['used_usage']) && $this->data['OrdersSubscribedPlansUser']['total_weight'] < $minimum_usage) {
							//echo 'condition 3 total == remaining and total<15';exit;
							$this->data['Order']['order_amount'] = ($minimum_usage - ($this->data['OrdersSubscribedPlansUser']['total_weight'])) * $overage_amount;                                                        
						} else
							if ($this->data['OrdersSubscribedPlansUser']['total_weight'] < ($paymentstatusinfo['ReguserOrder']['total_usage'] - $paymentstatusinfo['ReguserOrder']['used_usage']) && $this->data['OrdersSubscribedPlansUser']['total_weight'] < $minimum_usage && ($paymentstatusinfo['ReguserOrder']['total_usage'] - $paymentstatusinfo['ReguserOrder']['used_usage']) < $minimum_usage) {
								//echo 'condition 4 total < remaining and total<15';exit;
								$this->data['Order']['order_amount'] = ($minimum_usage - ($paymentstatusinfo['ReguserOrder']['total_usage'] - $paymentstatusinfo['ReguserOrder']['used_usage'])) * $overage_amount;
							}

			}

			$this->Order->save($this->data);

			if ($this->data['Order']['order_type'] == 'Pay As You Go') {
				$this->OrdersPayAsYouGoUser->query("UPDATE orders_pay_as_you_go_users SET payment_status = '" . $this->data['OrdersPayAsYouGoUser']['payment_status'] . "', total_weight = '" . $this->data['OrdersPayAsYouGoUser']['total_weight'] . "' WHERE order_id = '" . $id . "'");
			} else {

				if ($this->data['OrdersSubscribedPlansUser']['total_weight'] < $minimum_usage && $this->data['OrdersSubscribedPlansUser']['total_weight'] != '0') { //echo 'total weight is right';exit;
					$this->data['OrdersSubscribedPlansUser']['total_weight'] = $minimum_usage;
				}

				$this->OrdersSubscribedPlansUser->query("UPDATE orders_subscribed_plans_users SET total_weight = '" . $this->data['OrdersSubscribedPlansUser']['total_weight'] . "' WHERE order_id = '" . $id . "'");

				$updated_weight = $this->data['OrdersSubscribedPlansUser']['total_weight'] - $this->data['Order']['old_weight'];

				$querypaymentinfo = "UPDATE reguser_orders SET used_usage = '" . $paymentstatusinfo['ReguserOrder']['used_usage'] . "' + '" . $updated_weight . "', payment_status = '" . $this->data['ReguserOrder']['payment_status'] . "' where id='" . $paymentstatusinfo['ReguserOrder']['id'] . "' AND status='1'";
				$resultpaymentinfo = mysql_query($querypaymentinfo) or die(mysql_error());

			}

   /*condition by deepshikha on 20110811
    * for sending notification
    * either via sms or email
    */
                            if($userInfo["User"]["notify_by"] == 'Sms'){

                                $ph = explode('-', $userInfo['User']['phone']);
                                $phone = $ph[0].$ph[1].$ph[2];

                                $this->Order->sendOrderStatusSms($phone,$id,$userInfo["User"]["first_name"]);
                            }
                            else if($userInfo["User"]["notify_by"] == 'Email'){
                                $this->Order->sendOrderStatusEmail($orderDetails["Order"]["user_id"], $id);
                            }

			$this->Session->write('message', 'Order details updated successfully.');
			$this->redirect('/admin/orders/index');

		} //end if($this->data){

		else {
			$this->Order->id = $id;
			$this->data = $this->Order->read();
		} //end else
	} //end function admin_editOrders($id=NULL)

	function admin_viewOrder($id = NULL) {
		$this->layout = "admin";
		$this->Order->id = $id;
		$orderDetails = $this->Order->read();
                $this->set("orderDetails", $orderDetails);

                $shippingInfo = $this->ShippingCharge->find("first", array ("conditions" => array ("ShippingCharge.order_id = " . $id)));
                $this->set("shippingInfo", $shippingInfo);

                $ordereditemInfo = $this->OrderItem->find("all", array ("conditions" => array ("OrderItem.order_id = " . $id)));
                $this->set("ordereditemInfo", $ordereditemInfo);

	} //end function admin_viewOrder()


        function admin_viewTodayorder($id = NULL) {
		$this->layout = "admin";
		$this->Order->id = $id;
		$orderDetails = $this->Order->read();
                $this->set("orderDetails", $orderDetails);

                $shippingInfo = $this->ShippingCharge->find("first", array ("conditions" => array ("ShippingCharge.order_id = " . $id)));
                $this->set("shippingInfo", $shippingInfo);

                $userInfo = $this->User->find("all", array ("conditions" => array ("User.id = " . $orderDetails['Order']['user_id'])));
                $this->set("userInfo", $userInfo);

                $ordereditemInfo = $this->OrderItem->find("all", array ("conditions" => array ("OrderItem.order_id = " . $id)));
                $this->set("ordereditemInfo", $ordereditemInfo);

	} //end function admin_viewOrder()


         function admin_viewTodayorderPrint($id = NULL) {
		$this->layout = "";
		$this->Order->id = $id;
		$orderDetails = $this->Order->read();
                $this->set("orderDetails", $orderDetails);

                $shippingInfo = $this->ShippingCharge->find("first", array ("conditions" => array ("ShippingCharge.order_id = " . $id)));
                $this->set("shippingInfo", $shippingInfo);

                $userInfo = $this->User->find("all", array ("conditions" => array ("User.id = " . $orderDetails['Order']['user_id'])));
                $this->set("userInfo", $userInfo);

                $ordereditemInfo = $this->OrderItem->find("all", array ("conditions" => array ("OrderItem.order_id = " . $id)));
                $this->set("ordereditemInfo", $ordereditemInfo);

	} //end function admin_viewOrder()


	function admin_viewOrderPrint($id = NULL) {
		$this->layout = "";
		$this->Order->id = $id;
		$orderDetails = $this->Order->read();
		$this->set("orderDetails", $orderDetails);

                $shippingInfo = $this->ShippingCharge->find("first", array ("conditions" => array ("ShippingCharge.order_id = " . $id)));
                $this->set("shippingInfo", $shippingInfo);

                $ordereditemInfo = $this->OrderItem->find("all", array ("conditions" => array ("OrderItem.order_id = " . $id)));
                $this->set("ordereditemInfo", $ordereditemInfo);
	} //end function admin_viewOrder()

	function admin_generateInvoice($id = NULL) {

		$this->layout = "admin";
		$this->Order->id = $id;
		$orderDetails = $this->Order->read();


		$invoiceinfo = $this->GenerateInvoice->find("count", array (
			"conditions" => array (
				"GenerateInvoice.order_id = '" . $id . "'"
			),
			null
		));

                $shippingInfo = $this->ShippingCharge->find("first", array ("conditions" => array ("ShippingCharge.order_id = " . $id)));
                $this->set("shippingInfo", $shippingInfo);

                if($shippingInfo!=''){
                        $this->data['GenerateInvoice']['shipping_charge'] = $shippingInfo['ShippingCharge']['shipping_charge'];
                }

		if ($invoiceinfo > 0) {
			$this->Session->write('message', 'Invoice of this order is already generated.');
			$this->redirect('/admin/generate_invoices/index');
		} else {

			$this->data['GenerateInvoice']['user_id'] = $orderDetails['Order']['user_id'];
			$this->data['GenerateInvoice']['order_id'] = $orderDetails['Order']['id'];
			$this->data['GenerateInvoice']['plan_id'] = $orderDetails['ReguserOrder']['id'];
			$this->data['GenerateInvoice']['purchased_plan_id'] = $orderDetails['ReguserOrder']['plan_id'];
			$this->data['GenerateInvoice']['plan_purchased_date'] = $orderDetails['ReguserOrder']['plan_start_date'];
			$this->data['GenerateInvoice']['plan_expired_date'] = $orderDetails['ReguserOrder']['plan_expire_date'];
			$this->data['GenerateInvoice']['max_weight'] = (float) $orderDetails["ReguserOrder"]['total_usage'];
			$this->data['GenerateInvoice']['total_weight'] = (float) $orderDetails["OrdersSubscribedPlansUser"]['total_weight'];

			if ($orderDetails['Order']['order_amount'] != '') {
				$this->data['GenerateInvoice']['overage_amount'] = $orderDetails['Order']['order_amount'];
			} else {
				$this->data['GenerateInvoice']['overage_amount'] = '0';
			}


			$this->GenerateInvoice->save($this->data);

			$this->Session->write('message', 'Invoice of this order is generated successfully.');
			$this->redirect('/admin/generate_invoices/index');
		}
	} //end function admin_generateInvoice()

	/*
	 *CLIENT FUNCTION STARTS HERE BY Deepshikha Jain
	 */

	function pay_as_you_go($id = null) {

		global $overage_amount;
		global $cardno;

		$this->layout = "client_inner";
		$this->set('active', "order");
		$this->userLoginCheck();
		$errorMessage = "";

                $user_detail = $this->User->find("first", array (
			"conditions" => array (
				"User.id = " . $this->Session->read('user_id')
			)
		));

                // added by devendra 20120405

                if(empty ($user_detail['User']['address']) || empty ($user_detail['User']['city']) || empty ($user_detail['User']['state']) || empty ($user_detail['User']['zip']))
                {
                    $this->Session->write('message',__('Your delivery information is not complete, Kindly fill your delivery info.',true));
                    $this->redirect('/users/account_step2');
                }

		$configDetails = $this->Configuration->find("first", array (
			"conditions" => "Configuration.id='1'",
			null
		));
                $this->set('configDetails',$configDetails);

		$userAddress = $this->User->find("list", array (
			"conditions" => array (
				"User.id = " . $this->Session->read('user_id')
			),
			"fields" => array (
				"User.id",
				"User.address"
			)

		));



		$this->set("address", $userAddress);

		$userInfo = $this->User->find("first", array (
			"conditions" => "User.id = '" . $this->Session->read('user_id') . "'"
		));
		$this->set("userInfo", $userInfo);

		$locationInfo = $this->UserLocation->find("list", array (
			"conditions" => array (
				"UserLocation.user_id = '" . $this->Session->read('user_id') . "'"
			),
			"fields" => array ("UserLocation.address","UserLocation.address")));

		$this->set("locationInfo", $locationInfo);


		if ($this->data) {

			if (empty ($this->data['Order']['pickup_date'])) {
				$errorMessage .= "Please Enter Pickup Date.<br>";
			}
                        elseif(date('l',strtotime($this->data['Order']['pickup_date'])) == 'Sunday')
                        {
                                $errorMessage .= "We are closed on Sunday<br>
                                                  Please select another day for your pickup or delivery.<br>";
                        }

			if (empty ($this->data['Order']['delivery_date'])) {
				$errorMessage .= "Please Enter Delivery Date.<br>";
			}
                        elseif(date('l',strtotime($this->data['Order']['delivery_date'])) == 'Sunday')
                        {
                                $errorMessage .= "We are closed on Sunday<br>
                                                  Please select another day for your pickup or delivery.<br>";
                        }

			if (isset ($errorMessage) && $errorMessage != "") {
				$this->Session->write("message", $errorMessage);
			} else {


				/*code for giving discount with coupon code will be used when weight calculator part will be done
				 * order amount will be calculated
				 * when weight calculator will be implemented
				 * after order amount, discounted order amount will be calculated.
				 * so this is static for now.
				 */

				//by deepshikha on 29th june $this->data['Order']['order_amount'] = ($count_weight)*$overage_amount;

				$this->data['Order']['order_amount'] = $configDetails['Configuration']['authorize_amount'];

				if (!empty ($this->data['Order']['discount_coupon_code'])) {

					$couponInfo = $this->Discountcoupon->find("first", array (
						"conditions" => array (
							"Discountcoupon.coupon_code = '" . $this->data['Order']['discount_coupon_code'] . "'"
						),
						null
					));

                                        $userInfo = $this->User->find("first", array (
						"conditions" => array (
							"User.id = '" . $couponInfo['Discountcoupon']['from_id'] . "'"
						),
						null
					));


                                        //if coupon is for referral
					if ($couponInfo['Discountcoupon']['status'] == '1' && $couponInfo['Discountcoupon']['current_status'] == 'not used' && $couponInfo['Discountcoupon']['discount_percentage']!='0.00' && $couponInfo['Discountcoupon']['discount_amount']=='0.00') {

                                                if($couponInfo['Discountcoupon']['to_email'] == $this->Session->read('user_email') && $couponInfo['Discountcoupon']['coupon_usage'] == 'Single'){  //echo 'first if';exit;
                                                        $this->data['Order']['discounted_order_amount'] = (($this->data['Order']['order_amount']) * ($configDetails['Configuration']['coupon_discount'])) / 100;
                                                        $this->data['Order']['discount_percentage'] = $configDetails['Configuration']['coupon_discount'];
                                                        $this->Discountcoupon->query("UPDATE discountcoupons SET current_status = 'used', status = '0' WHERE coupon_code = '" . $this->data['Order']['discount_coupon_code'] . "'");
                                                        $this->Discountcoupon->sendCouponUsedEmail($userInfo["User"]["email_address"],$userInfo['User']['first_name'],$this->Session->read('user_email'));
                                                }
                                                else if($couponInfo['Discountcoupon']['to_email'] == $this->Session->read('user_email') && $couponInfo['Discountcoupon']['coupon_usage'] == 'Multiple'){ //echo 'first if else';exit;
                                                        $this->data['Order']['discounted_order_amount'] = (($this->data['Order']['order_amount']) * ($couponInfo['Discountcoupon']['discount_percentage'])) / 100;
                                                }
                                                else if($couponInfo['Discountcoupon']['to_email'] == NULL && $couponInfo['Discountcoupon']['coupon_usage'] == 'Single'){ //echo '2 if else';exit;
                                                        $this->data['Order']['discounted_order_amount'] = (($this->data['Order']['order_amount']) * ($couponInfo['Discountcoupon']['discount_percentage'])) / 100;
                                                        $this->Discountcoupon->query("UPDATE discountcoupons SET current_status = 'used', status = '0' WHERE coupon_code = '" . $this->data['Order']['discount_coupon_code'] . "'");
                                                }
                                                else if($couponInfo['Discountcoupon']['to_email'] == NULL && $couponInfo['Discountcoupon']['coupon_usage'] == 'Multiple'){ //echo '3 if else';exit;
                                                        $this->data['Order']['discounted_order_amount'] = (($this->data['Order']['order_amount']) * ($couponInfo['Discountcoupon']['discount_percentage'])) / 100;
                                                }
                                                else{ //echo 'else';exit;
                                                      $this->Session->write("message", 'You are not authorized to use this coupon.');
                                                      $this->redirect('/orders/pay_as_you_go/');
                                                }

					}

                                        //if coupon is created by administrator.

                                        elseif($couponInfo['Discountcoupon']['status'] == '1' && $couponInfo['Discountcoupon']['current_status'] == 'not used' && $couponInfo['Discountcoupon']['discount_percentage']=='0.00' && $couponInfo['Discountcoupon']['discount_amount']!='0.00') {

                                                if($couponInfo['Discountcoupon']['to_email'] == $this->Session->read('user_email') &&  $couponInfo['Discountcoupon']['coupon_usage'] == 'Single'){ //echo '1 if';exit;
                                                        if(($this->data['Order']['order_amount'] - $couponInfo['Discountcoupon']['discount_amount']) > '0.00'){
                                                            $this->data['Order']['discounted_order_amount'] = $this->data['Order']['order_amount'] - $couponInfo['Discountcoupon']['discount_amount'];
                                                        }else{
                                                            $this->data['Order']['discounted_order_amount'] = '0.00';
                                                        }

                                                        $this->Discountcoupon->query("UPDATE discountcoupons SET current_status = 'used', status = '0' WHERE coupon_code = '" . $this->data['Order']['discount_coupon_code'] . "'");
                                                }
                                                else if($couponInfo['Discountcoupon']['to_email'] == $this->Session->read('user_email') &&  $couponInfo['Discountcoupon']['coupon_usage'] == 'Multiple'){ //echo '1 if else';exit;
                                                        if(($this->data['Order']['order_amount'] - $couponInfo['Discountcoupon']['discount_amount']) > '0.00'){
                                                            $this->data['Order']['discounted_order_amount'] = $this->data['Order']['order_amount'] - $couponInfo['Discountcoupon']['discount_amount'];
                                                        }else{
                                                            $this->data['Order']['discounted_order_amount'] = '0.00';
                                                        }
                                                }
                                                else if($couponInfo['Discountcoupon']['to_email'] == NULL && $couponInfo['Discountcoupon']['coupon_usage'] == 'Multiple'){ //echo '2 if else';exit;
                                                        if(($this->data['Order']['order_amount'] - $couponInfo['Discountcoupon']['discount_amount']) > '0.00'){
                                                            $this->data['Order']['discounted_order_amount'] = $this->data['Order']['order_amount'] - $couponInfo['Discountcoupon']['discount_amount'];
                                                        }else{
                                                            $this->data['Order']['discounted_order_amount'] = '0.00';
                                                        }
                                                }
                                                else if($couponInfo['Discountcoupon']['to_email'] == NULL && $couponInfo['Discountcoupon']['coupon_usage'] == 'Single'){ //echo '3 if else';exit;
                                                        if(($this->data['Order']['order_amount'] - $couponInfo['Discountcoupon']['discount_amount']) > '0.00'){
                                                            $this->data['Order']['discounted_order_amount'] = $this->data['Order']['order_amount'] - $couponInfo['Discountcoupon']['discount_amount'];
                                                        }else{
                                                            $this->data['Order']['discounted_order_amount'] = '0.00';
                                                        }
                                                        $this->Discountcoupon->query("UPDATE discountcoupons SET current_status = 'used', status = '0' WHERE coupon_code = '" . $this->data['Order']['discount_coupon_code'] . "'");
                                                }
                                                else{ //echo 'else';exit;
                                                      $this->Session->write("message", 'You are not authorized to use this coupon.');
                                                      $this->redirect('/orders/pay_as_you_go/');
                                                }

					}
                                        else {
						$this->data['Order']['discounted_order_amount'] = $this->data['Order']['order_amount'];
						$this->Session->write("message", 'Coupon is already used.');
						$this->redirect('/orders/pay_as_you_go/');
					}

				} else
					if (empty ($this->data['Order']['discount_coupon_code']) && !empty ($userInfo['User']['coupon_code'])) {
						$couponInfo = $this->Discountcoupon->find("first", array (
							"conditions" => array (
								"Discountcoupon.coupon_code = '" . $userInfo['User']['coupon_code'] . "'"
							),
							null
						));

						if ($couponInfo['Discountcoupon']['status'] == '0' && $couponInfo['Discountcoupon']['current_status'] == 'used' && $couponInfo['Discountcoupon']['discount_percentage']!='0.00') {
							$this->data['Order']['discounted_order_amount'] = (($this->data['Order']['order_amount']) * ($configDetails['Configuration']['coupon_discount'])) / 100;
                                                        $this->data['Order']['discount_percentage'] = $configDetails['Configuration']['coupon_discount'];
						} else {
							$this->data['Order']['discounted_order_amount'] = $this->data['Order']['order_amount'];
						}

					} else {
						$this->data['Order']['discounted_order_amount'] = $this->data['Order']['order_amount'];
					}

				$this->data['Order']['order_type'] = 'Pay As You Go';
                                $this->data['Order']['user_id'] = $this->Session->read('user_id');
				$this->data['Order']['delivery_date'] = date('Y-m-d', strtotime($this->data['Order']['delivery_date']));
				$this->data['Order']['pickup_date'] = date('Y-m-d', strtotime($this->data['Order']['pickup_date']));
				$this->data['Order']['order_date'] = date('Y-m-d H:i:s');
                                $this->data['Order']['order_status'] = 'Scheduled Pickup';
				$this->data['Order']['status'] = '1';
				$this->data['Order']['id'] = $id;
				$this->Order->save($this->data);



				$this->Reference->query("UPDATE references SET purchase_confirmation = '1', date_confirmed_purchase = '" . date('Y-m-d H:i:s') . "' WHERE coupon_code = '" . $this->data['Order']['discount_coupon_code'] . "'");

				$this->User->query("UPDATE users SET coupon_code = '' WHERE id = '" . $this->Session->read('user_id') . "'");

				$form_order_id = $cardno . str_pad($this->Order->id, 5, "0", STR_PAD_LEFT);
				$this->data['Order']['id'] = $this->Order->id;
				$this->data['Order']['order_no'] = $form_order_id;
				$orderNoArray = array ();
				$orderNoArray['Order']['id'] = $this->data['Order']['id'];
				$orderNoArray['Order']['order_no'] = $this->data['Order']['order_no'];

				$this->Order->save($orderNoArray);

				$orderid = $this->Order->id;

                                if (empty ($id) || $id == 0) {
					$this->data['OrdersPayAsYouGoUser']['order_id'] = $orderid;
					$this->data['OrdersPayAsYouGoUser']['payment_status'] = 'Pending';
                                        $this->data['OrdersPayAsYouGoUser']['amount_captured_status'] = 'not captured';
                                        //echo '<pre>';print_r($this->data);exit;
					$this->OrdersPayAsYouGoUser->save($this->data);
				}

				$this->Session->write("message", "Order Confirmation");
				$this->redirect('/orders/payment_preview_payasugo/' . $this->Order->id);
			}
		} else {
			if (isset ($id)) {
				$this->Order->id = $id;
				$this->data = $this->Order->read();
                                $this->set('id',$id);
                                $orderitemdetails = $this->OrderItem->find("all", array ("conditions" => array ("OrderItem.order_id = " . $id),null));
                                $this->set('orderitemdetails',$orderitemdetails);
                                //echo '<pre>';print_r($orderitemdetails);exit;
			}
		}
	} //end function pay_As_you_Go()

	function order_schedule_subscribed_plan($id = null) {
		//echo $id;exit;
		$this->layout = "client_inner";
		$this->set('active', "order");
		$this->userLoginCheck();
		$errorMessage = "";

                $user_detail = $this->User->find("first", array (
			"conditions" => array (
				"User.id = " . $this->Session->read('user_id')
			)
		));

                // added by devendra 20120405

                if(empty ($user_detail['User']['address']) || empty ($user_detail['User']['city']) || empty ($user_detail['User']['state']) || empty ($user_detail['User']['zip']))
                {
                    $this->Session->write('message',__('Your delivery information is not complete, Kindly fill your delivery info.',true));
                    $this->redirect('/users/account_step2');
                }

		$userAddress = $this->User->find("list", array (
			"conditions" => array (
				"User.id = " . $this->Session->read('user_id')
			),
			"fields" => array (
				"User.id",
				"User.address"
			)
		));
		$this->set("address", $userAddress);

		$paymentstatusinfo = $this->ReguserOrder->find("first", array (
			"conditions" => array (
				"ReguserOrder.user_id = " . $this->Session->read('user_id'),
				"ReguserOrder.payment_status = 'Confirm'",
				"ReguserOrder.status = '1'"
			),
			'order' => 'ReguserOrder.id DESC',
			"limit" => "1"
		));
		$this->set('paymentstatusinfo', $paymentstatusinfo);

		$locationInfo = $this->UserLocation->find("list", array (
			"conditions" => array (
				"UserLocation.user_id = '" . $this->Session->read('user_id') . "'"
			),
			"fields" => array ("UserLocation.address","UserLocation.address")));

		$this->set("locationInfo", $locationInfo);

		if ($this->data) {

			if (empty ($this->data['Order']['pickup_date'])) {
				$errorMessage .= "Please Enter Pickup Date.<br>";
			}
                        elseif(date('l',strtotime($this->data['Order']['pickup_date'])) == 'Sunday')
                        {
                                $errorMessage .= "We are closed on Sunday<br>
                                                  Please select another day for your pickup or delivery.<br>";
                        }
                        
			if (empty ($this->data['Order']['delivery_date'])) {
				$errorMessage .= "Please Enter Delivery Date.<br>";
			}
                        elseif(date('l',strtotime($this->data['Order']['delivery_date'])) == 'Sunday')
                        {
                                $errorMessage .= "We are closed on Sunday<br>
                                                  Please select another day for your pickup or delivery.<br>";
                        }

			if (isset ($errorMessage) && $errorMessage != "") {
				$this->Session->write("message", $errorMessage);
			} else {

				$this->data['Order']['user_id'] = $this->Session->read('user_id');
				$this->data['Order']['order_type'] = 'Subscription';
				$this->data['Order']['order_date'] = date('Y-m-d H:i:s');
				$this->data['Order']['delivery_date'] = date('Y-m-d', strtotime($this->data['Order']['delivery_date']));
				$this->data['Order']['pickup_date'] = date('Y-m-d', strtotime($this->data['Order']['pickup_date']));
                                $this->data['Order']['order_status'] = 'Scheduled Pickup';
				$this->data['Order']['status'] = '1';

				$this->Session->write("order_sumry", $this->data);
				$this->Session->write("message", "Order Confirmation");
				$this->redirect('/orders/payment_preview/' . $this->Order->id);
			}
		} else {
			$this->Order->id = $id;
			$this->data = $_SESSION['order_sumry'];
		}
	}

	function payment_preview($order_id = null) {
		$this->layout = "client_inner";
		$this->set('active', "");
		$this->userLoginCheck();
		$errorMessage = "";

		$userAddress = $this->User->find("first", array (
			"conditions" => array (
				"User.id = " . $this->Session->read('user_id')
			)
		));
		$this->set("userAddress", $userAddress);

		$userInfo = $this->Session->read('order_sumry');
		$this->set("userInfo", $userInfo);
	}

	function payment_preview_payasugo($order_id = null) {
		$this->layout = "client_inner";
		$this->set('active', "");
		$this->userLoginCheck();
		$errorMessage = "";

		if (isset ($order_id)) {

			$this->Order->id = $order_id;

			$userInfo = $this->Order->read();
                        $this->set("userInfo", $userInfo);

                        $ordereditemInfo = $this->OrderItem->find("all", array ("conditions" => array ("OrderItem.order_id = " . $order_id)));
                        $this->set("ordereditemInfo", $ordereditemInfo);

		}
	}

	function payment($order_id = null) {
		$this->layout = "client_inner";
		$this->set('active', "");
		$this->userLoginCheck();
		$errorMessage = "";

		$userAddress = $this->User->find("first", array (
			"conditions" => array (
				"User.id = " . $this->Session->read('user_id')
			)
		));

		$this->set("userAddress", $userAddress);


                $ordereditemInfo = $this->OrderItem->find("all", array ("conditions" => array ("OrderItem.order_id = " . $order_id)));
                $this->set("ordereditemInfo", $ordereditemInfo);

		$configDetails = $this->Configuration->find("first", array (
			"conditions" => "Configuration.id='1'",
			null
		));

		if ($configDetails['Configuration']['payment_mode'] == "sandbox") {
			$environment = "sandbox";
		} else {
			$environment = "";
		}

		if (isset ($order_id)) {
			$userInfo = $this->Order->find("first", array (
				"conditions" => array (
					"Order.user_id = " . $this->Session->read('user_id'),
					"Order.id = " . $order_id
				)
			));
			$this->set("userInfo", $userInfo);

			if (isset ($configDetails['Configuration']['authorize_amount']) && $configDetails['Configuration']['authorize_amount'] != '0.00') {
				$paymentType = urlencode('Authorization'); // Authorization or 'Sale'
				$firstName = urlencode($userAddress['User']['first_name']);
				$lastName = urlencode($userAddress['User']['last_name']);
				$creditCardType = urlencode($userAddress['User']['card_type']);
				$creditCardNumber = urlencode($userAddress['User']['card_number']); //$userInfo['PayAsYouGoOrder']['card_number']
				$expDateMonth = $userAddress['User']['expiration_card_month'];
				// Month must be padded with leading zero
				$padDateMonth = urlencode(str_pad($expDateMonth, 2, '0', STR_PAD_LEFT));

				$expDateYear = urlencode($userAddress['User']['expiration_card_year']); //$userInfo['PayAsYouGoOrder']['expiration_card_year']
				$cvv2Number = urlencode($userAddress['User']['card_number_cvv']); //$userInfo['PayAsYouGoOrder']['card_number_cvv']
				$address1 = urlencode($userAddress['User']['billing_address']); //$userInfo['PayAsYouGoOrder']['billing_address']
				$address2 = "";
				$city = urlencode($userAddress['User']['billing_city']); //$userInfo['PayAsYouGoOrder']['billing_city']
				$state = urlencode('test state'); //$userInfo['PayAsYouGoOrder']['expiration_card_month']
				$zip = urlencode($userAddress['User']['billing_zip']); //$userInfo['PayAsYouGoOrder']['billing_zip']
				$country = urlencode('US'); // US or other valid country code
				$amount = urlencode($configDetails['Configuration']['authorize_amount']); //$userInfo['PayAsYouGoOrder']['expiration_card_month']
				$currencyID = urlencode('USD'); // or other currency ('GBP', 'EUR', 'JPY', 'CAD', 'AUD')

				// Add request-specific fields to the request string.
				$nvpStr = "&PAYMENTACTION=$paymentType&AMT=$amount&CREDITCARDTYPE=$creditCardType&ACCT=$creditCardNumber" .
				"&EXPDATE=$padDateMonth$expDateYear&CVV2=$cvv2Number&FIRSTNAME=$firstName&LASTNAME=$lastName" .
				"&STREET=$address1&CITY=$city&STATE=$state&ZIP=$zip&COUNTRYCODE=$country&CURRENCYCODE=$currencyID";
//echo '<pre>';print_r($nvpStr);exit;
				$httpParsedResponseAr = $this->Common->PPHttpPostDoAuth('DoDirectPayment', $nvpStr, $environment);

//echo "<pre>";print_r($httpParsedResponseAr);exit;
				$authorizationID = $httpParsedResponseAr['TRANSACTIONID'];
                        } //end if amount not equal to zero

                        /*by deepshikha*/

                        if("SUCCESS" == strtoupper($httpParsedResponseAr["ACK"]) || "SUCCESSWITHWARNING" == strtoupper($httpParsedResponseAr["ACK"])) {
                            $query_update = "UPDATE orders_pay_as_you_go_users SET payment_status='Confirm',status='1',transaction_id='" . $authorizationID . "' WHERE order_id = '" . $order_id . "'";
                            mysql_query($query_update) or die(mysql_error());


                            $this->Order->sendGenerateOrderEmailToAdmin($userAddress["User"]["email_address"], $order_id);

                          /*by deepshikha for sending sms if notification type is sms or email if notification type is email*/
                            if($userAddress["User"]["notify_by"] == 'Sms'){

                                $ph = explode('-', $userAddress['User']['phone']);
                                $phone = $ph[0].$ph[1].$ph[2];

                                $this->Order->sendSms($phone, $order_id, $userAddress["User"]["first_name"]);
                            }else if($userAddress["User"]["notify_by"] == 'Email'){
                                $this->Order->sendGenerateOrderEmail($userAddress["User"]["email_address"], $order_id);
                            }
                          /* end by deepshikha*/

                            //echo "<pre>";pr($httpParsedResponseArCapture);exit;

                            $this->Session->write("message", "Your order has been placed.  You just saved a few hours of work with a few clicks of a mouse!");
                        }else{

                            $query_delete = "DELETE from orders_pay_as_you_go_users WHERE order_id = '" . $order_id . "'";
                            mysql_query($query_delete) or die(mysql_error());

                            $this->Session->write("message", "This transaction cannot be processed. Please update your credit card information.!");
                            $this->redirect('/orders/pay_as_you_go');
                        }
		}
	} //end function payment()

	function completeorder() {

		$this->layout = "client_inner";
		$this->set('active', "");
		$this->userLoginCheck();
		$errorMessage = "";

                $user_detail = $this->User->find("first", array (
			"conditions" => array (
				"User.id = " . $this->Session->read('user_id')
			)
		));

                // added by devendra 20120405

                if(empty ($user_detail['User']['address']) || empty ($user_detail['User']['city']) || empty ($user_detail['User']['state']) || empty ($user_detail['User']['zip']))
                {
                    $this->Session->write('message',__('Your delivery information is not complete, Kindly fill your delivery info.',true));
                    $this->redirect('/users/account_step2');
                }

		$paymentstatusinfo = $this->ReguserOrder->find("first", array (
			"conditions" => array (
				"ReguserOrder.user_id = " . $this->Session->read('user_id'),
				"ReguserOrder.payment_status = 'Confirm'",
				"ReguserOrder.status = '1'"
			),
			'order' => 'ReguserOrder.id DESC',
			"limit" => "1"
		));
		$this->set('paymentstatusinfo', $paymentstatusinfo);

		$this->Order->save($_SESSION['order_sumry']);

		$orderid = $this->Order->id;

		$this->Session->delete('order_sumry'); //deletes all data from session
		//to generate a unique order number
		global $cardno;
		$form_order_id = $cardno . str_pad($orderid, 5, "0", STR_PAD_LEFT);
		$this->data['Order']['id'] = $orderid;
		$this->data['Order']['order_no'] = $form_order_id;
		$orderNoArray = array ();
		$orderNoArray['Order']['id'] = $this->data['Order']['id'];
		$orderNoArray['Order']['order_no'] = $this->data['Order']['order_no'];

		$this->Order->save($orderNoArray);

		$this->data['OrdersSubscribedPlansUser']['order_id'] = $orderid;
		$this->data['OrdersSubscribedPlansUser']['plan_id'] = $paymentstatusinfo['ReguserOrder']['id'];
		$this->data['OrdersSubscribedPlansUser']['status'] = '1';
		$this->OrdersSubscribedPlansUser->save($this->data);

		$userAddress = $this->User->find("first", array (
			"conditions" => array (
				"User.id = " . $this->Session->read('user_id')
			)
		));
		$this->set("userAddress", $userAddress);

		$maximum_usage = $paymentstatusinfo['ReguserOrder']['total_usage'];
		$this->set('maximum_usage', $maximum_usage);

		$query_orderinfo = "SELECT order_id, plan_id, SUM(total_weight) FROM orders_subscribed_plans_users WHERE plan_id = '" . $paymentstatusinfo['ReguserOrder']['id'] . "' GROUP BY plan_id";
		$result_orderinfo = mysql_query($query_orderinfo) or die(mysql_error());
		$row_orderinfo = mysql_fetch_assoc($result_orderinfo);

		if (isset ($orderid)) {
			$userInfo = $this->Order->find("first", array (
				"conditions" => array (
					"Order.user_id = " . $this->Session->read('user_id'),
					"Order.id = " . $orderid
				)
			));
			$this->set("userInfo", $userInfo);

			// added by devendra 20120405
                        // $this->ReguserOrder->query("UPDATE reguser_orders SET used_usage = '" . $paymentstatusinfo['ReguserOrder']['used_usage'] . "' + '" . $row_orderinfo['SUM(total_weight)'] . "' WHERE id = '" . $paymentstatusinfo['ReguserOrder']['id'] . "'");

			$this->Order->sendGenerateOrderEmail($userAddress["User"]["email_address"], $orderid);
                        $this->Order->sendGenerateOrderEmailToAdmin($userAddress["User"]["email_address"], $orderid);

			$this->Session->write("message", "Your order has been placed.  You just saved a few hours of work with a few clicks of a mouse!");
		}

	} //end function completeorder()



	function vieworderdetail($orderid = null) {
		$this->layout = "client_inner";
		$this->userLoginCheck();
		$userorderDetails = $this->Order->find("first", array (
			"conditions" => array (
				"Order.id = " . $orderid
			)
		));
		$this->set("userorderDetails", $userorderDetails);

		$userAddress = $this->User->find("first", array (
			"conditions" => array (
				"User.id = " . $this->Session->read('user_id')
			),
			"fields" => array (
				"User.id",
				"User.address"
			)
		));
		$this->set("userAddress", $userAddress);

                $ordereditemInfo = $this->OrderItem->find("all", array ("conditions" => array ("OrderItem.order_id = " . $orderid)));
                $this->set("ordereditemInfo", $ordereditemInfo);
	} //end function vieworderdetail()

	/*paging for my orders*/

	function myorder() {
		$this->layout = "client_inner";
		$this->set("title_for_layout", "My Orders");

		$msgString = '';

		$condition = array ();
		$condition[] = "Order.user_id = " . $this->Session->read('user_id');
		$separator = array ();
		$urlSeparator = array ();

		$separator = implode("/", $separator);

		if (!empty ($this->passedArgs)) {
			if (isset ($this->passedArgs["page"])) {
				$urlSeparator[] = 'page:' . $this->passedArgs["page"];
			}
			if (isset ($this->passedArgs["sort"])) {
				$urlSeparator[] = 'sort:' . $this->passedArgs["sort"];
			}
			if (isset ($this->passedArgs["direction"])) {
				$urlSeparator[] = 'direction:' . $this->passedArgs["direction"];
			}
		}

		$urlSeparator = implode("/", $urlSeparator);

		$this->set('separator', $separator);
		$this->set('urlSeparator', $urlSeparator);

		$this->paginate['Order'] = array (
			'order' => array (
				'Order.id' => 'DESC'
			),
			'limit' => '10'
		);
		$this->set('userorderInfo', $this->paginate('Order', $condition));

	} //end function searchzip()

	function test() {
		$this->layout = "client_inner";

		$deliveryInfo1 = $this->WeighProduct->find("all", array ("conditions" => array ("WeighProduct.status= '1'"),'order' => 'WeighProduct.product_name ASC',"fields" => array ("WeighProduct.id","WeighProduct.product_name","WeighProduct.product_weight")));
		$this->set("deliveryInfo1", $deliveryInfo1);
		//echo '<pre>';print_r($this->data);exit;

	}


        function deleteitems($id = NULL, $order_id = NULL) {
		if ($id > 0) {
                        $this->OrderItem->id = $id;
			$itemInfo = $this->OrderItem->read();
                        $this->OrdersPayAsYouGoUser->query("UPDATE orders_pay_as_you_go_users SET total_weight = '" . $itemInfo['OrdersPayAsYouGoUser']['total_weight'] . "' - '" . $itemInfo['OrderItem']['total_weight'] . "' WHERE order_id = '" . $order_id . "'");
                        //echo '<pre>';print_r($itemInfo);exit;
			$this->OrderItem->delete($id);
			$this->viewPath = 'elements' . DS . 'admin';
			$this->Session->write('message', 'Item deleted successfully.');
			$this->render('blank_delete');
			$this->redirect('/orders/pay_as_you_go/'.$order_id);
		}
	} //end of admin_deleteUser


        function admin_captureAmount($order_id = null){

            $this->Order->id = $order_id;
            $orderInfo = $this->Order->read();

            $userInfo = $this->User->find("first", array ("conditions" => array ("User.id = " . $orderInfo['Order']['user_id']),null));

            $configDetails = $this->Configuration->find("first", array (
				"conditions" => "Configuration.id='1'", null));

		if ($configDetails['Configuration']['payment_mode'] == "sandbox") {
			$environment = "sandbox";
		} else {
			$environment = "";
		}

                if (isset($orderInfo) && $orderInfo['OrdersPayAsYouGoUser']['amount_captured_status']== 'not captured') {

				$paymentType = urlencode('Sale'); // Authorization or 'Sale'

				$authorizationID = $orderInfo['OrdersPayAsYouGoUser']['transaction_id'];

                                if(($orderInfo['Order']['order_total'] >= $configDetails['Configuration']['authorize_amount']) && $orderInfo['Order']['discount_coupon_code']==''){ //echo 'if not coupon n greater';exit;
                                    $amount = urlencode($configDetails['Configuration']['authorize_amount']);
                                    $remaining_amount = $orderInfo['Order']['order_total'] - $configDetails['Configuration']['authorize_amount'];
                                }

                                else if(($orderInfo['Order']['order_total'] < $configDetails['Configuration']['authorize_amount']) && $orderInfo['Order']['discount_coupon_code']==''){ //echo 'if not coupon n less';exit;
                                    $amount = urlencode($orderInfo['Order']['order_total']);
                                    $remaining_amount = '0.00';
                                }

                                else if($orderInfo['Order']['discount_coupon_code']!='' && ($orderInfo['Order']['discounted_order_amount'] >= $configDetails['Configuration']['authorize_amount'])){ //echo 'if coupon n greater';exit;
                                    $amount = urlencode($configDetails['Configuration']['authorize_amount']);
                                    $remaining_amount = $orderInfo['Order']['discounted_order_amount'] - $configDetails['Configuration']['authorize_amount'];
                                }

                                else if($orderInfo['Order']['discount_coupon_code']!='' && ($orderInfo['Order']['discounted_order_amount'] < $configDetails['Configuration']['authorize_amount'])){ //echo 'if coupon n less';exit;

                                	if((($orderInfo['Order']['discounted_order_amount']) + ($orderInfo['Order']['drycleaning_amount'])) >= $configDetails['Configuration']['authorize_amount']){ //echo 'greater';exit;
										$amount = urlencode($configDetails['Configuration']['authorize_amount']);
										$remaining_amount = (($orderInfo['Order']['drycleaning_amount']) + ($orderInfo['Order']['discounted_order_amount']))- $configDetails['Configuration']['authorize_amount'];
									}

									if((($orderInfo['Order']['discounted_order_amount']) + ($orderInfo['Order']['drycleaning_amount'])) < $configDetails['Configuration']['authorize_amount']){ //echo 'less';exit;
										$amount = urlencode(($orderInfo['Order']['discounted_order_amount']) + ($orderInfo['Order']['drycleaning_amount']));
										$remaining_amount = '0.00';
									}

                                }
//                              else{
//                                    $amount = urlencode($orderInfo['Order']['discounted_order_amount']);
//                                    $remaining_amount = '0.00';
//                              }

				$currency = urlencode('USD'); // or other currency ('GBP', 'EUR', 'JPY', 'CAD', 'AUD')
				$completeCodeType = urlencode('Complete'); // or 'NotComplete'
				$invoiceID = urlencode('');
				$note = urlencode('');
				$nvpStrCap = "&AUTHORIZATIONID=$authorizationID&AMT=$amount&COMPLETETYPE=$completeCodeType&CURRENCYCODE=$currency&NOTE=$note";
				//echo '<pre>';print_r($nvpStrCap);exit;
				// This will capture the exact amount from the authorize amount
				$httpParsedResponseArCapture = $this->Common->capture('DoCapture', $nvpStrCap, $environment);

                                $query_update_payasgo = "UPDATE orders_pay_as_you_go_users SET amount_captured_status = 'captured' WHERE id = '" . $order_id . "'";
                                mysql_query($query_update_payasgo) or die(mysql_error());

                                $query_update_orders = "UPDATE orders SET captured_amount = '".$amount."', remaining_amount = '".$remaining_amount."' WHERE id = '" . $order_id . "'";
                                mysql_query($query_update_orders) or die(mysql_error());


                                /*code for send mail to user about
                                 * the info of payment capturization
                                 */

                                //$this->Order->sendAmountCapturedEmail($userInfo['User']['email_address'],$orderInfo['Order']['order_no'], $amount, $remaining_amount);
                                $to = $userInfo['User']['email_address'];
                                $subject = "Payment Captured for BTM Laundry Order";
                                $message .= "$".$amount." are captured from your account. ";
                                //echo $message;exit;
                                if($remaining_amount!='0.00'){
                                    $message .= " $".$remaining_amount." is remaining amount, you will have to pay at delivery time.";
                                }
                                $headers .= "From: ".SITE_TITLE." <info@".SITE_TITLE_MAIL.".com>\r\n";

                                mail($to,$subject,$message,$headers);

                                $this->Session->write("message", "The amount is captured!");
                                $this->redirect('/admin/orders/editOrders/'.$order_id);
                    } //end if amount not equal to zero


                    else{
                                $this->Session->write("message", "The amount is already captured and can not be captured again!");
                                $this->redirect('/admin/orders/editOrders/'.$order_id);
                    }

        } //end function admin_captureAmount($order_id)



        function weight_calc() {
            $this->layout="clientpopup";
            $this->set("title", "Weight Calculator");

            $deliveryInfo1 = $this->WeighProduct->find("all", array ("conditions" => array ("WeighProduct.status= '1'"),'order' => 'WeighProduct.product_name ASC',"fields" => array ("WeighProduct.id","WeighProduct.product_name","WeighProduct.product_weight")));
            $this->set("deliveryInfo1", $deliveryInfo1);
        }

}
?>
