<?php
class PageController extends AppController {

	var $name = 'Page';
	var $uses = array('User','Page','static_pages',"Faq","Configuration","Testimonial","Admin");
	var $helpers 	= array('Html','Form','Javascript','Ajax','Fck','Time');
	var $paginate	= array('limit'=> '10', 'page' => '1', 'order'=>array('Page.static_page_title'=>'asc'));
	var $components = array ('RequestHandler');
	var $layout='admin';


       function admin_index(){
		$this->layout="admin";
		$this->set("expand_menu_links","pages");
		$condition=array();
		$separator=array();
		$urlSeparator=array();
		
		$separator=implode("/",$separator);

		if(!empty($this->passedArgs)){
			if(isset($this->passedArgs["page"])){
				$urlSeparator[]='page:'.$this->passedArgs["page"];
			}
			if(isset($this->passedArgs["sort"])){
				$urlSeparator[]='sort:'.$this->passedArgs["sort"];
			}
			if(isset($this->passedArgs["direction"])){
				$urlSeparator[]='direction:'.$this->passedArgs["direction"];
			}
		}

		$urlSeparator=implode("/",$urlSeparator);

		$this->set('separator',$separator);
		$this->set('urlSeparator',$urlSeparator);
		$this->set('staticpages', $this->paginate('Page',$condition));
		if($this->RequestHandler->isAjax()) {
			$this->layout='';
			$this->viewPath = 'elements'.DS.'admin/page/';
			$this->render('index');
		}
	}// end of function index	


       function admin_editPage($id=null) {
              $this->layout   =   "admin";


                if($this->data){
			
			if(empty($this->data["Page"]["static_page_title"])){
				$msgString ="- Page title is required field.<br>";
			}
                        
                        if(empty($this->data["Page"]["static_page_description"])){
				$msgString .="- Page description is required field.<br>";
			}
                        
                        if(isset($msgString) && $msgString!='')
			{
				$this->Session->write('message',$msgString);
			}
			else
			{
				if($this->Page->save($this->data)){
					$this->Session->write('message',__('Page details updated successfully.',true));
					$this->redirect('/admin/page/index');
				}
			}
		}elseif($id>0){
			$this->Page->id = $id;
			$this->data =  $this->Page->read();


		}

	}              

        
		 
	function faq(){
            $this->layout="client";
            $faqdetails    =    $this->Faq->find("all",array("conditions"=>"Faq.status='1'",null));
            $this->set("faqdetails",$faqdetails) ;
            $this->set('active',"faq");

            //$this->Session->write('landing_id','test');

        } //end function faq()

        function pricing(){
            $this->layout   =   "client";
            $this->set('active',"pricing");
            $pageContent    =    $this->Page->find("first",array("conditions"=>"Page.id='17'","fields"=>array("Page.id","Page.static_page_title","Page.static_page_description")));
            $this->set("pageContent",$pageContent) ;         
        } //end function pricing()
        
        function order(){
            $this->layout   =   "client";
            $this->set('active',"order");
            $pageContent    =    $this->Page->find("first",array("conditions"=>"Page.id='19'","fields"=>array("Page.id","Page.static_page_title","Page.static_page_description")));
            $this->set("pageContent",$pageContent) ;
            $this->set("title_for_layout",$pageContent['Page']['static_page_title']) ;
        }

        function underwork(){
            $this->layout   =   "client";
            $this->set('active',"");
            $pageContent    =    $this->Page->find("first",array("conditions"=>"Page.id='22'","fields"=>array("Page.id","Page.static_page_title","Page.static_page_description")));
            $this->set("pageContent",$pageContent) ;
            $this->set("title_for_layout",$pageContent['Page']['static_page_title']) ;
        }

        function commercial(){
            $this->layout   =   "client";
            $this->set('active',"");
            $pageContent    =    $this->Page->find("first",array("conditions"=>"Page.id='21'","fields"=>array("Page.id","Page.static_page_title","Page.static_page_description")));
            $this->set("pageContent",$pageContent) ;
            $this->set("title_for_layout",$pageContent['Page']['static_page_title']) ;
        }
        function terms(){
            $this->layout   =   "client";
            $this->set('active',"");
            $pageContent    =    $this->Page->find("first",array("conditions"=>"Page.id='20'","fields"=>array("Page.id","Page.static_page_title","Page.static_page_description")));
            $this->set("pageContent",$pageContent) ;
            $this->set("title_for_layout",$pageContent['Page']['static_page_title']) ;
        }


        function terms_service(){
            $this->layout   =   "clientpopup_terms";
            $this->set('active',"");
            $pageContent    =    $this->Page->find("first",array("conditions"=>"Page.id='20'","fields"=>array("Page.id","Page.static_page_title","Page.static_page_description")));
            $this->set("pageContent",$pageContent) ;
            $this->set("title_for_layout",$pageContent['Page']['static_page_title']) ;
        }
        
        function privacy(){
            $this->layout   =   "client";
            $this->set('active',"");
            $pageContent    =    $this->Page->find("first",array("conditions"=>"Page.id='16'","fields"=>array("Page.id","Page.static_page_title","Page.static_page_description")));
            $this->set("pageContent",$pageContent) ;
            $this->set("title_for_layout",$pageContent['Page']['static_page_title']) ;
        }

        function content($id){
            $pageContent    =    $this->Page->find("first",array("conditions"=>"Page.id=".$id,"fields"=>array("Page.id","Page.static_page_title","Page.static_page_description")));
            return $pageContent;
        }
       

        function policy()
	{
		$this->layout = 'client';
                $pageContent    =    $this->Page->find("first",array("conditions"=>"Page.id='16'","fields"=>array("Page.id","Page.static_page_title","Page.static_page_description")));
                $this->set("pageContent",$pageContent) ;
                $this->set("title_for_layout",$pageContent['Page']['static_page_title']) ;
	}


        function success(){
            $this->layout   =   "client";           

        }
		
		function thankyou(){
			$this->layout   =   "client";     
			// $msgstring = "";      
		}

        function success_plan($id = NULL){
            $this->layout   =   "client";
            $this->set('id',$id);
            if($id == 'upgrade')
            {
                    $this->set('heading','Upgrading Plan');
                    $this->set('desc','Congratulations on upgrading your subscription to your laundry plan. Your upgraded plan will be start on the expiration of current plan.');
            }
            if($id == 'new')
            {
                    $this->set('heading','Subscribed New Plan');
                    $this->set('desc','Value Plan successfully purchased, Don’t forget to schedule your first pickup.');
            }
            if($id == 'autorenew')
            {
                    $this->set('heading','Auto Renew Plan');
                    $this->set('desc','Congratulations!! Your plan has been renewed, Now you can start to schedule your orders. Schedule your first pickup.');
            }

        }


        function contactus(){ 
            $this->layout   =   "client";
            $msgstring = "";

            $configInfo = $this->Configuration->find('first',array('conditions'=>'Configuration.id=1'));
            $this->set('configInfo',$configInfo);

            $adminInfo = $this->Admin->find('first',array('conditions'=>'Admin.id=1'));
            $this->set('adminInfo',$adminInfo);

            if($this->data){

                if(isset($this->data["Page"]["name"]) && $this->data["Page"]["name"] == ""){
                    $msgstring = $msgstring."<br />"."Please Enter Your Name";
                }
                if(isset($this->data["Page"]["email"]) && $this->data["Page"]["email"] == ""){
                    $msgstring = $msgstring."<br />"."Please Enter Your Email";
                }elseif($this->User->checkEmail($this->data['Page']['email']) == false){
                    $msgstring = $msgstring."<br />"."Please Enter Valid Email";
                }
                if(isset($this->data["Page"]["subject"]) && $this->data["Page"]["subject"] == ""){
                    $msgstring = $msgstring."<br />"."Please Select subject";
                }
                if(isset($this->data["Page"]["description"]) && $this->data["Page"]["description"] == ""){
                    $msgstring = $msgstring."<br />"."Please Enter Your Message";
                }
                if($msgstring != ''){
                    $this->Session->write('message',$msgstring);
                }else{

                    $to = $adminInfo['Admin']['email'];
                    $subject = $this->data["Page"]["subject"];
                    $message = $this->data["Page"]["description"];
                    $headers ="From: ".$this->data["Page"]["email"]."\r\n";
                    $headers .= "MIME-Version: 1.0\r\n";
                    $headers .= "Content-type: text/html; charset=iso-8859-1\r\n";
                    mail($to,$subject,$message,$headers);
                    $msgstring = "Your Enquiry Has Been Sent, We Will Contact You Soon";
                    $this->Session->write('message',$msgstring);
                    $this->redirect("/page/contactus");
                }
                /*By kapil agrwal ends here july 17,2010*/
            } 
        }  //end function contact us..
		
		function home_contactus(){		
            $this->layout   =   "client";
            $msgstring = "";

            $configInfo = $this->Configuration->find('first',array('conditions'=>'Configuration.id=1'));
            $this->set('configInfo',$configInfo);

            $adminInfo = $this->Admin->find('first',array('conditions'=>'Admin.id=1'));
            $this->set('adminInfo',$adminInfo);

            if($this->data){

                if(isset($this->data["Page"]["name"]) && $this->data["Page"]["name"] == ""){
                    $msgstring = $msgstring."<br />"."Please Enter Your Name";
                }
                if(isset($this->data["Page"]["email"]) && $this->data["Page"]["email"] == ""){
                    $msgstring = $msgstring."<br />"."Please Enter Your Email";
                }elseif($this->User->checkEmail($this->data['Page']['email']) == false){
                    $msgstring = $msgstring."<br />"."Please Enter Valid Email";
                }
                if(isset($this->data["Page"]["subject"]) && $this->data["Page"]["subject"] == ""){
                    $msgstring = $msgstring."<br />"."Please Select subject";
                }
                if(isset($this->data["Page"]["description"]) && $this->data["Page"]["description"] == ""){
                    $msgstring = $msgstring."<br />"."Please Enter Your Message";
                }
                if($msgstring != ''){
                    //$this->Session->write('message',$msgstring);
					$this->Session->write('message',"Please enter the required fields");
                }else{

                    $to = $adminInfo['Admin']['email'];
                    $subject = $this->data["Page"]["subject"];
                    $message = $this->data["Page"]["description"];
                    $headers ="From: ".$this->data["Page"]["email"]."\r\n";
                    $headers .= "MIME-Version: 1.0\r\n";
                    $headers .= "Content-type: text/html; charset=iso-8859-1\r\n";
                    mail($to,$subject,$message,$headers);
                    $msgstring = "Your Enquiry Has Been Sent, We Will Contact You Soon";
                    $this->Session->write('message',$msgstring);
                    //$this->redirect($this->webroot."#ContactFormHome");
					$this->redirect($_SERVER['HTTP_REFERER'].'#ContactFormHome');
                }
				$this->redirect($_SERVER['HTTP_REFERER'].'#ContactFormHome');
                /*By kapil agrwal ends here july 17,2010*/
            } 
        }  //end function contact us..
		

        function index(){
            $this->layout="client";
            $this->set('active',"home");

        } //end function index()



        function testimonials(){
            $this->layout   =   "client";
            $this->set('active',"");
            $testimonialInfo = $this->Testimonial->find("all", array ("conditions" => array ("Testimonial.status= '1'"),'order' => 'Testimonial.id DESC'));
            //echo '<pre>';print_r($testimonialInfo);exit;
            $this->set('testimonialInfo',$testimonialInfo);
        }

        function how_it_works(){
            
            $this->layout   =   "client";
            $this->set('active',"how_it_works");
            
            $this->set("title_for_layout",'How It Works');
        }
		
		function get_started(){
            
            $this->layout   =   "client";
            $this->set('active',"get_started");
            
            $this->set("title_for_layout",'Get Started');
        }


        function about_us(){
		
            $this->layout   =   "client";
            $this->set('active',"about_us");
            
            $pageContent    =    $this->Page->find("first",array("conditions"=>"Page.id='32'","fields"=>array("Page.id","Page.static_page_title","Page.static_page_description")));
            $this->set("pageContent",$pageContent) ;

            $this->set("title_for_layout",$pageContent['Page']['static_page_title']) ;
        }
        
        function specials(){

            $this->layout   =   "client";

            $pageContent    =    $this->Page->find("first",array("conditions"=>"Page.id='33'","fields"=>array("Page.id","Page.static_page_title","Page.static_page_description")));
            $this->set("pageContent",$pageContent) ;

            $this->set("title_for_layout",$pageContent['Page']['static_page_title']) ;
        }

}

?>