<?php

class ReferencesController extends AppController {

	var $name = 'References';
	var $uses 		= array("User","State","Reference");
	var $helpers 	= array('Html','Form','Javascript','Ajax','Time');
	var $paginate	= array('limit'=> '50', 'page' => '1', 'order'=>array('Reference.id'=>'desc'));
	var $components = array ('RequestHandler',"Logincheck","Common");
	var $layout='admin';

	function beforeFilter(){
                $loggedAdminId = $this->Session->read("adminid");
		if(isset($this->params['admin']) && $this->params['admin'] && !$loggedAdminId){
			$this->redirect("/admin/admins/login");
		}
	}



	/*_____________________________________________________________________________
	Function : index
	Show admin_index page
	Tables : users
	???????????????????????????????????????????????????????????????????????????????*/
	function admin_index($created=null,$toDate=null){
		$this->layout="admin";
		$this->set("expand_menu_links","users");
		$condition=array();
		$separator=array();
		$urlSeparator=array();

		if(!empty($this->data)){

			if(isset($this->data['Reference']['last_name']) && $this->data['Reference']['last_name']!=''){
				$customerName=trim($this->data['Reference']['last_name']);
			}


			if(isset($this->data['Reference']['action'])){
				$idList=$this->data['Reference']['idList'];
				if($idList){
					if($this->data['Reference']['action']=="activate"){
						$cnd=array("Reference.id IN ($idList) ");
						$this->Reference->updateAll(array('Reference.status' =>"'1'"),$cnd);
					}elseif($this->data['Reference']['action']=="deactivate"){
						$cnd=array("Reference.id IN ($idList) ");
						$this->Reference->updateAll(array('Reference.status' =>"'0'"),$cnd);
					}elseif($this->data['Reference']['action']=="delete"){
						$cnd=array("Reference.id IN ($idList) ");
						$this->Reference->deleteAll($cnd);
					}
				}
			}
		}elseif(!empty($this->params)){
			if(isset($this->params['named']['last_name']) && $this->params['named']['last_name']!=''){
				$userName=trim($this->params['named']['last_name']);
			}

		}

		  if(isset($created) && $created!='' && $created!='null'){
                    $created    =   $created ;
                   }
                    if(isset($toDate) && $toDate!='' && $toDate!='null'){
                    $toDate    =   $toDate ;
                   }
                    elseif(!empty($this->params)){
                                if(isset($this->params['named']['created']) && $this->params['named']['created']!='' && isset($this->params['named']['todate']) && $this->params['named']['todate']!=''){
                                        $created=trim($this->params['named']['created']);
                                        $toDate=trim($this->params['named']['todate']);
                                }
                    }
                if(isset($created) && $created!='' && $created!='null'){
			$separator[]='created:'.$created;
                        $separator[]='todate:'.$toDate;
			$condition[]="Reference.created between '".$created."' and '".$toDate."'";
		}


		$separator=implode("/",$separator);

		if(!empty($this->passedArgs)){
			if(isset($this->passedArgs["page"])){
				$urlSeparator[]='page:'.$this->passedArgs["page"];
			}
			if(isset($this->passedArgs["sort"])){
				$urlSeparator[]='sort:'.$this->passedArgs["sort"];
			}
			if(isset($this->passedArgs["direction"])){
				$urlSeparator[]='direction:'.$this->passedArgs["direction"];
			}
		}

		$urlSeparator=implode("/",$urlSeparator);

		$this->set('separator',$separator);
		$this->set('urlSeparator',$urlSeparator);

//
                $this->set('references', $this->paginate('Reference',$condition));
		if($this->RequestHandler->isAjax()) {
			$this->layout='';
			$this->viewPath = 'elements'.DS.'admin/references/';
			$this->render('index');
		}
	}// end of function index

        function admin_addusers() {
		$this->layout="admin";
                $stateList = $this->State->stateList();
                $this->set("stateList",$stateList);		
		$errorMessage='';
		$conditions=array();
		App::import('Sanitize');
	if($this->data){
                    if(empty($this->data['User']['email_address'])){
                        $errorMessage .= "- Please Enter Email.<br>";
                    }elseif($this->User->checkEmail($this->data['User']['email_address']) == false){
                        $errorMessage .= "- Please Enter Valid Email.<br>";
                    }elseif($this->User->isRecordUniqueemail($this->data["User"]["email_address"]) == false){
                        $errorMessage .="- Email already exists.<br>";
                    }
                    if(empty($this->data["User"]["password"])){
                    $errorMessage .="- Password is required field.<br>";
                    }
                    if(empty($this->data["User"]["confirm_password"])){
                        $errorMessage .="- Confirm Password is required field.<br>";
                    }elseif($this->data["User"]["password"] != $this->data["User"]["confirm_password"]){
                        $errorMessage .="- Password and Confirm Password doesn't match.<br>";
                    }
                    if(empty($this->data["User"]["first_name"])){
                        $errorMessage .="- First Name is required field.<br>";
                    }
                    if(empty($this->data["User"]["last_name"])){
                        $errorMessage .="- Last Name is required field.<br>";
                    }
                    if(empty($this->data["User"]["year"]) || empty($this->data["User"]["month"]) || empty($this->data["User"]["day"])){
                        $errorMessage .="- Month,Day or Year for Date of Birth Required.<br>";
                    }elseif((date('Y-m-d') < $this->data["User"]["year"]."-".$this->data["User"]["month"]."-".$this->data["User"]["day"]) ? true : false){
                        $errorMessage .="- Choose Valid Date.<br>";
                    }
                    if(empty($this->data["User"]["gender"])){
                        $errorMessage .="- Gender is Required.<br>";
                    }                    
                    if(empty($this->data['User']['phone1']) || empty($this->data['User']['phone2']) || empty($this->data['User']['phone3'])){
                        $errorMessage .= "- Phone Number is Required Field.<br>";
                    }elseif(preg_match("/^[0-9]{10}$/", $this->data['User']['phone1'].$this->data['User']['phone2'].$this->data['User']['phone3']) === 0){
                        $errorMessage .= "- Phone Number Should be Numeric and 10 digit.<br>";
                    }

//                    if(preg_match("/^[0-9]{10}$/", $this->data['User']['alt_phone1'].$this->data['User']['alt_phone2'].$this->data['User']['alt_phone3']) === 0){
//                        $errorMessage .= "- Alternate Phone Number Should be Numeric and 10 digit.<br>";
//                    }
                    if(empty($this->data['User']['address'])){
                    $errorMessage .= "- Address is Required Field.<br>";
                    }
                    if(empty($this->data['User']['city'])){
                        $errorMessage .= "- City is Required Field.<br>";
                    }
                    if(empty($this->data['User']['state'])){
                        $errorMessage .= "- State is Required Field.<br>";
                    }
                    if(empty($this->data['User']['zip'])){
                        $errorMessage .= "- Zip is Required Field.<br>";
                    }
                    if(empty($this->data['User']['billing_person_name'])){
                        $errorMessage .= "- Full Name is Required Field.<br>";
                    }                    

                    if(empty($this->data['User']['card_number'])){
                        $errorMessage .= "- Card Number is Required Field.<br>";
//                    }elseif(preg_match("/^[0-9]{15,}$/", $this->data['User']['card_number']) === 0){
//                        $errorMessage .= "- Card Number Should be Numeric and 15 or 16 digit.<br>";
//                    }
                    }else{
                        $returnMsg  =   $this->User->validateCC($this->data['User']['card_number'],$this->data['User']['card_type']);
                        if(isset($returnMsg) && $returnMsg != ""){
                            $errorMessage .= $returnMsg;
                        }
                    }
                    if(empty($this->data['User']['card_number_cvv'])){
                        $errorMessage .= "- Card's CVV Code is Required Field.<br>";
                    }elseif(preg_match("/^[0-9]{3,}$/", $this->data['User']['card_number_cvv']) === 0){
                        $errorMessage .= "- Card's CVV Code Should be Numeric and 3 or 4 digit.<br>";
                    }
                    if(empty($this->data["User"]["expiration_card_year"]) || empty($this->data["User"]["expiration_card_month"])){
                        $errorMessage .="- Card Expiration Month or Year Required.<br>";
                    }elseif((date('Y-m') > $this->data["User"]["expiration_card_year"]."-".$this->data["User"]["expiration_card_month"]) ? true : false){
                        $errorMessage .="- Choose Valid Expiration Date.<br>";
                    }
                    if(empty($this->data['User']['billing_address'])){
                        $errorMessage .= "- Billing Address is Required Field.<br>";
                    }
                    if(empty($this->data['User']['billing_city'])){
                        $errorMessage .= "- Billing City is Required Field.<br>";
                    }
                    if(empty($this->data['User']['billing_state'])){
                        $errorMessage .= "- Billing State is Required Field.<br>";
                    }
                    if(empty($this->data['User']['billing_zip'])){
                        $errorMessage .= "- Billing Zip is Required Field.<br>";
                    }

                    if(isset($errorMessage) && $errorMessage!=''){
                            $this->Session->write('message',$errorMessage);
                    }else{
                        $this->data['User']['confirm'] = 1;
                        $this->data['User']['status'] = 1;
                        $this->data["User"]["allergies"] = implode(",",$this->data["User"]["allergies"]);
                        $this->data['User']['date_of_birth'] = $this->data['User']['year']."-".$this->data['User']['month']."-".$this->data['User']['day'];
                        $this->data['User']['phone'] = $this->data['User']['phone1']."-".$this->data['User']['phone2']."-".$this->data['User']['phone3'];
                        $this->data['User']['alt_phone'] = $this->data['User']['alt_phone1']."-".$this->data['User']['alt_phone2']."-".$this->data['User']['alt_phone3'];
                        //echo "<pre>";pr($this->data);exit;
                        if($this->User->save($this->data)){
                           // echo "<pre>";pr($this->data);exit;
                                $this->Session->write('message','User details saved successfully');
                                $this->redirect('/admin/users/index');
                        }
                    }
        }
   }

        function admin_editusers($id=NULL){
            $this->layout="admin";
            $stateList = $this->State->stateList();
            $this->set("stateList",$stateList);
            $errorMessage='';
            $conditions=array();
            App::import('Sanitize');
            if($this->data){//echo "<pre>";pr($this->data);exit;
                        if($this->data['User']['email_address']!=$this->data['User']['old_email_address']){
                            if(empty($this->data['User']['email_address'])){
                                $errorMessage .= "- Please Enter Email.<br>";
                            }elseif($this->User->checkEmail($this->data['User']['email_address']) == false){
                                $errorMessage .= "- Please Enter Valid Email.<br>";
                            }elseif($this->User->isRecordUniqueemail($this->data["User"]["email_address"]) == false){
                                $errorMessage .="- Email already exists.<br>";
                            }
                        }
                        if(empty($this->data["User"]["password"])){
                        $errorMessage .="- Password is required field.<br>";
                        }
                        if(empty($this->data["User"]["confirm_password"])){
                            $errorMessage .="- Confirm Password is required field.<br>";
                        }elseif($this->data["User"]["password"] != $this->data["User"]["confirm_password"]){
                            $errorMessage .="- Password and Confirm Password doesn't match.<br>";
                        }
                        if(empty($this->data["User"]["first_name"])){
                            $errorMessage .="- First Name is required field.<br>";
                        }
                        if(empty($this->data["User"]["last_name"])){
                            $errorMessage .="- Last Name is required field.<br>";
                        }
                        if(empty($this->data["User"]["year"]) || empty($this->data["User"]["month"]) || empty($this->data["User"]["day"])){
                        $errorMessage .="- Month,Day or Year for Date of Birth Required.<br>";
                        }elseif((date('Y-m-d') < $this->data["User"]["year"]."-".$this->data["User"]["month"]."-".$this->data["User"]["day"]) ? true : false){
                            $errorMessage .="- Choose Valid Date.<br>";
                        }
                        if(empty($this->data["User"]["gender"])){
                            $errorMessage .="- Gender is Required.<br>";
                        }
                        if(empty($this->data['User']['phone1']) || empty($this->data['User']['phone2']) || empty($this->data['User']['phone3'])){
                            $errorMessage .= "Phone Number is Required Field.<br>";
                        }elseif(preg_match("/^[0-9]{10}$/", $this->data['User']['phone1'].$this->data['User']['phone2'].$this->data['User']['phone3']) === 0){
                            $errorMessage .= "- Phone Number Should be Numeric and 10 digit.<br>";
                        }

//                        if(preg_match("/^[0-9]{10}$/", $this->data['User']['alt_phone1'].$this->data['User']['alt_phone2'].$this->data['User']['alt_phone3']) === 0){
//                            $errorMessage .= "- Alternate Phone Number Should be Numeric and 10 digit.<br>";
//                        }
                        if(empty($this->data['User']['address'])){
                        $errorMessage .= "- Address is Required Field.<br>";
                        }
                        if(empty($this->data['User']['city'])){
                            $errorMessage .= "- City is Required Field.<br>";
                        }
                        if(empty($this->data['User']['state'])){
                            $errorMessage .= "- State is Required Field.<br>";
                        }
                        if(empty($this->data['User']['zip'])){
                            $errorMessage .= "- Zip is Required Field.<br>";
                        }
                        if(empty($this->data['User']['billing_person_name'])){
                            $errorMessage .= "- Full Name is Required Field.<br>";
                        }
                        if(empty($this->data['User']['card_number'])){
                            $errorMessage .= "- Card Number is Required Field.<br>";
//                        }elseif(preg_match("/^[0-9]{15,}$/", $this->data['User']['card_number']) === 0){
//                            $errorMessage .= "- Card Number Should be Numeric and 15 or 16 digit.<br>";
//                        }
                        }else{
                        $returnMsg  =   $this->User->validateCC($this->data['User']['card_number'],$this->data['User']['card_type']);
                            if(isset($returnMsg) && $returnMsg != ""){
                                $errorMessage .= $returnMsg;
                            }
                        }
                        if(empty($this->data["User"]["expiration_card_year"]) || empty($this->data["User"]["expiration_card_month"])){
                            $errorMessage .="- Choose Day,Month or Year Required.<br>";
                        }elseif((date('Y-m') > $this->data["User"]["expiration_card_year"]."-".$this->data["User"]["expiration_card_month"]) ? true : false){
                            $errorMessage .="- Choose Valid Expiration Date.<br>";
                        }
                        if(empty($this->data['User']['card_number_cvv'])){
                            $errorMessage .= "- Card's CVV Code is Required Field.<br>";
                        }elseif(preg_match("/^[0-9]{3,}$/", $this->data['User']['card_number_cvv']) === 0){
                            $errorMessage .= "- Card's CVV Code Should be Numeric and 3 or 4 digit.<br>";
                        }
                        if(empty($this->data['User']['billing_address'])){
                            $errorMessage .= "- Billing Address is Required Field.<br>";
                        }
                        if(empty($this->data['User']['billing_city'])){
                            $errorMessage .= "- Billing City is Required Field.<br>";
                        }
                        if(empty($this->data['User']['billing_state'])){
                            $errorMessage .= "- Billing State is Required Field.<br>";
                        }
                        if(empty($this->data['User']['billing_zip'])){
                            $errorMessage .= "- Billing Zip is Required Field.<br>";
                        }

                        if(isset($errorMessage) && $errorMessage!=''){
                                $this->Session->write('message',$errorMessage);
                        }else{
                            $this->data['User']['confirm'] = 1;
                            $this->data['User']['status'] = 1;
                            $this->data["User"]["allergies"] = implode(",",$this->data["User"]["allergies"]);
                            $this->data['User']['phone'] = $this->data['User']['phone1']."-".$this->data['User']['phone2']."-".$this->data['User']['phone3'];
                            $this->data['User']['alt_phone'] = $this->data['User']['alt_phone1']."-".$this->data['User']['alt_phone2']."-".$this->data['User']['alt_phone3'];
                            $this->data['User']['date_of_birth'] = $this->data['User']['year']."-".$this->data['User']['month']."-".$this->data['User']['day'];
                            //echo "<pre>";pr($this->data);exit;
                            if($this->User->save($this->data)){
                                //echo "<pre>";pr($this->data);exit;
                                    $this->Session->write('message','User details saved successfully');
                                    $this->redirect('/admin/users/index');
                            }
                        }
            }elseif($id>0){//when coming without filling form
                $this->User->id = $id;
                 //echo "<pre>";pr($this->data);exit;
                $this->data =  $this->User->read();
                $this->data["User"]["old_email_address"] = $this->data["User"]["email_address"];
                $this->data['User']['confirm_password'] = $this->data['User']['password'];
                $this->data['User']['allergies'] = explode(",",$this->data['User']['allergies']);
                $dateArray = explode("-",$this->data['User']['date_of_birth']);
                $this->data['User']['year'] = $dateArray[0];
                $this->data['User']['month'] = $dateArray[1];
                $this->data['User']['day'] = $dateArray[2];
                $phoneArray = explode("-",$this->data["User"]["phone"]);
                $this->data["User"]["phone1"] = $phoneArray[0];
                $this->data["User"]["phone2"] = $phoneArray[1];
                $this->data["User"]["phone3"] = $phoneArray[2];
                $altphoneArray = explode("-",$this->data["User"]["alt_phone"]);
                $this->data["User"]["alt_phone1"] = $altphoneArray[0];
                $this->data["User"]["alt_phone2"] = $altphoneArray[1];
                $this->data["User"]["alt_phone3"] = $altphoneArray[2];
                //echo "<pre>";pr($this->data);exit;

            }

        }

        function admin_deletereferences($id=NULL){
            if($id>0){
                $this->Reference->delete($id);
                $this->viewPath = 'elements'.DS.'admin';
                $this->Session->write('message','Reference details deleted successfully.');
                $this->render('blank_delete');
                $this->redirect('/admin/references/index');
            }
        }//end of admin_deleteUser

        function admin_deactivateUser($id=NULL){
        if($id>0){
        $this->User->recursive = -1;
        $cnd=array("User.id = $id");
        $this->User->updateAll(array('User.status' =>"'0'"),$cnd);
        $this->Session->write('message','User Deactivated successfully.');
        $this->set('action','/admin/users/activateUser/'.$id);
        $this->set('id',$id);
        $this->set('status',0);
        $this->viewPath = 'elements'.DS.'admin';
        $this->render('update_status');
        $this->redirect('/admin/users/index');
        }

        }

        function admin_activateUser($id=NULL){
		if($id>0){
                    $this->User->recursive = -1;
			$cnd=array("User.id = $id");
			$this->User->updateAll(array('User.status' =>"'1'"),$cnd);
                        $this->Session->write('message','User Activated successfully.');
			$this->set('action','/admin/users/deactivateUser/'.$id);
			$this->set('id',$id);
			$this->set('status',1);
			$this->viewPath = 'elements'.DS.'admin';
			$this->render('update_status');
			$this->redirect('/admin/users/index');
		}
	}//end of admin_activateCustomer



        function admin_exportSubscriber($id=NULL){
             
                $this->layout="default";

		// to export to csv
                $contents   =   "";
		if($id == "csv")
		{

                 //$contents = "User id,First Name,Last Name,Gender,Email,City,State,Zip,Phone \n";
                    $contents = "Email \n";
                 $contactInfo = $this->User->find("all",array("conditions"=>"User.newsletter_subscribe=1"));
                        //echo "<pre>";print_r($contactInfo);exit;


			for($cntr = 0; $cntr < count($contactInfo); $cntr++)
			{
				        //$contents.=stripslashes('"'.$contactInfo[$cntr]['User']['id'].'"').",";
                                        //$contents.=stripslashes('"'.$contactInfo[$cntr]['User']['first_name'].'"').",";
                                        //$contents.=stripslashes('"'.$contactInfo[$cntr]['User']['last_name'].'"').",";
                                        //$contents.=stripslashes('"'.$contactInfo[$cntr]['User']['gender'].'"').",";
                                        $contents.=stripslashes('"'.$contactInfo[$cntr]['User']['email_address'].'"').",";
                                        //$contents.=stripslashes('"'.$contactInfo[$cntr]['User']['city'].'"').",";
                                        //$contents.=stripslashes('"'.$contactInfo[$cntr]['User']['state'].'"').",";
                                        //$contents.=stripslashes('"'.$contactInfo[$cntr]['User']['zip'].'"').",";
                                        //$contents.=stripslashes('"'.$contactInfo[$cntr]['User']['phone'].'"').",";
                                        $contents.="\n";
			} //end for($cnt = 0; $cntr < count($customerInfo); $cntr++)


			$contents = strip_tags($contents); // remove html and php tags etc.
			$date = date("Ymd");
			$fileName = "Newsletter_Subscribers_".$date.".csv";
			header("Content-Disposition: attachment; filename=$fileName");
			print $contents;
			exit;

		} //end if($id == "csv")
             
	} //end function
        

/* ------------------------------------------------------------------------------------------------------------------------------------------ */
        /*client function starts
         * from here
         * 
         */

         function confirmation(){
            $this->layout="client_inner";
            $this->set("title_for_layout","Sign Up") ;
            $this->set("active","register");
            if($this->data){
                $this->redirect('/');
            }
         }	

         function login(){
         $this->layout = 'client';
         $this->set("active","");
         $errorMessage='';
         $userid   =$this->Session->read("user_id");
          if(isset($userid)){
              $this->Session->write('user_inserted_id',$userid);             
              $this->redirect('/users/account_step1');
          }
          if(isset($this->data)){		  
                 if(empty($this->data['User']['email_address'])){
                     $errorMessage.=   "Please enter your username.<br>";
                   }
                 if(empty($this->data['User']['password'])){
                     $errorMessage.=   "Please enter your password.<br>";
                 }
                 
                 if(isset($msgString) && $msgString!=''){
                     $this->Session->write('message',$errorMessage);
                 }
                 else{
                    $UserCheck = $this->User->find("first",array("conditions"=>array("User.email_address = '".$this->data['User']['email_address']."'","User.password = '".$this->data['User']['password']."'")));
                    if(is_array($UserCheck) &&  !empty($UserCheck)){
                        $this->Session->write("user_id",$UserCheck['User']['id']);
                        $this->Session->write("user_name",$UserCheck['User']['first_name']);
                        $this->Session->write('user_inserted_id',$UserCheck['User']['id']);                        
                        $this->redirect('/users/account_step1');
                    }else{
                        $this->Session->write('message',__('You have entered invalid username/password.',true));
                        $this->redirect("/users/login");
                 }
                }            
            }
	}
        /*  End Function  */

        function logout(){
            $this->Session->write('message','Logout Successfull');
            $this->Session->delete('user_id');
            $this->Session->delete('user_name');
            $this->Session->delete('user_inserted_id');
            //$this->Session->delete('order_id');
            $this->redirect('/');
         
        }

        function account(){
            $this->layout="client_inner";
            $this->userLoginCheck();
            $this->set("active","");
            $this->set("title_for_layout","My Account") ;           
            $this->data = $this->User->find("first",array("conditions"=>"User.status = 1 and User.id = '".$this->Session->read('user_id')."'"));

        } //end function account()

       

        function forgotPassword() {
            $this->layout="client";
            $this->set("active","");
            if(isset($this->data)){
                    $errorMessage = '';
                        if(empty($this->data['User']['email_address'])){
                            $errorMessage = "Please Enter Your Email";
                        }elseif($this->User->checkEmail($this->data["User"]["email_address"]) == false){
                        	$errorMessage .="- Email Not Valid.<br>";
                        }                        
                        if($errorMessage == ''){
                            $email = $this->data['User']['email_address'];
                            $userCheck = $this->User->find("first",array("conditions"=>"User.email_address = '".$email."'"));
                            if(is_array($userCheck) &&  !empty($userCheck)){
                                $this->User->sendForgotPasswordEmail($this->data["User"]["email_address"]);
                                $this->Session->write('message','Your Password has been sent to your email id successfully.');
                                $this->redirect('/users/forgotPassword');
                            }else{
                                $errorMessage = "No Account Found, Check E-mail.";
                            }
                        }
                        $this->Session->write("message",$errorMessage);
		}
	}

        function changepassword(){
        $this->layout="mymemorial";
        $this->userLoginCheck();
        $id = $this->Session->read('user_id');
   
        $this->set("active","");
        $msgString='';

        $stateList = $this->State->stateList();
        $this->set("stateList",$stateList);

        if($this->data){
                       
			if(empty($this->data["User"]["password"])){
				$msgString .="- Password is required field.<br>";
			}

                        elseif(strlen($this->data["User"]["password"])<6){
				$msgString .="- Password must be at least 6 characters.<br>";
			}
                        if(empty($this->data["User"]["confirm_password"])){
				$msgString .="- Confirm Password is required field.<br>";
			}
                      

                        $password = $this->data["User"]["password"];
                        $conformpassword = $this->data["User"]["confirm_password"];

                        if($password!=$conformpassword)
                        {
                                  $msgString.= "- Password Mismatch";
                        }
                        if(isset($msgString) && $msgString!=''){
				$this->Session->write('message',$msgString);
			}
                        else
                            {
                            $this->data['User']['status'] = 1;
                            $this->data['User']['id'] = $id;

                            if($this->User->save($this->data)){

                                   $this->Session->write('message','Password Updated successfully.');
                                    $this->redirect('/users/my_account');
                            }
                        }


		   }

        elseif($id>0){
            $this->User->id = $id;
            $this->data =  $this->User->read();
            $this->data["User"]["old_email_address"] = $this->data["User"]["email_address"];
            $this->data['User']['confirm_password'] =  $this->data['User']['password'];
            $userName = $this->data['User']['user_name'];
            $this->set('userName',$userName);

        }
	}        

        function register_step1(){ //echo $this->Session->read('user_inserted_id');exit;
            $this->layout="client";
            //$this->userLoginCheck();
            $errorMessage = "";
            if($this->data){//echo "<pre>";pr($this->data);
                if(empty($this->data['User']['email_address'])){
                    $errorMessage .= "Please Enter Email.<br>";
                }elseif($this->data['User']['email_address']!=$this->data['User']['old_email']){
                    if(empty($this->data['User']['email_address'])){
                        $errorMessage .= "Please Enter Email.<br>";
                    }elseif($this->User->checkEmail($this->data['User']['email_address']) == false){
                        $errorMessage .= "Please Enter Valid Email.<br>";
                    }elseif($this->User->isRecordUniqueemail($this->data["User"]["email_address"]) == false){
                        $errorMessage .="Email already exists.<br>";
                    }
                }
                if(empty($this->data["User"]["password"])){
                    $errorMessage .="Password is required field.<br>";
                }
                if(empty($this->data["User"]["confirm_password"])){
                    $errorMessage .="Confirm Password is required field.<br>";
                }elseif($this->data["User"]["password"] != $this->data["User"]["confirm_password"]){
                    $errorMessage .="Password and Confirm Password doesn't match.<br>";
                }
                if(empty($this->data["User"]["first_name"])){
                    $errorMessage .="First Name is required field.<br>";
                }
                if(empty($this->data["User"]["last_name"])){
                    $errorMessage .="Last Name is required field.<br>";
                }
                if(empty($this->data["User"]["year"]) || empty($this->data["User"]["month"]) || empty($this->data["User"]["day"])){
                    $errorMessage .="Month,Day or Year for Date of Birth Required.<br>";
                }elseif((date('Y-m-d') < $this->data["User"]["year"]."-".$this->data["User"]["month"]."-".$this->data["User"]["day"]) ? true : false){
                    $errorMessage .="Choose Valid Date.<br>";
                }
                if(empty($this->data["User"]["gender"])){
                    $errorMessage .="Gender is Required.<br>";
                }
                $this->data['User']['phone'] = $this->data['User']['phone1']."-".$this->data['User']['phone2']."-".$this->data['User']['phone3'];
                if(empty($this->data['User']['phone1']) || empty($this->data['User']['phone2']) || empty($this->data['User']['phone3'])){
                    $errorMessage .= "Phone Number is Required Field.<br>";
                }elseif(preg_match("/^[0-9]{10}$/", $this->data['User']['phone1'].$this->data['User']['phone2'].$this->data['User']['phone3']) === 0){
                    $errorMessage .= "Phone Number Should be Numeric and 10 digit.<br>";
                }               
//                $this->data['User']['alt_phone'] = $this->data['User']['alt_phone1']."-".$this->data['User']['alt_phone2']."-".$this->data['User']['alt_phone3'];
//                if(preg_match("/^[0-9]{10}$/", $this->data['User']['alt_phone1'].$this->data['User']['alt_phone2'].$this->data['User']['alt_phone3']) === 0){
//                    $errorMessage .= "Alternate Phone Number Should be Numeric and 10 digit.<br>";
//                }

                if($errorMessage!="" && isset($errorMessage)){
                    $this->Session->write("message",$errorMessage);
                }else{
                    $this->data["User"]["allergies"] = implode(",",$this->data["User"]["allergies"]);
                    $this->data['User']['date_of_birth'] = $this->data['User']['year']."-".$this->data['User']['month']."-".$this->data['User']['day'];
                    $this->data['User']['phone'] = $this->data['User']['phone1']."-".$this->data['User']['phone2']."-".$this->data['User']['phone3'];
                    $this->data['User']['alt_phone'] = $this->data['User']['alt_phone1']."-".$this->data['User']['alt_phone2']."-".$this->data['User']['alt_phone3'];
                    if($this->Session->check('user_inserted_id')){
                        $this->data['User']['id'] = $this->Session->read('user_inserted_id');
                    }
                    //echo "<pre>";pr($this->data);
                    $this->User->save($this->data);
                    $this->Session->write('user_inserted_id',$this->User->id);
                    $this->Session->write();
                    $this->redirect('/users/register_step2');
                }


            }elseif($this->Session->check('user_inserted_id')){
                    $this->User->id = $this->Session->read('user_inserted_id');
                    $this->data =  $this->User->read();
                    $this->data['User']['old_email'] = $this->data['User']['email_address'];
                    $this->data['User']['confirm_password'] = $this->data['User']['password'];
                    $this->data['User']['allergies'] = explode(",",$this->data['User']['allergies']);
                    $dateArray = explode("-",$this->data['User']['date_of_birth']);
                    $this->data['User']['year'] = $dateArray[0];
                    $this->data['User']['month'] = $dateArray[1];
                    $this->data['User']['day'] = $dateArray[2];
                    $phoneArray = explode("-",$this->data["User"]["phone"]);
                    $this->data["User"]["phone1"] = $phoneArray[0];
                    $this->data["User"]["phone2"] = $phoneArray[1];
                    $this->data["User"]["phone3"] = $phoneArray[2];
                    $altphoneArray = explode("-",$this->data["User"]["alt_phone"]);
                    $this->data["User"]["alt_phone1"] = $altphoneArray[0];
                    $this->data["User"]["alt_phone2"] = $altphoneArray[1];
                    $this->data["User"]["alt_phone3"] = $altphoneArray[2];

            }
        }
        function register_step2(){
            $this->layout="client";
            //$this->userLoginCheck();
            $errorMessage = "";
            $stateList = $this->State->stateList();
            $this->set("stateList",$stateList); 
            if($this->data){                
                if(empty($this->data['User']['address'])){
                    $errorMessage .= "Address is Required Field.<br>";
                }
                if(empty($this->data['User']['city'])){
                    $errorMessage .= "City is Required Field.<br>";
                }
                if(empty($this->data['User']['state'])){
                    $errorMessage .= "State is Required Field.<br>";
                }
                if(empty($this->data['User']['zip'])){
                    $errorMessage .= "Zip is Required Field.<br>";
                }
                if(empty($this->data['User']['billing_person_name'])){
                    $errorMessage .= "Full Name is Required Field.<br>";
                }
                if(empty($this->data['User']['card_number'])){
                    $errorMessage .= "Card Number is Required Field.<br>";
//                }elseif(preg_match("/^[0-9]{15,}$/", $this->data['User']['card_number']) === 0){
//                    $errorMessage .= "Card Number Should be Numeric and 15 or 16 digit.<br>";
//                }
                }else{
                        $returnMsg  =   $this->User->validateCC($this->data['User']['card_number'],$this->data['User']['card_type']);
                        if(isset($returnMsg) && $returnMsg != ""){
                            $errorMessage .= $returnMsg;
                        }
                }
                if(empty($this->data['User']['card_number_cvv'])){
                    $errorMessage .= "Card's CVV Code is Required Field.<br>";
                }elseif(preg_match("/^[0-9]{3,}$/", $this->data['User']['card_number_cvv']) === 0){
                    $errorMessage .= "Card's CVV Code Should be Numeric and 3 or 4 digit.<br>";
                }

                $padDateMonth = str_pad($this->data["User"]["expiration_card_month"], 2, '0', STR_PAD_LEFT);
                if(empty($this->data["User"]["expiration_card_year"]) || empty($this->data["User"]["expiration_card_month"])){
                    $errorMessage .="Card Expiration Month or Year Required.<br>";
                }elseif((date('Y-m') > $this->data["User"]["expiration_card_year"]."-".$padDateMonth) ? true : false){
                    $errorMessage .="Choose Valid Expiration Date.<br>";
                }
                if(empty($this->data['User']['billing_address'])){
                    $errorMessage .= "Billing Address is Required Field.<br>";
                }
                if(empty($this->data['User']['billing_city'])){
                    $errorMessage .= "Billing City is Required Field.<br>";
                }
                if(empty($this->data['User']['billing_state'])){
                    $errorMessage .= "Billing State is Required Field.<br>";
                }
                if(empty($this->data['User']['billing_zip'])){
                    $errorMessage .= "Billing Zip is Required Field.<br>";
                }

                if($errorMessage!="" && isset($errorMessage)){
                    $this->Session->write("message",$errorMessage);
                }else{
                    if($this->Session->check('user_inserted_id')){
                        $this->data['User']['id'] = $this->Session->read('user_inserted_id');
                    }
                    //$this->data['User']['id'] = $this->Session->read('user_inserted_id');
                    $this->User->save($this->data);                    
                    $this->redirect('/users/register_step3');
                }
            }elseif($this->Session->check('user_inserted_id')){
                    $this->User->id = $this->Session->read('user_inserted_id');
                    $this->data =  $this->User->read();
            }
        }
        function register_step3(){
            $this->layout="client";
            //$this->userLoginCheck();
            //$this->Session->write('user_inserted_id','5');exit;
            $errorMessage = "";
             if($this->data){                 
                if(!$this->data['User']['confirm']){
                    $errorMessage .= "Please agree to our terms of service.<br>";
                }
                if($errorMessage!="" && isset($errorMessage)){
                    $this->Session->write("message",$errorMessage);
                }else{
                    $this->data['User']['id'] = $this->Session->read('user_inserted_id');
                    $this->User->save($this->data);
                    $sendEmail = $this->User->sendConfirmationEmail($this->data['User']['id']);                    
                    $this->redirect('/page/success');
                }
             }elseif($this->Session->check('user_inserted_id')){
                    $this->User->id = $this->Session->read('user_inserted_id');
                    $this->data =  $this->User->read();
            }
             
        }
        

        function account_step1(){ //echo $this->Session->read('user_inserted_id');exit;
            $this->layout="client";
            $this->userLoginCheck();
            $errorMessage = "";
            if($this->data){//echo "<pre>";pr($this->data);
                if(empty($this->data['User']['email_address'])){
                    $errorMessage .= "Please Enter Email.<br>";
                }elseif($this->data['User']['email_address']!=$this->data['User']['old_email']){
                    if(empty($this->data['User']['email_address'])){
                        $errorMessage .= "Please Enter Email.<br>";
                    }elseif($this->User->checkEmail($this->data['User']['email_address']) == false){
                        $errorMessage .= "Please Enter Valid Email.<br>";
                    }elseif($this->User->isRecordUniqueemail($this->data["User"]["email_address"]) == false){
                        $errorMessage .="Email already exists.<br>";
                    }
                }
                if(empty($this->data["User"]["password"])){
                    $errorMessage .="Password is required field.<br>";
                }
                if(empty($this->data["User"]["confirm_password"])){
                    $errorMessage .="Confirm Password is required field.<br>";
                }elseif($this->data["User"]["password"] != $this->data["User"]["confirm_password"]){
                    $errorMessage .="Password and Confirm Password doesn't match.<br>";
                }
                if(empty($this->data["User"]["first_name"])){
                    $errorMessage .="First Name is required field.<br>";
                }
                if(empty($this->data["User"]["last_name"])){
                    $errorMessage .="Last Name is required field.<br>";
                }
                if(empty($this->data["User"]["year"]) || empty($this->data["User"]["month"]) || empty($this->data["User"]["day"])){
                    $errorMessage .="Month,Day or Year for Date of Birth Required.<br>";
                }elseif((date('Y-m-d') < $this->data["User"]["year"]."-".$this->data["User"]["month"]."-".$this->data["User"]["day"]) ? true : false){
                    $errorMessage .="Choose Valid Date.<br>";
                }
                if(empty($this->data["User"]["gender"])){
                    $errorMessage .="Gender is Required.<br>";
                }
                $this->data['User']['phone'] = $this->data['User']['phone1']."-".$this->data['User']['phone2']."-".$this->data['User']['phone3'];
                if(empty($this->data['User']['phone1']) || empty($this->data['User']['phone2']) || empty($this->data['User']['phone3'])){
                    $errorMessage .= "Phone Number is Required Field.<br>";
                }elseif(preg_match("/^[0-9]{10}$/", $this->data['User']['phone1'].$this->data['User']['phone2'].$this->data['User']['phone3']) === 0){
                    $errorMessage .= "Phone Number Should be Numeric and 10 digit.<br>";
                }
//                $this->data['User']['alt_phone'] = $this->data['User']['alt_phone1']."-".$this->data['User']['alt_phone2']."-".$this->data['User']['alt_phone3'];
//                if(preg_match("/^[0-9]{10}$/", $this->data['User']['alt_phone1'].$this->data['User']['alt_phone2'].$this->data['User']['alt_phone3']) === 0){
//                    $errorMessage .= "Alternate Phone Number Should be Numeric and 10 digit.<br>";
//                }

                if($errorMessage!="" && isset($errorMessage)){
                    $this->Session->write("message",$errorMessage);
                }else{
                    $this->data["User"]["allergies"] = implode(",",$this->data["User"]["allergies"]);
                    $this->data['User']['date_of_birth'] = $this->data['User']['year']."-".$this->data['User']['month']."-".$this->data['User']['day'];
                    $this->data['User']['phone'] = $this->data['User']['phone1']."-".$this->data['User']['phone2']."-".$this->data['User']['phone3'];
                    $this->data['User']['alt_phone'] = $this->data['User']['alt_phone1']."-".$this->data['User']['alt_phone2']."-".$this->data['User']['alt_phone3'];
                    if($this->Session->check('user_inserted_id')){
                        $this->data['User']['id'] = $this->Session->read('user_inserted_id');
                    }
                    //echo "<pre>";pr($this->data);
                    $this->User->save($this->data);
                    $this->Session->write('user_inserted_id',$this->User->id);
                    $this->Session->write();
                    $this->Session->write("message",'Your details saved successfully.');
                    //$this->redirect('/users/register_step2');
                }


            }elseif($this->Session->check('user_inserted_id')){
                    $this->User->id = $this->Session->read('user_inserted_id');
                    $this->data =  $this->User->read();
                    $this->data['User']['old_email'] = $this->data['User']['email_address'];
                    $this->data['User']['confirm_password'] = $this->data['User']['password'];
                    $this->data['User']['allergies'] = explode(",",$this->data['User']['allergies']);
                    $dateArray = explode("-",$this->data['User']['date_of_birth']);
                    $this->data['User']['year'] = $dateArray[0];
                    $this->data['User']['month'] = $dateArray[1];
                    $this->data['User']['day'] = $dateArray[2];
                    $phoneArray = explode("-",$this->data["User"]["phone"]);
                    $this->data["User"]["phone1"] = $phoneArray[0];
                    $this->data["User"]["phone2"] = $phoneArray[1];
                    $this->data["User"]["phone3"] = $phoneArray[2];
                    $altphoneArray = explode("-",$this->data["User"]["alt_phone"]);
                    $this->data["User"]["alt_phone1"] = $altphoneArray[0];
                    $this->data["User"]["alt_phone2"] = $altphoneArray[1];
                    $this->data["User"]["alt_phone3"] = $altphoneArray[2];

            }
        }
        function account_step2(){
            $this->layout="client";
            $this->userLoginCheck();
            $errorMessage = "";
            $stateList = $this->State->stateList();
            $this->set("stateList",$stateList);
            if($this->data){
                if(empty($this->data['User']['address'])){
                    $errorMessage .= "Address is Required Field.<br>";
                }
                if(empty($this->data['User']['city'])){
                    $errorMessage .= "City is Required Field.<br>";
                }
                if(empty($this->data['User']['state'])){
                    $errorMessage .= "State is Required Field.<br>";
                }
                if(empty($this->data['User']['zip'])){
                    $errorMessage .= "Zip is Required Field.<br>";
                }
                if(empty($this->data['User']['billing_person_name'])){
                    $errorMessage .= "Full Name is Required Field.<br>";
                }
                if(empty($this->data['User']['card_number'])){
                    $errorMessage .= "Card Number is Required Field.<br>";
//                }elseif(preg_match("/^[0-9]{15,}$/", $this->data['User']['card_number']) === 0){
//                    $errorMessage .= "Card Number Should be Numeric and 15 or 16 digit.<br>";
//                }
                }else{
                        $returnMsg  =   $this->User->validateCC($this->data['User']['card_number'],$this->data['User']['card_type']);
                        if(isset($returnMsg) && $returnMsg != ""){
                            $errorMessage .= $returnMsg;
                        }
                }
                if(empty($this->data['User']['card_number_cvv'])){
                    $errorMessage .= "Card's CVV Code is Required Field.<br>";
                }elseif(preg_match("/^[0-9]{3,}$/", $this->data['User']['card_number_cvv']) === 0){
                    $errorMessage .= "Card's CVV Code Should be Numeric and 3 or 4 digit.<br>";
                }

                $padDateMonth = str_pad($this->data["User"]["expiration_card_month"], 2, '0', STR_PAD_LEFT);
                if(empty($this->data["User"]["expiration_card_year"]) || empty($this->data["User"]["expiration_card_month"])){
                    $errorMessage .="Card Expiration Month or Year Required.<br>";
                }elseif((date('Y-m') > $this->data["User"]["expiration_card_year"]."-".$padDateMonth) ? true : false){
                    $errorMessage .="Choose Valid Expiration Date.<br>";
                }
                if(empty($this->data['User']['billing_address'])){
                    $errorMessage .= "Billing Address is Required Field.<br>";
                }
                if(empty($this->data['User']['billing_city'])){
                    $errorMessage .= "Billing City is Required Field.<br>";
                }
                if(empty($this->data['User']['billing_state'])){
                    $errorMessage .= "Billing State is Required Field.<br>";
                }
                if(empty($this->data['User']['billing_zip'])){
                    $errorMessage .= "Billing Zip is Required Field.<br>";
                }

                if($errorMessage!="" && isset($errorMessage)){
                    $this->Session->write("message",$errorMessage);
                }else{
                    if($this->Session->check('user_inserted_id')){
                        $this->data['User']['id'] = $this->Session->read('user_inserted_id');
                    }
                    //$this->data['User']['id'] = $this->Session->read('user_inserted_id');
                    $this->User->save($this->data);
                    $this->Session->write("message",'Your details saved successfully.');
                    //$this->redirect('/users/register_step3');
                }
            }elseif($this->Session->check('user_inserted_id')){
                    $this->User->id = $this->Session->read('user_inserted_id');
                    $this->data =  $this->User->read();
            }
        }
        function account_step3(){
            $this->layout="client";
            $this->userLoginCheck();
            //$this->Session->write('user_inserted_id','5');exit;
            $errorMessage = "";
             if($this->data){
                if(!$this->data['User']['confirm']){
                    $errorMessage .= "Please Confirm your Status.<br>";
                }
                if($errorMessage!="" && isset($errorMessage)){
                    $this->Session->write("message",$errorMessage);
                }else{
                    $this->data['User']['id'] = $this->Session->read('user_inserted_id');
                    $this->User->save($this->data);
                    $this->Session->write("message",'Your details saved successfully.');
                    //$sendEmail = $this->User->sendConfirmationEmail($this->data['User']['id']);
                    //$this->redirect('/page/success');
                }
             }elseif($this->Session->check('user_inserted_id')){
                    $this->User->id = $this->Session->read('user_inserted_id');
                    $this->data =  $this->User->read();
            }

        }


        function registrationConfirm($time,$userid,$useridsha1){
            if(sha1($userid)==$useridsha1){
                $this->data['User']['id'] = $userid;
                $this->data['User']['status'] = '1';
                $this->User->save($this->data);
                $this->Session->write('message',"Your account is validated, Please login with your email and password");
                $this->redirect('/');
            }
        }
        function tell_friend(){
            $this->layout = "client_inner";
            $this->userLoginCheck();
            $errorMessage = "";
            global $default_discount;
            //echo '<pre>';print_r($this->data);exit;

            if($this->data){
                if($this->data['Reference']['email_address']==""){
                    $errorMessage = "- Please Enter at least one email.";
                }else{
                    $this->data['Reference']['email_address'] = rtrim($this->data['Reference']['email_address'],",");
                    $emails = explode(",",$this->data['Reference']['email_address']);
                    if(count($emails)>10){
                        $errorMessage = "- Please Enter only Maximum 10 emails at a time.";
                    }else{
                        $flag = 0;
                        foreach($emails as $email){
                            if($this->User->checkEmail($email) == false){
                                $flag = 1;
                            }
                        }
                        if($flag == 1){
                            $errorMessage .= "Please Enter Valid Email or seperated by comma.<br>";
                            $flag = 0;
                        }
                    }
                }

                if($errorMessage!="" && isset($errorMessage)){
                    $this->Session->write("message",$errorMessage);
                }else{
                    
                    $tempEmails = $this->data['Reference']['email_address'];
                    $this->data['Reference']['user_id'] = $this->Session->read('user_id');
                    foreach($emails as $email){
                        $this->data['Reference']['email_address'] = $email;
                        $this->data['Reference']['coupon_code'] = $this->Reference->get_rand_id(8);
                        $this->data['Reference']['date_sent'] = date('Y-m-d h:i:s',time());
                        $this->Reference->save($this->data);
                        $this->data['Reference']['id'] = $this->Reference->id;

                        $this->User->query("UPDATE users SET coupon_code = '".$this->data['Reference']['coupon_code']."' WHERE id = '".$this->Session->read('user_id')."'");

                        $curdate = date('Y-m-d');
                        $expdate = date("Y-m-d", mktime(0, 0, 0, date("m")+1, date("d")-1, date("Y")));

                        //condition to check out whether coupon code is not duplicate
                                                

                        $this->data['CouponCode']['from_id'] = $this->data['Reference']['user_id'];
                        $this->data['CouponCode']['to_id'] = '';
                        $this->data['CouponCode']['coupon_code'] = $this->data['Reference']['coupon_code'];
                        $this->data['CouponCode']['discount_percentage'] = $default_discount;
                        $this->data['CouponCode']['start_date'] = $curdate;
                        $this->data['CouponCode']['expire_date'] = $expdate;
                        $this->data['CouponCode']['created'] = date('Y-m-d h:i:s',time());
                        $this->data['CouponCode']['coupon_used_status'] = 'Not Used';
                        $this->data['CouponCode']['status'] = '1';
                        $this->CouponCode->save($this->data);
                        $this->Reference->sendConfirmationEmail($this->data);
                        $this->CouponCode->id = '';
                        $this->data['Reference']['id'] = '';

                    }
                    $this->data['Reference']['email_address'] = $tempEmails;
                    $this->Session->write("message","Email has been sent successfully");
                    //$this->redirect('/users/register_step1');
                }
            }

        }

        function refferal($time,$userid,$useridsha1,$reguserid){
            $this->userLoginCheck();
            if(sha1($userid)==$useridsha1){

                $this->data['Reference']['link_confirmation'] = '1';
                $this->data['Reference']['id'] = $userid;
                //echo '<pre>';print_r($this->data);exit;
                $this->Reference->save($this->data);
                $this->Session->write('message',"Please get registered first.");
                $this->redirect('/users/register_step1');
            }
        }


        function order(){
            $this->layout="client_inner";
            $this->set('active',"order");
            //$this->userLoginCheck();

            $userid   =$this->Session->read("user_id");
            $paymentstatusinfo = $this->ReguserOrder->find("first",array("conditions"=>array("ReguserOrder.user_id = '".$this->Session->read('user_id')."'","ReguserOrder.payment_status='Confirm'","ReguserOrder.status='1'"),array('order'=>'ReguserOrder.id DESC')));
            $this->set("paymentstatusinfo",$paymentstatusinfo);

            $orderInfo = $this->OrdersSubscribedPlansUser->find("count",array("conditions"=>array("OrdersSubscribedPlansUser.plan_id = '".$paymentstatusinfo['ReguserOrder']['id']."'"),null));
            $this->set('orderInfo',$orderInfo);
            
        }
        
        
                    

                



}



?>
