<?php
/*
 * deepshikha jain
 */
class SubscriptionPlansController extends AppController {

	var $name = 'SubscriptionPlans';
	var $uses 	= array("LaundryProduct","LaundryProductimages","LaundryCategory","SubscriptionPlan","ReguserOrder");
	var $helpers 	= array('Html','Form','Javascript','Ajax','Time');
	var $paginate	= array('limit'=> '10', 'page' => '1', 'order'=>array('SubscriptionPlan.id'=>'desc'));
	var $components = array ('RequestHandler','Logincheck');
	var $layout='admin';

	function beforeFilter(){
                $loggedAdminId = $this->Session->read("adminid");
		if(isset($this->params['admin']) && $this->params['admin'] && !$loggedAdminId){
			$this->redirect("/admin/admins/login");
		}
	}

	function admin_index($created=null,$toDate=null){		
		$this->layout="admin";
	//	$this->set("expand_menu_links","testimonial");
		$condition=array();
		$separator=array();
		$urlSeparator=array();
                
		$urlSeparator=implode("/",$urlSeparator);

		$this->set('separator',$separator);
		$this->set('urlSeparator',$urlSeparator);

                    if(isset($this->data['SubscriptionPlan']['action'])){
				$idList=$this->data['SubscriptionPlan']['idList'];
				if($idList){
					if($this->data['SubscriptionPlan']['action']=="activate"){
						$cnd=array("SubscriptionPlan.id IN ($idList) ");
						$this->SubscriptionPlan->updateAll(array('SubscriptionPlan.status' =>"'1'"),$cnd);
					}elseif($this->data['SubscriptionPlan']['action']=="deactivate"){
						$cnd=array("SubscriptionPlan.id IN ($idList) ");
						$this->SubscriptionPlan->updateAll(array('SubscriptionPlan.status' =>"'0'"),$cnd);
					}elseif($this->data['SubscriptionPlan']['action']=="delete"){
						$cnd=array("SubscriptionPlan.id IN ($idList) ");
						$this->SubscriptionPlan->deleteAll($cnd);
					}
				}
			}

		//$transactiondetail = $this->User->find("all",array("conditions"=>"Transaction.status = 1"));		
        $this->set('subscriptions', $this->paginate('SubscriptionPlan',$condition));
		if($this->RequestHandler->isAjax()) {
			$this->layout='';
			$this->viewPath = 'elements'.DS.'admin/subscription_plans/';
			$this->render('index');
		}		
	}// end of function index

        function admin_addsubscriptions() {
			$this->layout="admin";
			$msgString='';
			$conditions=array();


		if($this->data){


                        if(empty($this->data["SubscriptionPlan"]["plan_name"])){
                            $msgString .="- Subscription Plan name is required field.<br>";
                        }

			if(empty($this->data["SubscriptionPlan"]["plan_charge"])){
				$msgString .="- Subscription Charge is required field.<br>";
			}

                        if(empty($this->data["SubscriptionPlan"]["minimum_usage_per_bag"])){
				$msgString .="- Minimum Usage per Bag is required field.<br>";
			}

//			if(empty($this->data["SubscriptionPlan"]["plan_validity"])){
//				$msgString .="- Subscription Validity is required field.<br>";
//			}


			if(isset($msgString) && $msgString!=''){
				$this->Session->write('message',$msgString);
			}
                        else
                            {
                            $this->data['SubscriptionPlan']['status'] = 1;
                            $this->data["SubscriptionPlan"]["plan_validity"] = '30';
                            if($this->SubscriptionPlan->save($this->data)){


                                    $this->Session->write('message','Subscription details saved successfully');
                                    $this->redirect('/admin/subscription_plans/index');
                            }
                        }

		   }

   }

        function admin_deletesubscriptions($id=NULL){
		if($id>0){
			$this->Transaction->delete($id);
			$this->viewPath = 'elements'.DS.'admin';
                        $this->Session->write('message','Subscription details deleted successfully.');
			$this->render('blank_delete');
			$this->redirect('/admin/subscription_plans/index');
		}
	}//end of admin_deleteUser

	function admin_deactivatesubscriptions($id=NULL){
			if($id>0){
				$cnd=array("SubscriptionPlan.id = $id");
				$this->Transaction->updateAll(array('SubscriptionPlan.status' =>"'0'"),$cnd);
				$this->set('action','/admin/subscription_plans/activatesubscriptions/'.$id);
				$this->set('id',$id);
				$this->set('status',0);
				$this->viewPath = 'elements'.DS.'admin';
                                $this->Session->write('message','Subscription details Deactivated successfully.');
				$this->render('update_status');
				$this->redirect('/admin/subscription_plans/index');
			}

	}

        function admin_activatesubscriptions($id=NULL){
				if($id>0){
					$cnd=array("SubscriptionPlan.id = $id");
					$this->Transaction->updateAll(array('SubscriptionPlan.status' =>"'1'"),$cnd);
					$this->set('action','/admin/subscription_plans/deactivatesubscriptions/'.$id);
					$this->set('id',$id);
					$this->set('status',1);
					$this->viewPath = 'elements'.DS.'admin';
                                        $this->Session->write('message','Subscription details Activated successfully.');
					$this->render('update_status');
					$this->redirect('/admin/subscription_plans/index');
				}
			}//end of admin_activateCustomer

	function admin_editsubscriptions($id=NULL){

		$this->layout="admin";
		$msgString='';
		$conditions=array();

		if($this->data){
 
			//echo "<pre>";print_r($this->data);exit;	
		
                        if(empty($this->data["SubscriptionPlan"]["plan_name"])){
                            $msgString .="- Subscription plan name is required field.<br>";
                        }

			if(empty($this->data["SubscriptionPlan"]["plan_charge"])){
				$msgString .="- Subscription charge is required field.<br>";
			}

                        if(empty($this->data["SubscriptionPlan"]["total_usage"])){
				$msgString .="- Total usage is required field.<br>";
			}

			if($this->data["SubscriptionPlan"]["hidplan"]=='N')
			{
				if(empty($this->data["SubscriptionPlan"]["minimum_usage_per_bag"])){
					$msgString .="- Minimum Usage per Bag is required field.<br>";
				}
			}

			if($this->data["SubscriptionPlan"]["hidplan"]!='N')
			{
				if(empty($this->data["SubscriptionPlan"]["start_date"]) || empty($this->data["SubscriptionPlan"]["end_date"]))
				{
				    $msgString .="- Start Date or End Date is required field.<br>";
				}
				$start_time=strtotime($this->data["SubscriptionPlan"]["start_date"]);
				$end_time=strtotime($this->data["SubscriptionPlan"]["end_date"]);
				
				if($end_time <= $start_time)
				{
					$msgString .="- End Date should be greater than Start Date .<br>";
				}
				
			}

			if(isset($msgString) && $msgString!=''){
				
			//	echo "one";exit;
					$this->Session->write('message',$msgString);
			}
			else{
				//echo "two";exit;
				//echo "<pre>";print_r($this->data);exit;
				if($this->data["SubscriptionPlan"]["hidplan"]=='A')
				{
					$this->data["SubscriptionPlan"]["plan_validity"] = '182';
				}else if($this->data["SubscriptionPlan"]["hidplan"] == 'S')
				{
					$this->data["SubscriptionPlan"]["plan_validity"] = '91';
				}else{
					$this->data["SubscriptionPlan"]["plan_validity"] = '30';	
				}
                                
                                $this->SubscriptionPlan->save($this->data);

				if($this->data["SubscriptionPlan"]["hidplan"]!='N')
				{
					$start_date=date('Y-m-d',strtotime($this->data["SubscriptionPlan"]["start_date"]));
					$end_date=date('Y-m-d',strtotime($this->data["SubscriptionPlan"]["end_date"]));
					$p_type=$this->data["SubscriptionPlan"]["hidplan"];
					
					$start_time=strtotime($this->data["SubscriptionPlan"]["start_date"]);
				        $end_time=strtotime($this->data["SubscriptionPlan"]["end_date"]);
					
					$query_update = "UPDATE subscription_plans SET start_date='".$start_date."',end_date='".$end_date."' WHERE plan_type = '".$p_type."'";
					mysql_query($query_update) or die(mysql_error());
				}
				
                                $this->Session->write('message','Subscription details updated successfully.');
                                $this->redirect('/admin/subscription_plans/index');
                            }
			  }
			  else{
                                $this->SubscriptionPlan->id = $id;
                                $this->data = $this->SubscriptionPlan->read();
                          }
		} //end function admin_edittestimonials($id=NULL)

                function transactions(){
			$this->layout="client_inner";
			$transactiondetail = $this->Transaction->find("all",array("conditions"=>"Transaction.status = 1"));
			//echo '<pre>';print_r($testimonialdetail);exit;
			$this->set('transactiondetail',$transactiondetail);
		} //end function testimonials()

        
                /* This function is called after selecting plan for subscription plan*/
                function index($selected_plan = null){
                    $this->layout = "client_inner";
                    $this->userLoginCheck();
                    $this->set('selected_plan',$selected_plan);
                }

                function plans(){
                    $this->layout = "client_inner";
                    $this->userLoginCheck();

                    $plandetailsmallbag = $this->SubscriptionPlan->find("all",array("conditions"=> array("SubscriptionPlan.status = '1'", "SubscriptionPlan.id "=> array(1,2,3,4))));
                    $this->set('plandetailsmallbag',$plandetailsmallbag);

                } //end function plans()


                function upgradeplans(){
                    $this->layout = "client_inner";
                    $this->userLoginCheck();

                    $plandetailsmallbag = $this->SubscriptionPlan->find("all",array("conditions"=>"SubscriptionPlan.status = '1'"));
                    $this->set('plandetailsmallbag',$plandetailsmallbag);
                }


}// end of Class
?>