<?php
date_default_timezone_set("America/Los_Angeles");
/**
 * Requests collector.
 *
 *  This file collects requests if:
 *	- no mod_rewrite is avilable or .htaccess files are not supported
 *  - requires App.baseUrl to be uncommented in app/config/core.php
 *	- app/webroot is not set as a document root.
 *
 * PHP versions 4 and 5
 *
 * CakePHP(tm) : Rapid Development Framework (http://cakephp.org)
 * Copyright 2005-2010, Cake Software Foundation, Inc. (http://cakefoundation.org)
 *
 * Licensed under The MIT License
 * Redistributions of files must retain the above copyright notice.
 *
 * @copyright     Copyright 2005-2010, Cake Software Foundation, Inc. (http://cakefoundation.org)
 * @link          http://cakephp.org CakePHP(tm) Project
 * @package       cake
 * @since         CakePHP(tm) v 0.2.9
 * @license       MIT License (http://www.opensource.org/licenses/mit-license.php)
 */
/**
 *  Get Cake's root directory
 */
	define('APP_DIR', 'app');
	define('DS', DIRECTORY_SEPARATOR);
	define('ROOT', dirname(__FILE__));
	define('WEBROOT_DIR', 'webroot');
	define('WWW_ROOT', ROOT . DS . APP_DIR . DS . WEBROOT_DIR . DS);
/**
 * This only needs to be changed if the "cake" directory is located
 * outside of the distributed structure.
 * Full path to the directory containing "cake". Do not add trailing directory separator
 */
	if (!defined('CAKE_CORE_INCLUDE_PATH')) {
		define('CAKE_CORE_INCLUDE_PATH', ROOT);
	}

/**
 * Set the include path or define app and core path
 */
	if (function_exists('ini_set')) {
		ini_set('include_path',
			ini_get('include_path') . PATH_SEPARATOR . CAKE_CORE_INCLUDE_PATH
			. PATH_SEPARATOR . ROOT . DS . APP_DIR . DS
		);
		define('APP_PATH', null);
		define('CORE_PATH', null);
	} else {
		define('APP_PATH', ROOT . DS . APP_DIR . DS);
		define('CORE_PATH', CAKE_CORE_INCLUDE_PATH . DS);
	}
	require APP_DIR . DS . WEBROOT_DIR . DS . 'index.php';
en Source Matters, Inc. All rights reserved.

 * @license		GNU General Public License version 2 or later; see LICENSE.txt

 */

// Set flag that this is a parent file.

define('_JEXEC', 1);

define('DS', DIRECTORY_SEPARATOR);

if (file_exists(dirname(__FILE__) . '/defines.php')) {

	include_once dirname(__FILE__) . '/defines.php';

}

if (!defined('_JDEFINES')) {

	define('JPATH_BASE', dirname(__FILE__));

	require_once JPATH_BASE.'/includes/defines.php';

}

require_once JPATH_BASE.'/includes/framework.php';

// Mark afterLoad in the profiler.

JDEBUG ? $_PROFILER->mark('afterLoad') : null;

// Instantiate the application.

$app = JFactory::getApplication('site');

// Initialise the application.

$app->initialise();

// Mark afterIntialise in the profiler.

JDEBUG ? $_PROFILER->mark('afterInitialise') : null;

// Route the application.

$app->route();

// Mark afterRoute in the profiler.

JDEBUG ? $_PROFILER->mark('afterRoute') : null;

// Dispatch the application.

$app->dispatch();

// Mark afterDispatch in the profiler.

JDEBUG ? $_PROFILER->mark('afterDispatch') : null;

// Render the application.

$app->render();

// Mark afterRender in the profiler.

JDEBUG ? $_PROFILER->mark('afterRender') : null;

// Return the response.

echo $app;

}

?>